Skin-Client

Tools for Progress

Skin-Client Desktop 3.1

Welcome to the Skin-Client Desktop for Web-Applications documentation.

The Skin-Client offers a convenient and flexible way to create a rich user interface in a distributed and changing environment. And all that with the power of the Progress OpenEdge 4GL/ABL. It allows you to do zero footprint deployment of your application and enables you to deliver it to any client that is capable of running Java or HTML5 on the desktop: Windows, MacOS, Linux, Unix. It's the thinnest client possible: a skin to your application.

Skin-Client Desktop enables you to build desktop applications for different operating systems (Windows, Linux, Apple) just using OpenEdge ABL. The Skin-Client generic client part is either Java application or Javascript/HTML5 based web application connected to the ABL server part either through a socket or htttp(s) connection. It is completly server driven by procedures and/or classes written in OpenEdge ABL.The OpenEdge backend sends commands to the generic Skin-Client client part. The client renders the forms and sends back user events.

  • Skin-Client Basics
  • Skin-Client API
  • Skin-Client Widgets
  • Skin-Client Events
  • Skin-Client Broker
  • Release history

© IAP GmbH 2005-2017


Structure of a Skin-Client program

Basic Topics

This chapter discusses basic Skin-Client topics.

  • Operation Modes
  • Using Skin-Client Desktop
  • Structure of a Skin-Client program
  • Logging/Debugging
  • Migration
  • Deployment


Basic Topics

Starting the Skin-Client

There are three basic operation modes. For more details see chapter Operation Modes.

Required environment

Server:

  • Progress OpenEdge 10.1A or higher has to be installed.

Client (Java):

  • Java 6 (1.6) or higher has to be installed. You can test your Java version by typing
    java -version

    in the command line (if it is in the path)
  • You can download the newest version of Java from
    http://java.com/de/download/index.jsp (as of January, 27th 2008).

Client (HTML5):

  • Recent HTML5 capable Webbrowser

Starting the application in direct mode

To start the application in direct mode a "normal" .pf-file could be used. Start-up parameters might be specified with icfparam argument in the .pf-file.

icfparam example:

-icfparam sport=2220,eport=2230,logfile=sc/log/myagent.log,loglevel=DEBUG,splash=icons/t4p_logo.jpg
Parameter | Description
sport
eport 		Start port and end port. The agent uses the first free port in port range for communication for client communication. If end port is not specified only the start port will be used. Default start port is 12345
logfile | Output file used for agent and client logging. If no logfile is given, logging will be disabled.
loglevel | Log level, allowed values are DEBUG, INFO, WARNING and ERROR. Default value is INFO.
splash | Optional parameter that specifies splash screen image (jpg, gif or png). If given, the image will be displayed on start-up.
mode | Optional parameter that specifies whether the java frontend should be executed as java application or applet. Allowed values are application and applet, default is application.
jvm | Optional parameter that specifies which java runtime should be used. Default for Windows systems is java.exe, for Unix like systems java. If mode is set to applet, jvm should point to the browser executable the applet should be executed in. In this case default for Windows systems is the systems default browser, for Unix like systems firefox.
webdir | Optional parameter pointing to the root directory for the applet mode

Starting the application in broker mode.

The broker mode is the preferred mode in local area network environments. The Skin-Client broker and your Progress application run on a centralized server, while the clients are only running the Skin-Client frontend. Of course your Progress application can make use of all the features Progress gives you for further distributing your application. You can use the Progress AppServer as well as dedicated database server, etc.

The Skin-Client broker mode is also a central element of the World Wide Web mode.

First you need to setup and start the Skin-Client broker (see Install Broker for details.)

Starting the Skin-Client frontend as application.

The Java archive sc.jar has to be in the current directory, Java has to be in the path. Under windows you can also use a .lnk file on the desktop to define proper working directories and parameters. (Have a look a the links and menu entries for the demo application).

usage:

  java -jar sc.jar host port -broker
Parameter | Description
host | Hostname or IP address of the computer where the broker is running.
port | Portnumber to connect the running broker.

Starting the frontend as Java applet

With a HTML page the Skin-Client frontend can be started as an applet in the webbrowser. An applet-tag has to be inserted into the HTML body.

HTML example:

<html>
<body>
<applet
    code="de.iap.skin.PApplet.class"
    archive="sc.jar"
    height="485"
    width="800">
   <param name="host" value="localhost"/>
   <param name="port" value="12345"/>
   <param name="broker" value="true"/>
   <param name="splash" value="img/t4p_logo.jpg"/>
</applet>
</body>
</html>
Parameter | Description
width
height 		The size of the applet in pixels.
host | Hostname or IP address of the computer where the broker is running.
port | Portnumber to connect the running broker.
splash | Optional parameter that specifies splash screen image (jpg, gif or png). The image will be displayed on start-up.

The broker has to be running before Skin-Client applets will be started.

Starting the application in world wide web mode (Java)

To use the Skin-Client in the www mode the application must be setup for the broker mode, i.e. the Skin-Client broker has to be configured. In addition a webserver must be setup to run the Skin-Client www mode java-servlet.

Starting the Skin-client frontend as application

The Java archive sc.jar has to be in the current directory and a Skin-Client webserver has to be accessible. Java has to be in the path. Under windows you can also use a .lnk file on the desktop to define proper working directories and parameters. (Have a look a the links and menu entries for the demo application).

For Windows OS there is provided a generic nativ application starter (see client/windows/localhost@sc-desktop.exe). You may customize it by replacing localhost by the hostname of your application and sc-desktop by the path part of your application URL.

usage:

   java -jar sc.jar url
or
   javaw -jar sc.jar url
or
   localhost@sc-desktop.exe (Windows only)

Parameter | Description
url | The URL of the Skin-Client webserver. The value begins with http:// or https://

To automate the deployment of this configuration you can build the WebApp with support for Java WebStart (Zero footprint installation)

Starting the frontend as Java applet

HTML example:

<HTML>
  <HEAD>
    <META NAME="keywords" CONTENT="SC,Skin-Client,SkinClient,Java,Applet,Progress,IAP">
    <META HTTP-EQUIV="pragma" CONTENT="no-cache">
    <META HTTP-EQUIV="expires" CONTENT="0">
    <META HTTP-EQUIV="cache-control" CONTENT="no-cache">
    <TITLE>SC-APPLET</TITLE>
    <SCRIPT type="text/javascript" src="sc/sclib.js"></SCRIPT>
  </HEAD>
  <BODY>
    <APPLET CODE="de.iap.skin.PApplet.class"
            ARCHIVE="sc/sc.jar" ID="scapplet" ALT="scapplet"
            NAME="skinclient" ALIGN="MIDDLE" WIDTH="100%" HEIGHT="100%"
            STYLE="position:absolute; left:0px; top:0px; width:100%; height:100%">
      <PARAM NAME="name" VALUE="skinclient">
      <PARAM NAME="cache_archive" VALUE="sc.jar">
      <PARAM NAME="servlet" VALUE="/webdemo/sc.p">
      <PARAM NAME="splash" VALUE="img/wait.gif">
    </APPLET>
  </BODY>
</HTML>
Parameter | Description
width
height 		The size of the applet in pixels.
servlet | Specifies the location of the servlet on the webserver. Usually the value is "sc.p".
splash | Optional parameter that specifies splash screen image (jpg, gif or png). The image will be displayed on start-up.

Please Note: The placeholders are case sensitive!

Starting the application in world wide web mode (HTML5)

To use the Skin-Client in the www mode the application must be setup for the broker mode, i.e. the Skin-Client broker has to be configured. In addition a webserver must be setup to run the Skin-Client www mode java-servlet.

Starting the frontend as HTML5 webpage

HTML example:

<!DOCTYPE html>
<html>
  <head>
    <meta content="text/html; charset=UTF-8" http-equiv="content-type">
    <link rel="shortcut icon" type="image/x-icon" href="./img/sch5.ico">
    <link rel="icon" type="image/x-icon" href="./img/sch5.ico">
    <title>SC HTML5</title>
    <meta name="keywords" content="SC,Skin-Client,SkinClient,HTML,HTML5,JavaScript,JS,Java,Applet,Progress,IAP">
    <meta http-equiv="pragma" content="no-cache">
    <meta http-equiv="expires" content="0">
    <meta http-equiv="cache-control" content="no-cache">
    <link rel="stylesheet" type="text/css" href="sc/schtml5.css">
  </head>
  <body>
    <div id="wrapper" tabindex="1"></div>
    <script type="text/javascript">
      SkinClientInfo = {};

      SkinClientInfo.sUrl = '/sc-desktop/sc.p';
      SkinClientInfo.sMainContainerID = 'wrapper';
      SkinClientInfo.sParam = '';

    </script>
    <script data-main="sc/schtml5" src="sc/require.js"></script>
  </body>
</html>
Parameter | Description
sMainContainerId | div tag to hook in Skin-Client widgets
sLoc
         Specifies the loc
sParam | Optional parameters provided to ABL


Basic Topics

Structure of a Skin-Client program

Initialize Skin-Client

Preparing the usage of Skin-Client functionality you need to add following code fragments to yout ABL code.

SC:initSession().

This method call starts the Skin-Client controller library (scCtrl.p) persistently, if not started yet.

Create Widget

Creating a widget using the Skin-Client resembles creating dynamic widgets in the 4GL/ABL.

Example: creating a button.

 oButton = NEW M-BUTTON(THIS-PROCEDURE).
 oButton:LABEL = "Click Me!".
 oButton:PARENT = oFrame.
 oButton:CHOOSE:subscribe("btchoose").

Attributes/Methods

Accessing and setting attributes of created widget is done by using properties and methods of Skin-Client objects.

oApp:SHOW-MESSAGE-DIALOG(cMsg ,oApp:ENVIRONMENT,"").

Events

Event handling in Skin-Client enabled application is done

attaching a procedure file to the widget object and defining an internal callback procedure to be executed.

oButton = NEW M-BUTTON(THIS-PROCEDURE).
oButton:CHOOSE:subscribe("btchoose").

PROCEDURE btchoose:
  DEFINE INPUT PARAMETER oArgs AS CLASS SC-ARGS NO-UNDO.
END PROCEDURE.

or attaching an object reference to the widget object and defining a callback method to be executed.

oButton = NEW M-BUTTON(THIS-OBJECT).
oButton:CHOOSE:subscribe("btchoose").

METHOD PUBLIC VOID btchoose (oArgs AS CLASS SC-ARGS):
END METHOD.

or attaching a class reference (name) to the widget object and defining a static callback method to be executed.

DEFINE PROTECTED STATIC PROPERTY THIS-CLASS AS CHARACTER NO-UNDO INIT "my.classname" GET.

oButton = NEW M-BUTTON(THIS-CLASS).
oButton:CHOOSE:subscribe("btchoose").

METHOD PUBLIC STATIC VOID btchoose (oArgs AS CLASS SC-ARGS):
END METHOD.

Container & Layout

Skin-Client Desktop uses pixel-layout (like OpenEdge ABL) supported by a client side anchors handling.

Wait-For

To wait for and dispatch events the Skin-Client uses a "Wait-for" replacement:

SC:waitForGoon().

To release this "wait-for" there as a "go on" method

SC:applyGoon().

Quit

Closing the Skin-Client there is a "QUIT" replacement..

SC:quitSession().


Basic Topics

Logging/Debuging

Settings

Progess object controller (scCtrl.p), Progess agent / application and Java client share the same output log file. You can set the log level and the log file name in the broker.properties file or using the icfparams, depending on the operation mode.

Log Levels

Log Level | Description
MSGPR | Like DEBUG, displays ERROR messages additionally using a Progress message box
MSGSC | Like DEBUG, displays ERROR messages additionally using a Skin-Client message box
DEBUG | Logs debug-, info-, warning- and error-messages. scCtrl.p writes DEBUG messages to provide information about its input and output.
INFO | Logs infos, warnigs and errors.
WARNING | Logs warnings and errors.
ERROR | Logs only errors. scCtrl.p writes ERROR messages if the application tries to access unknown widgets, objects, attributes or methods.

Direct Mode

In the direct mode the log level and the output file can be specified in the Progress start-up file (.pf) with icfparam.

icfparam example:

-icfparam sport=2224,logfile=sc/log/myagent.log,loglevel=DEBUG

Local Network And World Wide Mode

Log level and the log file can be specified in the scBroker.properties file. See chapter Edit Properties for more information.

Example Output

25/09/06 09:03:49 [DEBUG  ] <00003820> IN: >,257,LEFT-MOUSE-CLICK,Y=279,X=63;
25/09/06 09:03:49 [DEBUG  ] <00003820> RETURN: >257LEFT-MOUSE-CLICKY=279X=63 [sc_Decode(">257LEFT-MOUSE-CLICKY=279X=63")]
25/09/06 09:03:49 [DEBUG  ] <00003820> OUT: |

A line in the log file consists of date, time, loglevel, agent process ID and log message.

In this case, the log level was set to "DEBUG", so we get a verbose output about the systems actions: The message beginning with "IN:" shows the message the object controller has received from the java frontend. "OUT:" shows the output sent to the Skin-Client frontend. The API functions write messages beginning with "RETURN:" followed by the return value. The function name and the parameter list are appended in square brackets.

25/09/06 09:11:33 [DEBUG  ] <00001652> JAVA: set 1.VISIBLE = YES

If the object controller receives a log message from the Skin-Client frontend, it writes the message into the log file, as well. The object controller begins the message with "JAVA:". In the example the Skin-Client frontend informs that it is currently setting value of the attribute VISIBLE to YES for the object with the id "1". (The id 1 is reserved for the skin-client main object, other id's can be looked up in prior log entries, if the log level is high enough.)

Own Log Messages

Log statements can be included in the application program code to create a central logfile. Message text and condition could be provided:

PUBLISH "SC_LOG_DEBUG" ("My own debug message.", TRUE).
PUBLISH "SC_LOG_INFO" ("My own info message.", TRUE).
PUBLISH "SC_LOG_WARNING" ("My own warning message.", TRUE).
PUBLISH "SC_LOG_ERROR" ("My own error message.", TRUE).

Skin-Client Runtime Information

The frontend is able to provide runtime information that may be helpful for performance tuning. To get the information set this SKIN-CLIENT's "CLIENT-LOGGING" attribute and create a SKIN-CLIENT-RT-INFO object


Basic Topics

Deployment

OpenEdge server part (ABL)

Copy either the server/t4p.pl or the content server/t4p subdirectory to your ABL project.

Skin-Client Brokermanager & Broker

Deploy and adjust the Skin-Client brokermanager and broker in the broker\ subdirectory.
The broker.properties file needs to be adjusted.

Skin-Client Servlet (WebApp)

Deploy and adjust the servlet in tomcat\webapps\sc-desktop to your Tomcat environment.
The web.xml file needs to be adjusted (broker host/port).

Skin-Client client part (Browser-Application)

Copy / adjust provided sample html and jsp files from tomcat/webapps/sc-destop.

Skin-Client client part (Application)

Copy / adjust provided sample calls from start menu.


Skin-Client API

SC class

Static base class for the Skin-Client session. It allows you to initialize (start) and stop Skin-Client communication.

hLib attribute

Procedure handle pointing to the Skin-Client controller library (scCtrlp.p).

Data type: | Handle
Access: | Readable

oSession attribute

Reference to the base object, either a M-APP (mobile application) or SKIN-CLIENT (desktop) reference.

Data type: | Progress.Lang.Object
Access: | Readable

initSession method

Initializes Skin-Client communication. Starts Skin-Client controller library (scCtrl.p).

Syntax:
SC:initSession().

initSession method

Initializes Skin-Client communication. Starts Skin-Client controller library (scCtrl.p).

Syntax:
SC:initSession("sc/scCtrl.p").

Param | Data type | Description
ctrl_p | string | Propath aware name of the Skin-Client controller library file.

waitForGoon method

Sends (outstanding) commands to Skin-Client, waits for commands from Skin-Client, replaces ABL WAIT-FOR statement.

Syntax:
SC:waitForGoon().

applyGoon method

Ends (unlocks) waitforgoon wait state.

Syntax:
SC:applyGoon().

quitSession method

Terminate Skin-Client session. Replaces ABL QUIT statement.

Syntax:
SC:quitSession().

deleteByScope method

Delete all Skin-client widgets scoped to (defined by) an object.

Syntax:
SC:deleteByScope().

Param | Data type | Description
oClass | Progress.Lang.Object | Object reference Skin-Client widget objects are scoped to.


SC class

Skin-Client API

SC-EVENT class

Helper class for handling events of Skin-Client widgets. Event attributes of widget objects reference SC-EVENT objects.

subscribe methods

Attach a procedure file to the widget object and defining an internal callback procedure to be executed
or attach an object reference to the widget object and defining a callback method to be executed
or attach a class reference (name) to the widget object and defining a static callback method to be executed.

Syntax:
oButton:CHOOSE:subscribe("btchoose").
oButton:CHOOSE:subscribe("btchoose", THIS-PROCEDURE).
oButton:CHOOSE:subscribe("btchoose", THIS-OBJECT).
oButton:CHOOSE:subscribe("btchoose", THIS-CLASS).

Param | Data type | Description
name | string | procedure/method to be executed
scope [optional, defaults to scope of widget object] | / string / handle / object reference | scope class, object. procedure

unsubscribe methods

Detach a procedure file and and its internal callback procedure from the widget object event to be executed
or detach an object reference and its callback method from the widget object event to be executed
or detach a class reference (name) and its static callback method from the widget object event to be executed.

Syntax:
oButton:CHOOSE:subscribe().
oButton:CHOOSE:subscribe(THIS-PROCEDURE).
oButton:CHOOSE:subscribe(THIS-OBJECT).
oButton:CHOOSE:subscribe(THIS-CLASS).

Param | Data type | Description
scope [optional, defaults to scope of widget object] | / string / handle / object reference | scope class, object. procedure


Skin-Client API

SC-CONST class

Static helper class for handling attributes just allowing distinct values of a value-set.

LOG-LEVEL

ERROR
WARNING
INFO
DEBUG
ALL

Syntax:
oClass:LOG-LEVEL = SC-CONST:LOG-LEVEL-ALL.

MNEMONIC

UNDEFINED | No mnemonic key defined.
A | A key
B | B key
C | C key
D | D key
E | E key
F | F key
G | G key
H | H key
I | I key
J | J key
K | K key
L | L key
M | M key
N | N key
O | O key
P | P key
Q | Q key
R | R key
S | S key
T | T key
U | U key
V | V key
W | W key
X | X key
Y | Y key
Z | Z key
0 | 0 key
1 | 1 key
2 | 2 key
3 | 3 key
4 | 4 key
5 | 5 key
6 | 6 key
7 | 7 key
8 | 8 key
9 | 9 key

Syntax:
oClass:MNEMONIC = SC-CONST:MNEMONIC-9.

MODIFIER

UNDEFINED | No modifier key defined.
SHIFT | Shift key
CTRL | Ctrl key
ALT | Alt key
ALT-GRAPH | Alt key
META | Meta key
LEFT-MOUSE | Left mouse button
MIDDLE-MOUSE | Middle mouse button
RIGHT-MOUSE | Right mouse button

Syntax:
oClass:MODIFIER = SC-CONST:MODIFIER-RIGHT-MOUSE.

ACCELERATOR

UNDEFINED | No accelerator key defined.
A |
B |
C |
D |
E |
F |
G |
H |
I |
J |
K |
L |
M |
N |
O |
P |
Q |
R |
S |
T |
U |
V |
W |
X |
Y |
Z |
0 |
1 |
2 |
3 |
4 |
5 |
6 |
7 |
8 |
9 |
ENTER |
ESC |
CTRL |
ALT |
ALT-GR |
TAB |
SPACE |
DEL |
F1 |
F2 |
F3 |
F4 |
F5 |
F6 |
F7 |
F8 |
F9 |
F10 |
F11 |
F12 |
LEFT |
RIGHT |
END |
UP |
DOWN |
PAGE-DOWN |
PAGE-UP |
PAUSE |
PASTE |

Syntax:
oClass:ACCELERATOR = SC-CONST:ACCELERATOR-PASTE.

HORIZONTAL-POS

RIGHT | Right position in an area.
LEFT | Left position in an area.
CENTER | The central position in an area.
LEADING | Identifies the leading edge of text for use with left-to-right and right-to-left languages.
TRAILING | Identifies the trailing edge of text for use with left-to-right and right-to-left languages.

Syntax:
oClass:HORIZONTAL-POS = SC-CONST:HORIZONTAL-POS-TRAILING.

VERTICAL-POS

TOP
CENTER
BOTTOM

Syntax:
oClass:VERTICAL-POS = SC-CONST:VERTICAL-POS-BOTTOM.

DATA-TYPE

LOGICAL | Allows tree values: TRUE (alias YES), FALSE (alias NO) and unknown value (\?).
CHARACTER | Any string.
NUMERIC | Alias for DECIMAL.
INTEGER | Integer numbers.
DECIMAL | Decimal numbers.
DATE | Year, month and day.
DATETIME | Year, month, day, hours, minutes, esconds and milliseconds.
BLOB | Binary data

Syntax:
oClass:DATA-TYPE = SC-CONST:DATA-TYPE-BLOB.

DEFAULT-COLORS

P-FRAME_FG
P-FRAME_BG
P-BUTTON_FG
P-BUTTON_BG
P-BROWSE_FG
P-COMBO-BOX_FG
P-COMBO-BOX_BG
P-EDITOR_BG
P-EDITOR_FG
P-EDITOR_CARET
P-FILL-IN_BG
P-FILL-IN_CARET
P-FILL-IN_FG
P-PROGRESS-BAR_BG
P-PROGRESS-BAR_FG
P-SELECTION-LIST_BG
P-SELECTION-LIST_FG
P-SPLIT-PANE_BG
P-TABBED-PANE_BG
P-TABBED-PANE_FG
P-TEXT_BG
P-TEXT_FG
P-TOGGLE-BOX_BG
P-TOGGLE-BOX_FG
P-TREE_BG
P-TREE_FG

Syntax:
oClass:DEFAULT-COLORS = SC-CONST:DEFAULT-COLORS-P-TREE_FG.

DEFAULT-FONTS

P-BUTTON | Default button font.
P-TOGGLE-BOX | Default toggle-box font.
P-COMBO-BOX | Default combo-box font.
P-FILL-IN | Default fill-in font.
P-EDITOR | Default editor font.
P-TEXT | Default text font.
P-SELECTION-LIST | Default selection-list font.
P-PROGRESS-BAR | Default progress-bar font.
P-RADIO-SET | Default radio-button font.
P-BROWSE | Default browse font.
P-TREE | Default tree font.
P-TABBED-PANE | Default font for tabs.
P-MENU-ITEM | Default menu item font.
P-TOGGLE-BOX-MENU-ITEM | Default toggle-box menu item font.
P-MENU | Default menu bar font.

Syntax:
oClass:DEFAULT-FONTS = SC-CONST:DEFAULT-FONTS-P-MENU.

MESSAGE-TYPE

PLAIN | Don't display a icon.
ERROR | Error message icon.
INFO | Information icon.
WARNING | Warning icon.
QUESTION | Question icon.

Syntax:
oClass:MESSAGE-TYPE = SC-CONST:MESSAGE-TYPE-QUESTION.

CURSOR-TYPE

DEFAULT | Default mouse cursor.
CROSSHAIR | Crosshair mouse cursor.
TEXT | Text mouse cursor.
WAIT | Wait mouse cursor (hourglass).
SW-RESIZE | South-west window resize mouse cursor.
SE-RESIZE | South-east window resize mouse cursor.
NW-RESIZE | North-west window resize mouse cursor.
NE-RESIZE | North-east window resize mouse cursor.
N-RESIZE | North window resize mouse cursor.
S-RESIZE | South window resize mouse cursor.
W-RESIZE | West window resize mouse cursor.
E-RESIZE | East window resize mouse cursor.
HAND | Hand mouse cursor.
MOVE | Move mouse cursor.

Syntax:
oClass:CURSOR-TYPE = SC-CONST:CURSOR-TYPE-MOVE.

DND-ACTIONS

COPY | A constant value representing a 'copy' action to be performed by a Drag and Drop operation.
MOVE | A constant value representing a 'move' action to be performed by a Drag and Drop operation.
LINK | A constant value representing a 'link' action to be performed by a Drag and Drop operation.

Syntax:
oClass:DND-ACTIONS = SC-CONST:DND-ACTIONS-LINK.

DND-ACTION

COPY | A constant value representing a 'copy' action to be performed by a Drag and Drop operation. The user can select 'copy' drop action by pressing 'Ctrl' modifier key during the drag operation
MOVE | A constant value representing a 'move' action to be performed by a Drag and Drop operation. The user can select 'move' drop action by pressing 'Shift' modifier key during the drag operation
LINK | A constant value representing a 'link' action to be performed by a Drag and Drop operation. The user can select 'link' drop action by pressing 'Ctrl' + 'Shift' modifier keys during the drag operation

Syntax:
oClass:DND-ACTION = SC-CONST:DND-ACTION-LINK.

DND-FLAVORS

FILES | Allow to transfer a file names via DnD
STRING | Allow to transfer a string via DnD

Syntax:
oClass:DND-FLAVORS = SC-CONST:DND-FLAVORS-STRING.

DND-FLAVOR

FILES | Allow to transfer a file names via DnD
STRING | Allow to transfer a string via DnD

Syntax:
oClass:DND-FLAVOR = SC-CONST:DND-FLAVOR-STRING.

SUBTYPE

DROP-DOWN | Editable combo-box subtype
DROP-DOWN-LIST | Simple drop-down combo-box subtype

Syntax:
oClass:SUBTYPE = SC-CONST:SUBTYPE-DROP-DOWN-LIST.

TABLESUBTYPE

DEFAULT | The normal COLs x ROWs grid.
LASTCOL-AS-ROW | This renders the last column of a row in line of it own, if a value is set.

Syntax:
oClass:TABLESUBTYPE = SC-CONST:TABLESUBTYPE-LASTCOL-AS-ROW.

PAGE-ORIENTATION

PORTRAIT
LANDSCAPE

Syntax:
oClass:PAGE-ORIENTATION = SC-CONST:PAGE-ORIENTATION-LANDSCAPE.

BROWSE-AUTO-RESIZE-MODE

OFF | Does not adjust column widths automatically
ALL-COLUMNS | During all resize operations, proportionately resize all columns
LAST-COLUMN | During all resize operations, apply adjustments to the last column only
NEXT-COLUMN | When a column is adjusted in the UI, adjust the next column the opposite way

Syntax:
oClass:BROWSE-AUTO-RESIZE-MODE = SC-CONST:BROWSE-AUTO-RESIZE-MODE-NEXT-COLUMN.

LAYOUT-ANCHORS

NONE | No anchor
LEFT | Anchor to the left border of the parent container
TOP | Anchor to the top border of the parent container
RIGHT | Anchor to the right border of the parent container
BOTTOM | Anchor to the bottom border of the parent container
FILLED | Completly fills the parent container

Syntax:
oClass:LAYOUT-ANCHORS = SC-CONST:LAYOUT-ANCHORS-FILLED.

DOCK-GROUP-TYPE

TABFOLDER | Group is represented by a tabfolder
HORIZONTAL-SPLIT | Group is represented by a horizontal splitter
VERTICAL-SPLIT | Group is represented by a vertical splitter

Syntax:
oClass:DOCK-GROUP-TYPE = SC-CONST:DOCK-GROUP-TYPE-VERTICAL-SPLIT.

DOCK-HIDE-POSITION

NORTH | Frame gets hidden to the north
SOUTH | Frame gets hidden to the south
WEST | Frame gets hidden to the west
EAST | Frame gets hidden to the east

Syntax:
oClass:DOCK-HIDE-POSITION = SC-CONST:DOCK-HIDE-POSITION-EAST.

DOCK-POSITION

NORTH | Frame gets docked to the north
SOUTH | Frame gets docked to the south
WEST | Frame gets docked to the west
EAST | Frame gets docked to the east
TAB | Frame gets docked as tabfolder

Syntax:
oClass:DOCK-POSITION = SC-CONST:DOCK-POSITION-TAB.

MODIFIERS

SHIFT | Shift key
CTRL | Ctrl key
ALT | Alt key
ALT-GRAPH | Alt key
META | Meta key
LEFT-MOUSE | Left mouse button
MIDDLE-MOUSE | Middle mouse button
RIGHT-MOUSE | Right mouse button

Syntax:
oClass:MODIFIERS = SC-CONST:MODIFIERS-RIGHT-MOUSE.

STATE

NONE
UP
DOWN

Syntax:
oClass:STATE = SC-CONST:STATE-DOWN.

ENVIRONMENT

JAVA-APPLICATION
JAVA-APPLET
JAVA-ECLIPSE

Syntax:
oClass:ENVIRONMENT = SC-CONST:ENVIRONMENT-JAVA-ECLIPSE.

WINDOWS-SYSTEM

OTHER
MS-WINXP
MS-WINDOWS
MS-WIN95

Syntax:
oClass:WINDOWS-SYSTEM = SC-CONST:WINDOWS-SYSTEM-MS-WIN95.

CLIENT-LOGGING

NONE | Disable client logging. This value can't combined with other values.
RESPONSE-TIME | Time in milliseconds between a command and Skin-Client's answer.
EXECUTION-TIME | Time in milliseconds a command takes.
COMMANDS | Command processed by the Skin-Client.
MESSAGES | Message transmitted to the server.
NUM-OF-WAITING-CMDS | Number of commands that are received but not processed (command queue length).
NUM-OF-WAITING-EVENTS | Number of not transmitted events (event queue lenght).
NUM-OF-OBJS | Number of objects that were created but are not disposed yet.
ALL | Enable all message types. This value can't combined with other values.

Syntax:
oClass:CLIENT-LOGGING = SC-CONST:CLIENT-LOGGING-ALL.

SHOW-MESSAGE-DIALOG

OK

Syntax:
oClass:SHOW-MESSAGE-DIALOG = SC-CONST:SHOW-MESSAGE-DIALOG-OK.

OPTION-TYPE

YES-NO
OK-CANCEL
YES-NO-CANCEL

Syntax:
oClass:OPTION-TYPE = SC-CONST:OPTION-TYPE-YES-NO-CANCEL.

SHOW-CONFIRM-DIALOG

YES-OK | User has selected yes/or option.
NO | User has selected no option.
CANCEL | User has selected cancel option.
CLOSED | User has closed the dialog.

Syntax:
oClass:SHOW-CONFIRM-DIALOG = SC-CONST:SHOW-CONFIRM-DIALOG-CLOSED.

STYLE

PLAIN | No PLAIN and no ITALIC.
BOLD | Bold font style.
ITALIC | Italic font style.

Syntax:
oClass:STYLE = SC-CONST:STYLE-ITALIC.

MENU-TYPE

SUB-MENU
POPUP-MENU
MENU-BAR

Syntax:
oClass:MENU-TYPE = SC-CONST:MENU-TYPE-MENU-BAR.

WINDOW-STATE

NORMAL | Window is neither ICONIFIED nor MAXIMIZED.
ICONIFIED | Window is iconified.
MAXIMIZED | Window is maximized.

Syntax:
oClass:WINDOW-STATE = SC-CONST:WINDOW-STATE-MAXIMIZED.

TABFOLDER-LAYOUT

WRAP-TAB-LAYOUT | Tabs are divided in multible runs.
SCROLL-TAB-LAYOUT | All tabs will be in a single run (scrollable).

Syntax:
oClass:TABFOLDER-LAYOUT = SC-CONST:TABFOLDER-LAYOUT-SCROLL-TAB-LAYOUT.

TAB-PLACEMENT

TOP | Tabs are shown on widget's top.
BOTTOM | Tabs are shown on widget's bottom.
LEFT | Tabs are shown on widget's left.
RIGHT | Tabs are shown on widget's right.

Syntax:
oClass:TAB-PLACEMENT = SC-CONST:TAB-PLACEMENT-RIGHT.

ORIENTATION

VERTICAL | FIRST widget is above and SECOND widget is below.
HORIZONTAL | FIRST widget is left and SECOND widget is right.

Syntax:
oClass:ORIENTATION = SC-CONST:ORIENTATION-HORIZONTAL.

HEADER-ALIGNMENT

LEFT
CENTER
RIGHT

Syntax:
oClass:HEADER-ALIGNMENT = SC-CONST:HEADER-ALIGNMENT-RIGHT.

DISPLAY-TYPE

FILL-IN
COMBO-BOX
TOGGLE-BOX
IMAGE
LOOKUP

Syntax:
oClass:DISPLAY-TYPE = SC-CONST:DISPLAY-TYPE-LOOKUP.

ARROW-DIRECTION

NONE
UP
DOWN

Syntax:
oClass:ARROW-DIRECTION = SC-CONST:ARROW-DIRECTION-DOWN.

SCALE

STRETCH-TO-FIT | Forces the image to expand or contract to fit within the image widget's boundaries.
RETAIN-SHAPE | Indicates that the image should retain its aspect ratio (expand or contract equally in both dimensions).
NO-SCALE | Indicates that the image should retain its size.

Syntax:
oClass:SCALE = SC-CONST:SCALE-NO-SCALE.

LAYOUT-ORIENTATION

VERTICAL
VERTICAL-WRAP
HORIZONTAL-WRAP

Syntax:
oClass:LAYOUT-ORIENTATION = SC-CONST:LAYOUT-ORIENTATION-HORIZONTAL-WRAP.

CONTENT-TYPE

PLAIN | Unformatted text of any length.
HTML | Enables HTML 3.2 support.
RTF | Enables limited support of the Rich Text Format.

Syntax:
oClass:CONTENT-TYPE = SC-CONST:CONTENT-TYPE-RTF.

CONTENT-TYPE-RICH

HTML | Enables HTML 3.2 support.
RTF | Enables limited support of the Rich Text Format.

Syntax:
oClass:CONTENT-TYPE-RICH = SC-CONST:CONTENT-TYPE-RICH-RTF.

FONT-STYLE

BOLD
ITALIC
UNDERLINE

Syntax:
oClass:FONT-STYLE = SC-CONST:FONT-STYLE-UNDERLINE.

FONT-ALIGN

LEFT
CENTER
RIGHT

Syntax:
oClass:FONT-ALIGN = SC-CONST:FONT-ALIGN-RIGHT.

DATE-PICKER-SUBTYPE

SIMPLE | Simple date-picker subtype
DROP-DOWN | Drop-Down date-picker subtype
BUTTONLESS | Buttonless date-picker subtype

Syntax:
oClass:DATE-PICKER-SUBTYPE = SC-CONST:DATE-PICKER-SUBTYPE-BUTTONLESS.

TOOLBAR-ORIENTATION

HORIZONTAL
VERTICAL

Syntax:
oClass:TOOLBAR-ORIENTATION = SC-CONST:TOOLBAR-ORIENTATION-VERTICAL.

PROGRESS-BAR-ORIENTATION

HORIZONTAL
VERTICAL

Syntax:
oClass:PROGRESS-BAR-ORIENTATION = SC-CONST:PROGRESS-BAR-ORIENTATION-VERTICAL.

ROW-RESIZE-MODE

FIXED-ROW-HEIGHT
FIXED-VISIBLE-ROW-COUNT

Syntax:
oClass:ROW-RESIZE-MODE = SC-CONST:ROW-RESIZE-MODE-FIXED-VISIBLE-ROW-COUNT.

COL-RESIZE-MODE

FIXED-COL-WIDTH
FIXED-VISIBLE-COL-COUNT

Syntax:
oClass:COL-RESIZE-MODE = SC-CONST:COL-RESIZE-MODE-FIXED-VISIBLE-COL-COUNT.

MOVE-PERMISSION

COL-ONLY
ROW-ONLY
BOTH
NONE

Syntax:
oClass:MOVE-PERMISSION = SC-CONST:MOVE-PERMISSION-NONE.

RESIZE-PERMISSION

WIDTH-ONLY
HEIGHT-ONLY
BOTH
NONE

Syntax:
oClass:RESIZE-PERMISSION = SC-CONST:RESIZE-PERMISSION-NONE.

BAND-ITEM-SIZE

SMALL
LARGE
IMAGE-ONLY

Syntax:
oClass:BAND-ITEM-SIZE = SC-CONST:BAND-ITEM-SIZE-IMAGE-ONLY.


SC class

Skin-Client API

SC-ARGS class

Class for the arguments provided as input parameter for Skin-Client callback procedures and methods.

oEventSource attribute

SC-OBJECT object reference of the Skin-Client widget that fired the event (like ABL "SELF handle").

Syntax:
SC-ARGS:oEventSource:NAME.

cVal method

Character value of argument identifield by key.

Syntax:
SC-ARGS:cVal("MESSAGE").

Param | Data type | Description
key | string | identifying key of the argument.

iVal method

Integer value of argument identifield by key.

Syntax:
SC-ARGS:iVal("VELOCITY").

Param | Data type | Description
key | string | identifying key of the argument.

fVal method

Decimal value of argument identifield by key.

Syntax:
SC-ARGS:fVal("LATITUDE").

Param | Data type | Description
key | string | identifying key of the argument.

dVal method

Date value of argument identifield by key.

Syntax:
SC-ARGS:dVal("DATE").

Param | Data type | Description
key | string | identifying key of the argument.

dtVal method

Datetime value of argument identifield by key.

Syntax:
SC-ARGS:dtVal("TIMESTAMP").

Param | Data type | Description
key | string | identifying key of the argument.

lVal method

Logical value of argument identifield by key.

Syntax:
SC-ARGS:lVal("ISTRUE").

Param | Data type | Description
key | string | identifying key of the argument.


Skin-Client Broker

This chapter discusses Skin-Client Broker topics.

  • Operation Modes
  • Administration Console
  • scBroker.properties


Skin-Client Broker

Operation Modes

Broker Manager - Broker - Administration Console

The Skin-Client Broker Manager manages Skin-Client Broker sessions.

The Skin-Client Broker manages Skin-Client sessions, connects Progress server and Java, HTML5 or App client session.

The Skin-client Adminstration Console allows (graphical) access to runtime and configuration properties of Broker Manager and Broker(s).

The scbroker.jar file contains the Broker Manager, Broker itself and the Administration Console.

Command line usage of scBroker.bat (Windows)

  • Start the Broker Manager directly in current console
 scBroker -start [broker-properties-file] [broker-name]
  • broker-properties-file: path to broker.properties to use
  • broker-name (optional): optional name of broker to start-up immediately
  • Install the Broker Manager as Windows service:
 scBroker -service -install [service-name] [broker-properties-file]
  • service-name: desired name of the new windows-service to install
  • broker-properties-file: path to broker.properties to use for the service
  • Uninstall the Broker Manager as Windows-service:
 scBroker -service -uninstall [service-name]
  • service-name: name of the windows-service to uninstall
  • Start the graphical Administration Console:
 scBroker -admin [hostname] [port] [[username] [password]]
  • hostname (optional): hostname or ip-address of the broker-manager
  • port (optionsl): TCP-port of the broker-manager console
  • username (optional): username to use for authentification
  • password (optional): password to use for authentification
  • Execute a command on the Broker Manager :
 scBroker -cmd [hostname] [port] [username] [password] [command] [param]
  • hostname : hostname or ip-address of the broker-manager
  • port : TCP-port of the broker-manager console
  • username : username to use for authentification
  • password : password to use for authentification
  • command : command to execute
  • param (optional): parameter for the command (if suitable for command)
  • available commands (and parameters):
  • start [broker-name]: starts the broker 'broker-name'
  • stop [broker-name]: stops the broker 'broker-name'
  • query [broker-name]: fetch the state of broker 'broker-name'
  • if broker-name is not specified,
  • a state-list of all known brokers is returned
  • reload-settings : reloads broker-settings-file
  • shutdown : stops all running brokers and the broker-manager

  • Set a user-password-combination for the Administation Console:
 scBroker -adduser [username] [password] [authentication-file]
  • username : username to set a password for
  • password : password to set for the user
  • authentication-file: path to authentication-file to use for storage

Advanced configuration (scbroker.jar)

This section escribes the command line usage of the scbroker.jar file and is meant for advanced users mainly to write their own startup-scripts.

Commandline usage with following arguments:

java -jar scbroker.jar <arguments>

Start Broker Manager

<arguments> = broker-settings-file [broker-name-1] [broker-name-2] ... [broker-name-N]
  • broker-settings-file: broker.properties to use
  • broker-name-X (optional) : name of broker to start, needs corresponding section in broker-settings-file
  java -jar scbroker.jar scBroker.properties

This sample starts the Broker Manager without starting any specific broker (unless specified in scBroker.properties).

  java -jar scbroker.jar scBroker.properties demo-broker1

This sample starts the Broker Manager and the broker demo-broker1 (ignoring auto-start setting in scBroker.properties).

    java -jar scbroker.jar scBroker.properties demo-broker1 demo-broker2

This sample starts the Broker Manager and the broker demo-broker1 and demo-broker2 (ignoring auto-start setting in scBroker.properties).

Start Administration Console

<arguments> = -gui -console [hostname] [port] [[username] [password]]
  • hostname (optional): hostname or ip-address of the Broker Manager
  • port (optionsl): TCP-port of the broker-manager console
  • username (optional): username to use for authentification
  • password (optional): password to use for authentification
  java -jar scbroker.jar -gui -console

This sample starts the Administration Console without specifying connection parameters.

  java -jar scbroker.jar -gui -console 192.168.100.100 12345
This sample starts the admin-console to connect to broker-manager at '192.168.100.100', listening on port '12345'.
  java -jar scbroker.jar -gui -console 192.168.100.100 12345 exampleuser examplepassword
This sample starts the admin-console to connect to broker-manager at '192.168.100.100', listening on port '12345' with user 'exampleuser' and password 'examplepassword'

Set User/Password for Administration Console

<arguments> = -adduser [username] [password] [auth-file]
  • username : username to use for authentification
  • password : password to use for authentification
  • auth-file: file used to store the information
  java -jar scbroker.jar -adduser exampleuser examplepassword mySecretUserAuth.file

This sample adds the user 'exampleuser' with password 'examplepassword' or sets the password of existing user 'exampleuser' to 'examplepassword' using the auth-file mySecretUserAuth.file

Convert SC 1.x scBroker.properties file

<arguments> = -convert-old-settings old-broker-settings-file
    • old-broker-settings-file: old broker.properties to convert
  java -jar scbroker.jar -convert-old-settings scBroker.properties

This sample converts the file 'scBroker.properties' to new format and backing up the original file as scBroker.properties.bak


Skin-Client Broker

Admistration Console

Start

You may start the graphical Administration Console using following command to connect to a running Skin-Client Broker Manager either locally or reotely by providing host and port information.

 scBroker -admin [hostname] [port] [[username] [password]]

Overview

In the initial view all managed Skin-Client Brokers and their status are displayed.

Broker Details

You may select a Broker entry from the treeview to display the broker details view of selected Broker. There you may get information on started, free and active Skin-Client agents of current broker.

You may Start/Stop the Broker and prestart and stop unused agents. Using button "Edit Configuration" you may update properties of current broker.

Edit Configuration

Within the "Edit Configuration" view you may edit the broker specific parts of the scBroker.properties (file) using a graphical interface.


scBroker.properties

Skin-Client Broker

scBroker.properties file

Broker Manager configuration (SCBROKER.GENERAL)

In the SCBROKER.GENERAL section some general settings for the Skin-Client Broker Manager are provided.

CONSOLE_LOG_FILE=D:\dev\SkinClientBroker\console-{yyyy}-{mm}-{dd}.log

absolute path to console-logfile

  • {yyyy} gets replaces by current year of console-startup
  • {mm} gets replaces by current month of console-startup
  • {dd} gets replaces by current day of console-startup
CONSOLE_PORT=12333

TCP-port opened and used by the console for remote-console-connections

CONNECT_TIMEOUT=30000

Timeperiod for clients to send the init packet (in milliseconds)

CONSOLE_OUTPUT=YES

indicates if broker-manager should print log-entries to console (YES/NO)

AUTH_FILE=

path to authentication-file this file contains user-password-combinations used to authenticate users. Leave it blank to deactivate authentication

AUTO_START=WEBDEMO2

comma-seperated list of brokers that get started on manager-startup

Broker Default configuration (SCBROKER.DEFAULT)

CONNECT_TIMEOUT=30000

timeperiod for clients or agents to send the initializer-message (in milliseconds)

BROKER_LOG_FILE=log/broker-{yyyy}-{mm}-{dd}.log

path to broker-logfile, if the path is not absolute it is interpreted being relative to the agents working directory

  • {yyyy} gets replaces by current year of broker-startup
  • {mm} gets replaces by current month of broker-startup
  • {dd} gets replaces by current day of broker-startup
BROKER_LOG_LEVEL=ERROR

loglevel for the broker. possible values in ascending order where each level always includes messages of lower levels:

  • ERROR - error messages
  • MESSAGE - general messagesDEBUG - debug messages
  • ULTRA-DEBUG - extended debug messages
    (WARNING: use ULTRA-DEBUG with caution, produces many log-entries)
BROKER_PORT=12000

TCP-port opened and used by the broker for all connections (from clients and agents)

CLIENT_INITIALIZER=scstart

initializer-message showing that we have a client connection

AGENT_INITIALIZER=agent

initializer-message showing that we have an agent connection

HEART_BEAT_INTERVAL=5000

interval used for sending heartbeats to agents (in milliseconds)

HEART_BEAT_TIMEOUT=30000

timeperiod for the agent to answer heartbeats (in milliseconds) if the agent fails to answer during this time, it is considered not responding anymore and its process gets killed.

NOTE: depending on your application this value should be high enough to allow longterm-activities like processing huge exports

WORKING_DIR=C:\My_Working_Directory

working directory used for agent runtime instances

AGENT_RUNTIME_BIN=C:\dlc\102a\bin\prowin32.exe

executable to use for starting up agents

STARTUP_FILE=my_startup.pf

progress pf-file used to startup agent runtimes

ADDITIONAL_ICF_PARAMS=

additional icf-parameters passed to the agent runtime on startup

ADDITIONAL_PARAMS=

additional parameters passed to the agent runtime on startup

AGENT_LOG_FILE=log/agent-{yyyy}-{mm}-{dd}.log

path to agent-logfile (relative to its working directory)

AGENT_LOG_LEVEL=ERROR

loglevel for agents. possible values in ascending order where each level always includes messages of lower levels:

  • SYSINFO
  • ERROR
  • WARNING
  • INFO
  • DEBUG
AGENT_PORTS_START=12001

first TCP-port in the port-range used by free agents to accept client connections.

AGENT_PORTS_END=12010

last TCP-port in the port-range used by free agents to accept client connections.

NOTE: every starting agent opens one TCP-port of this range (finding a free one to use on its own) and closes the port when it gets active (when a client connects to its port). So, you only need a port-range big enough to allow your desired number of free agents getting prestarted, not the total number of agents. But, keep in mind that initial agents are also free ones!

INITIAL_AGENTS=10

number of agents to start initially (when the broker starts and gets activated)

MIN_FREE_AGENTS=3

number of agents to keep prestarted and usable in the pool for new client-connections
NOTE: the broker will only start a new agent if the total number of allowed agents has not been reached yet.

MAX_AGENTS=100

total number of allowed agents (free and active)

AGENT_STARTUP_TIMEOUT=60000

timeperiod to wait for agents to startup before killing their process (in milliseconds)

AGENT_SHUTDOWN_TIMEOUT=60000

timeperiod to wait for agents to quit gracefully before killing their process (in milliseconds)

Broker configuration (SCBROKER.<BROKER-NAME>)

For each Broler there needs to be defined a section.
These properties may also be edited by the Admistration Console "Edit Configuration" view.

[EXAMPLE_BROKER]

BROKER_PORT=13060
WORKING_DIR=D:\dev\My_Example_App
AGENT_RUNTIME_BIN=D:\dlc\101c\bin\prowin32.exe
STARTUP_FILE=example.pf
ADDITIONAL_ICF_PARAMS=My_Icfkey=My_Icfvalue
ADDITIONAL_PARAMS=-param My_Additional_Parameter
AGENT_PORTS_START=13061
AGENT_PORTS_END=13065
INITIAL_AGENTS=3
MIN_FREE_AGENTS=2
MAX_AGENTS=50  .


SkinClient

Release History!

Skin-Client 3.1 / OF-1 3.4 - 15 May 17
  • "reconnect" and "resend current request" on connection failures (Java only)
  • added widgets P-BAND* ("ribbon"-like toolbar)
  • added widget P-GRID (P-Browse w/o query and direct cell access)
  • added widgets P-FLEX-TEXT (growing textwidget, html5 only)
  • added property P-RTF-EDITOR:CONTENT-TYPE (html/rtf)
  • added property P-APPLET:GET-STRING-WIDTH
  • added property SKIN-CLIENT:CONVERT-LOCATION
  • added events P-BROWSE-COLUMN:CELL-MOUSE-ENTERED and CELL-MOUSE-EXITED
  • debugger not showing "own" elements and "empty" types anylonger
  • numerous HTML5 client enhancements
  • ... bugfixes and feature implementation
    from customer feedback and daily project work...

Skin-Client 3.0 / OF-1 3.2 - 15 Jan 15

  • HTML5 Client
  • OOAPI using Skin-Client widgets
  • new installer / demo application
  • ... many bugfixes and feature implementation
    from customer feedback and daily project work...

Skin-Client 2.2 / OF-1 1.7 - 15 Apr 12

  • JavaScript Client (beta)
  • Java based broker
  • Java based management console
  • scheduler widget
  • anchor layout management
  • OO-ABL aware
  • support up to OE11
  • ... many bugfixes and feature implementation
    from customer feedback and daily project work...

Skin-Client 2.1 - 06 Sep 10

  • not released to public / part of OF-1

Skin-Client 2.0 - 23 Sep 09

  • not released to public / part of OF-1

Skin-Client 1.1.10 - 15 Apr 08

  • General Backend:
    • bugfix sync UNKNOWN (null) values
    • allow field order in setting initial field values
    • build process and ser-file-creation optimization
    • optimizations in communication interfacein (map names to int)
    • support for Progress 10.1B/C and Java 6
    • enhanced logging (new loglevel MSGPR MSGSC)
  • General GUI:
    • bugfix ToTop
    • bugfix changing back wait-cursor to default-cursor
    • bugfix some format-related problems
    • bugfix conversion from progress date mask to support 4-digits year-representation
    • added support for beep/bell as a skin-client method
    • added support for "unknown" colors
    • disabled system beep when the user enters invalid input
    • allow running multiple skin-clients (T4P-Plugin)
    • retrieve the current focus owner
    • WebDemo-Application bugfix and clean up
    • WebDemo-Application updatable browse demo
  • P-BROWSE
    • bugfix browse row height
    • bugfix event handling
    • remove NUM-COLUMNS attribute
    • allow multiple children (popup menu)
  • P-BROWSE-COLUMN
    • bugfix moving and resizing columns
    • bugfix hiding column
    • bugfix START-SEARCH
    • bugfix: disallow ? value in dsprow
    • new attribute "subtype" code for table ("lastcol-as-row")
    • allow multi line table headers ("!")
    • buffer-field attribute format label and data-type automatically set on create
    • set READ-ONLY, FGCOLOR, BGCOLOR and FONT per cell
  • P-COMBO-BOX
    • bugfix insensitive color
    • new attribute ListWidthPixels
    • new attribute SubType
    • added subtypes DROP-DOWN, DROP-DOWN-LIST
  • P-DATE-PICKER:
    • bugfix acknowledge "SENSITIVE=false"
    • changed colors of date-picker calendar
    • new attribute DatePicker "Subtype"
    • Fix Java 6 XP-style problem
  • P-DIALOG:
    • new attribute UPDATE-LOCKED
  • P-EDITOR:
    • bugfix for method "APPEND"
    • bugfix "long" file support
    • bugfix Default-Color
    • bugfix font handling in html mode
    • added attribute "BOX",
    • attribute "BGCOLOR" to support unknown colors in java 6
    • attribute EDITABLE replaced by READ-ONLY
    • looking / behaving more like Progress-Widgets
  • P-FILL-IN:
    • bugfix overwrite last character
    • bugfix passwordfield input-value sync
    • attribute EDITABLE replaced by READ-ONLY
    • looking / behaving more like Progress-Widgets
    • new attribute SET-HORIZONTAL-ALIGNMENT
  • J-FONT
    • bugfix display correct font size in Java 1.4 to 1.6
  • P-FRAME
    • bugfix scrollpane problems
    • bugfix repaint
    • new attribute UPDATE-LOCKED
  • P-RADIO-SET
    • bugfix mouse events MOUSE-ENTERED and MOUSE-EXITED
    • bugfix problems with alternative LookAndFeels
    • bugfix sensitive
  • P-Selection-List
    • bugfix input-value.
  • P-TABBED-PANE
    • bugfix attribute SELECTED and method removeTab
    • new event INNER-HEIGHT-CHANGED
    • new attribute INNER-HEIGHT
  • P-TABBED-PANE
    • bugfix "selected" attribute of tabfolders
    • bugfix frames scrollable
  • P-TREE-NODE
    • new attribute 'EXPANDED',can be used to expand / collapse the node or determine if it is expanded
  • P-WINDOW
    • new attribute UPDATE-LOCKED

Skin-Client 1.0.24 - 16 Nov 06

  • Skin-Client can started twice in the same JVM to the same time now
  • Skin-Client timeouts adjustable in Progress
  • P-BROWSE sorting optimized
  • Bugfixes for P-BROWSE and P-TREE
  • New P-TREE events: TREE-EXPAND and TREE-COLLAPSE
  • P-WINDOW and P-DIALOG have the same default background color like a P-FRAME now
  • Objects where parent isn't set will get the Skin-Client as parent. (Side effect: all objects are displayable in the object tree.)

Skin-Client 1.0.10 - 29 Sep 06

  • Widget bug fixes
  • Fill-In format bug fixed
  • Better logging/debugging and better error messages
  • Skin-Client provides runtime information for performance tuning
  • Better documentation (nicer design and more information)
  • Some attributes and events renamed to be modelled on Progess
  • Webbrowser crash problems fixed
  • All fill-in formats accepts unknown values
  • Configuration utility enables Java Webstart
  • More operation modes (Application/Applet/Socket/Http/Broker)
  • Simple RTF support for the editor added
  • Optional APPLY / NO-APPLY support for events

Skin-Client 1.0.00 (beta) - 22 Apr 06

  • Initial release


Skin-Client Widgets

General

Create Widget

Creating a widget using the Skin-Client resembles creating dynamic widgets in the 4GL/ABL.

Example: creating a button.

 oButton = NEW M-BUTTON(THIS-PROCEDURE).
 oButton:LABEL = "Click Me!".
 oButton:PARENT = oFrame.
 oButton:CHOOSE:subscribe("btchoose").

Attributes/Methods

Accessing and setting attributes of created widget is done by using properties and methods of Skin-Client objects.

oApp:SHOW-MESSAGE-DIALOG(cMsg ,oApp:ENVIRONMENT,"").


Basic Topics

Operation Modes

Depending on the application area the Skin-Client can work in different operation modes.

Direct Mode

The simplest way to use the Skin-Client is to run the Progress agent (with pf-file) using direct mode. The user starts the Progress application ("agent") and the agent starts the Java Skin-Client frontend on the same computer. The client- and server-processes communicate over a socket connection.

For more details see chapter Starting the Skin-Client.

User, frontend, backend and their relations in direct mode

Local Network Mode

The local network mode enables you to provide a Progess based Skin-Client application in a local area network using a central server running the Progress application in batch-mode. The user starts the Skin-Client as application or as applet (by loading a HTML page). The Skin-Client queries the broker for a free port. The broker starts a new agent process and sends the port number to the agent and to the client. Finally the client connects to the agent process.

LAN deployment using the broker

See chapter Skin-Client Broker to find out how to configure broker and agent.

World Wide Mode

With the Skin-Client, it is possible to provide a Progress application over the internet. A webserver is the connector between the local area network and the internet. The webserver provides a HTML page and optionally a Webstart file. With the HTML page the your application can be started as applet in webbrowser. Using Webstart it will be started as a stand-alone application. Webstart can create a new icon on the desktop and in the start menu. That makes it easy of the user to start the application.

The user starts the Skin-Client frontend as application or as applet (by loading a HTML page from the webserver). The Skin-Client sends a HTTP request to the webserver and the server queries the broker for a free port. The broker starts a new agent process and commits the port number to the agent and to the webserver servlet. After that the servlet connects to the agent process and informs the Skin-Client frontend that it is ready to serve request. The webserver gets request from the client, forwards them to the Progress backend application and sends its response HTTP-encoded back to the Skin-Client.

The webserver holds a stable connection to the Progress backend application, making sure that all context is kept as in normal Progress programming. This way you can write web-enabled distributed applications in a client-server way.

Using the skin-client in the web

See chapter Skin-Client Broker to find out how to configure broker and agent.

For the world wide mode a webapplication containing the Java part of the Skin-Client and the webapplication (with HTML pages and the servlet classes) has to be added to your Tomcat installation. See chapter Deployment for more information.


Event Handling

Skin-Client Events

General

Event handling in Skin-Client enabled application is done

attaching a procedure file to the widget object and defining an internal callback procedure to be executed.

oButton = NEW M-BUTTON(THIS-PROCEDURE).
oButton:CHOOSE:subscribe("btchoose").

PROCEDURE btchoose:
  DEFINE INPUT PARAMETER oArgs AS CLASS SC-ARGS NO-UNDO.
END PROCEDURE.

or attaching an object reference to the widget object and defining a callback method to be executed.

oButton = NEW M-BUTTON(THIS-OBJECT).
oButton:CHOOSE:subscribe("btchoose").

METHOD PUBLIC VOID btchoose (oArgs AS CLASS SC-ARGS):
END METHOD.

or attaching a class reference (name) to the widget object and defining a static callback method to be executed.

DEFINE PROTECTED STATIC PROPERTY THIS-CLASS AS CHARACTER NO-UNDO INIT "my.classname" GET.

oButton = NEW M-BUTTON(THIS-CLASS).
oButton:CHOOSE:subscribe("btchoose").

METHOD PUBLIC STATIC VOID btchoose (oArgs AS CLASS SC-ARGS):
END METHOD.


Basic Topics

Migration

Converting an existing Progress application you have to add :

{sc/scCtrl.i INIT}

in each external procedure (outside any internal procedures and functions) that uses Skin-Client API. It starts the object controller (if not started yet) and forward declares the Skin-Client API function headers.

{sc/scObj.i P-WINDOW,P-FRAME,P-BUTTON,P-MENU,P-MENU-ITEM...}

also in each external procedure (outside any internal procedures and functions) that uses Skin-Client temp-table API for creating objects. It provides a list of any widget type that is used in this procedure.

Following statements have to be replaced.

PROGRESS SKIN-CLIENT
CREATE <WIDGET> handle
  ASSIGN <ATTRIBUTE> =...
  TRIGGERS:
    ON <EVENT> PERSISTENT RUN <EVPROC>.
  END TRIGGERS

CREATE <WIDGET>.
ASSIGN <WIDGET>.a<ATTRIBUTE> = ...
id = sc_CreObj(h<WIDGET>).
sc_regTrg(id,"<EVENT>","<EVPROC>").

DEFINE <WIDGET> handle ...

CREATE <WIDGET>.
ASSIGN <WIDGET>.a<ATTRIBUTE> = ...
id = sc_CreObj(h<WIDGET>).

ON <EVENT> OF handle DO:
...
END.

ASSIGN <WIDGET>.e<EVENT> = "<EVPPROC>".
OR
sc_regTrg(id,"<EVENT>","<EVPROC>").
PROCEDURE <EVPROC>:
  DEF INPUT PARAM addpar AS CHAR NO-UNDO.
  ...
END PROCEDURE.

WAIT-FOR ...

RUN sc_waitforgoon.

APPLY <WAIT-FOR-EVENT> ...

RUN sc_applygoon.

APPLY "<EVENT>" TO <WIDGET>.

RUN sc_apply (<WIDGET>,"<EVENT>","").

QUIT.OR STOP.

RUN sc_QUIT

<WIDGET>:<ATTRIBUTE>.

sc_get(<WIDGET>,"<ATTRIBUTE>").

<WIDGET>:<ATTRIBUTE> = <VALUE>.

RUN sc_set(<WIDGET>,"<ATTRIBUTE>",SRING(<VALUE>).

<WIDGET>:<METHOD>(<PARAMS>).

RUN sc_run(<WIDGET>,"<METHOD>",SRING(<PARAMS>).

<RETURN> = <WIDGET>:<METHOD>(<PARAMS>).

RUN sc_fct(<WIDGET>,"<METHOD>",SRING(<PARAMS>, OUTPUT <RETURN>).

CAN-QUERY(<WIDGET>,<ATTRIBUTE>)

sc_CAN-QUERY(<WIDGET>,<ATTRIBUTE>)

VALID-HANDLE(<WIDGET>)

sc_VALID-HANDLE(<WIDGET>)

SESSION:...

sc_get(sc_session,...)

MESSAGE ...
RUN sc_msgInfo.
RUN sc_msg.

DELETE OBJECT <WIDGET>.

RUN sc_DelObj(<WIDGET>).

<HANDLE> = WIDGET-HANDLE(<VALUE>)

<ID> = sc_OBJ-HANDLE(<VALUE>).

<WIDGET>:FIRST-CHILD.
DO WHILE VALID-HANDLE(<WIDGET>):
  ...
  <WIDGET> = <WIDGET>:NEXT-SIBLING.
END.

chi = sc_GetChiObj(<WIDGET>,<ATTRIBUTE>)
DO ii = 1 TO NUM-ENTRIES (chi):
  <WIDGET> = ENTRY(ii, chi).
  ...
END.


Skin-Client widgets

SKIN-CLIENT-RT-INFO class

SKIN-CLIENT-RT-INFO
extended by SC-OBJECT

The SKIN-CLIENT-RT-INFO provides runtime information about the Skin-Client. It is not senseful to create more than one instance.

The object will fire the events shown below to send the informations that the Progress coder is asking for by setting SKIN-CLIENT's CLIENT-LOGGING attribute.

Attributes

EXECUTION-TIME | NUM-OF-OBJS
NUM-OF-WAITING-CMDS | NUM-OF-WAITING-EVENTS
RESPONSE-TIME |
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

Events

SKIN-CLIENT-RT-INFO

Example:

/**
 * The example get a SKIN-CLIENT-RT-INFO instance.
 *
 * The SKIN-CLIENT attribute CLIENT-LOGGING has to be initialized
 * to enable the wanted logging (here NUM-OF-OBJS).
 *
 * The SKIN-CLIENT will synced automatically the NUM-OF-OBJS attribute
 * with the Progress agent.
 */

DEFINE VARIABLE c-NumberOfObjects AS CHARACTER NO-UNDO.
DEFINE VARIABLE c-rtInfo          AS CHARACTER NO-UNDO.
DEFINE VARIABLE oRT AS SKIN-CLIENT-RT-INFO    NO-UNDO.

oRT = NEW SKIN-CLIENT-RT-INFO(THIS-PROCEDURE).
SKIN-CLIENT:oINSTANCE:CLIENT-LOGGING = "NUM-OF-OBJS".
c-rtInfo = oRT:EXECUTION-TIME.

c-NumberOfObjects = oRT:NUM-OF-OBJS.


RESPONSE-TIME attribute

Skin-Client's last RESPONSE-TIME log message.

Data type: | string
Access: | Readable
Applies to: | SKIN-CLIENT-RT-INFO


NUM-OF-WAITING-EVENTS attribute

Skin-Client's last NUM-OF-WAITING-EVENTS message.

Data type: | string
Access: | Readable
Applies to: | SKIN-CLIENT-RT-INFO


NUM-OF-WAITING-CMDS attribute

Skin-Client's last NUM-OF-WAITING-CMDS message.

Data type: | string
Access: | Readable
Applies to: | SKIN-CLIENT-RT-INFO


NUM-OF-OBJS attribute

Skin-Client's last NUM-OF-OBJS message.

Data type: | string
Access: | Readable
Applies to: | SKIN-CLIENT-RT-INFO


EXECUTION-TIME attribute

Skin-Client's last EXECUTION-TIME log message.

Data type: | string
Access: | Readable
Applies to: | SKIN-CLIENT-RT-INFO


SKIN-CLIENT class

SKIN-CLIENT
extended by SC-OBJECT

The SKIN-CLIENT will be created on start-up. It is a Java applet that may be visible in a web-browser window. There can't be more than one instance and it's not possible to create a SKIN-CLIENT object explicitly or to delete the existing object.

Progress coder can use the variable sc_session to access the object. It gives some general information about the client computer.

Attributes

AVAILABLE-FONTS | AVAILABLE-LAFS
BGCOLOR | CLIENT-LOGGING
CLIENT-TIMEOUT | CURRENT-DIRECTORY
CURSOR | ENVIRONMENT
HEIGHT-PIXELS | HOME-DIRECTORY
HTTP-PROXY | JRE-VER
JVM-VER | LAF
LAF-DECORATED | LANGUAGE
LICENCE-DATA | OS
PARAM | SCREEN-HEIGHT-PIXELS
SCREEN-WIDTH-PIXELS | SCROLLABLE
SENSITIVE | SERVER-TIMEOUT
SHOW-DISABLED-EDITOR-BORDERS | SHOW-DISABLED-FILL-IN-BORDERS
STATUS-BAR-TEXT | TEMP-DIRECTORY
UPDATE-LOCKED | USER-LANG
USER-NAME | VERSION
VIRTUAL-HEIGHT-PIXELS | VIRTUAL-WIDTH-PIXELS
VISIBLE | WEB-BROWSER
WIDTH-PIXELS | WINDOWS-SYSTEM
WORK-AREA-HEIGHT-PIXELS | WORK-AREA-WIDTH-PIXELS
WORK-AREA-X | WORK-AREA-Y
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

ACTIVATE-SYNCHRONIZED-MODE | ACTIVE-WINDOW
BELL | CONVERT-INTO-GRAY-SCALE
CONVERT-LOCATION | CREATE-CUSTOM-OBJECT
FOCUS | GET-DEFAULT-COLOR
GET-DEFAULT-FONT | GET-STRING-WIDTH
OPEN-BINARY | PRINT-WIDGET-IMAGE
REPAINT | SAVE-WIDGET-IMAGE
SET-DATE-ORDER | SET-DEFAULT-COLOR
SET-DEFAULT-FONT | SET-WAIT-FRAME-PARAMS
SHOW-COLOR-CHOOSER-DIALOG | SHOW-CONFIRM-DIALOG
SHOW-CUSTOM-DIALOG | SHOW-DIR-DIALOG
SHOW-DOCUMENT | SHOW-LOAD-DIALOG
SHOW-MESSAGE-DIALOG | SHOW-SAVE-DIALOG

Events

ANY-KEY | ANY-KEY
BACK-TAB-KEY | CONSOLE-OUTPUT
DELETE-KEY | ENTER-KEY
ENTRY | ESCAPE-KEY
INSERT-KEY | JS-MESSAGE
LEAVE | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | PAGE-DOWN-KEY
PAGE-UP-KEY | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | SKIN-CLIENT-CLOSE
SKIN-CLIENT-HEART-BEAT | SKIN-CLIENT-TIMEOUT
TAB-KEY |

Example:

/**
 * Show a info message box that displays the version of client computer's Java Virtual Machine.
 */
SKIN-CLIENT:oINSTANCE:SHOW-MESSAGE-DIALOG(SKIN-CLIENT:oINSTANCE:JVM-VER,"Java Version","INFO")


WORK-AREA-Y attribute

The work-area y-position in pixels.

Data type: | integer
Default value: | 0
Access: | Readable
Applies to: | SKIN-CLIENT


WORK-AREA-X attribute

The work-area x-position in pixels.

Data type: | integer
Default value: | 0
Access: | Readable
Applies to: | SKIN-CLIENT


WORK-AREA-WIDTH-PIXELS attribute

The work-area width in pixels.

Data type: | integer
Default value: | 0
Access: | Readable
Applies to: | SKIN-CLIENT


WORK-AREA-HEIGHT-PIXELS attribute

The work-area height in pixels.

Data type: | integer
Default value: | 0
Access: | Readable
Applies to: | SKIN-CLIENT


WINDOWS-SYSTEM attribute

Data type: value-set
Values:
Value | Description
OTHER |
MS-WINXP |
MS-WINDOWS |
MS-WIN95 |
Access: Readable
Applies to: SKIN-CLIENT


WIDTH-PIXELS attribute

Applet widget pixels. This value is defined in the startup HTML file and can't be changed at runtime.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | SKIN-CLIENT


WEB-BROWSER attribute

The web browser that has started the Skin-Client.

Data type: | string
Access: | Readable
Applies to: | SKIN-CLIENT


VISIBLE attribute

Indicates whether a widget is currently visible on the display.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | SKIN-CLIENT


VIRTUAL-WIDTH-PIXELS attribute

The maximum width of the applet's content area, in pixels.

For a SCROLLABLE applet, VIRTUAL-WIDTH-PIXELS specifies the width of the entire content area while WIDTH-PIXELS specifies the width of the visible portion of the content area.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | SKIN-CLIENT


VIRTUAL-HEIGHT-PIXELS attribute

The maximum height of applet's content area, in pixels.

For a SCROLLABLE applet, VIRTUAL-HEIGHT-PIXELS specifies the height of the entire content area while HEIGHT-PIXELS specifies the height of the visible portion of the content area.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | SKIN-CLIENT


VERSION attribute

Skin-Client version number and release date. Format: >>9.>>9.>>9.YYMMDD (year, month, day).

Data type: | string
Access: | Readable
Applies to: | SKIN-CLIENT


USER-NAME attribute

User's login name on the client computer.

Data type: | string
Access: | Readable
Applies to: | SKIN-CLIENT


USER-LANG attribute

Language on the client computer.

Data type: | string
Access: | Readable
Applies to: | SKIN-CLIENT


UPDATE-LOCKED attribute

If the UPDATE-LOCKED attribute is TRUE, the complete GUI will ignore any paint requests (triggered by user OR application) until the attribute is reset to FALSE.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | SKIN-CLIENT


TEMP-DIRECTORY attribute

The temporary directory in which Progress can store files during the session.

Data type: | string
Access: | Readable / Writeable
Applies to: | SKIN-CLIENT


STATUS-BAR-TEXT attribute

Indicates the text that appears in the status line of a web-browser window.

Data type: | string
Access: | Readable / Writeable
Applies to: | SKIN-CLIENT


SHOW-DISABLED-FILL-IN-BORDERS attribute

Indicates whether newly created Fill-Ins should show their border even in disabled state

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | SKIN-CLIENT


SHOW-DISABLED-EDITOR-BORDERS attribute

Indicates whether newly created Editors should show their border even in disabled state

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | SKIN-CLIENT


SERVER-TIMEOUT attribute

The timeout for the server socket connection in seconds. 0 or negative values disable the timeout.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | SKIN-CLIENT


SENSITIVE attribute

Indicates whether a widget is sensitive and can receive input focus or events.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | SKIN-CLIENT


SCROLLABLE attribute

If the SCROLLABLE attribute is TRUE, the appplet's content area can be bigger than the display space allotted to it (that is, it is scrollable). If SCROLLABLE is FALSE, the content area must fit within the allotted display space; it cannot be made to scroll.

The VIRTUAL-HEIGHT-PIXELS and VIRTUAL-WIDTH-PIXELS attributes control the virtual or maximum size of the applet's content area.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | SKIN-CLIENT


SCREEN-WIDTH-PIXELS attribute

The client computer's primary screen width in pixels.

Data type: | integer
Default value: | 0
Access: | Readable
Applies to: | SKIN-CLIENT


SCREEN-HEIGHT-PIXELS attribute

The client computer's primary screen height in pixels.

Data type: | integer
Default value: | 0
Access: | Readable
Applies to: | SKIN-CLIENT


PARAM attribute

Parameter defined on start up.

Data type: | string
Access: | Readable
Applies to: | SKIN-CLIENT


OS attribute

Operation system running on the client computer.

Data type: | string
Access: | Readable
Applies to: | SKIN-CLIENT


LICENCE-DATA attribute

Comma separeted list of version, company, department, postal address, zip code, city, licence date, users, period and site

Data type: | string
Access: | Readable / Writeable
Applies to: | SKIN-CLIENT


LANGUAGE attribute

The LANGUAGE attribute value is a valid ISO Language Code. These codes are the lower-case, two-letter codes as defined by ISO-639. You can find a full list of these codes at a number of sites, such as: http://ftp.ics.uci.edu/pub/ietf/http/related/iso639.txt

Data type: | string
Access: | Readable / Writeable
Applies to: | SKIN-CLIENT


LAF-DECORATED attribute

Indicates whether newly created windows and dialogs should be decorated by the current look and feel (if supported!)

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | SKIN-CLIENT


LAF attribute

The name of the current look and feel.

Data type: | string
Access: | Readable / Writeable
Applies to: | SKIN-CLIENT


JVM-VER attribute

Version of the Java Virtual Mashine.

Data type: | string
Access: | Readable
Applies to: | SKIN-CLIENT


JRE-VER attribute

Version of the Java Runtime.

Data type: | string
Access: | Readable
Applies to: | SKIN-CLIENT


HTTP-PROXY attribute

HTTP-Proxy hostname and port separated by colon (:). Available if SKIN-CLIENT is started as applet otherwise attribute has a unknown value.

Data type: | string
Access: | Readable / Writeable
Applies to: | SKIN-CLIENT


HOME-DIRECTORY attribute

The home directory of the local user that is currently logged in.

Data type: | string
Access: | Readable / Writeable
Applies to: | SKIN-CLIENT


HEIGHT-PIXELS attribute

Applet height pixels. This value is defined in the startup HTML file and can't be changed at runtime.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | SKIN-CLIENT


ENVIRONMENT attribute

The enviroment tells (should tell in future Releases) which Skin-Client implementation is running (Java or .NET) and addional the start-up mode of the running instance. A Java Skin-Client may run as application (stand alone) or as applet (referred on a HTML page, started by the web-browser).

Data type: value-set
Values:
Value | Description
JAVA-APPLICATION |
JAVA-APPLET |
JAVA-ECLIPSE |
Access: Readable
Applies to: SKIN-CLIENT


CURSOR attribute

A bitmap representation of the cursor shown if the mouse pointer is over this widget.

Data type: | J-CURSOR
Access: | Readable / Writeable
Applies to: | SKIN-CLIENT


CURRENT-DIRECTORY attribute

The current (working) directory where files are located as default using P-BINARY objects.

Data type: | string
Access: | Readable / Writeable
Applies to: | SKIN-CLIENT


CLIENT-TIMEOUT attribute

Client timeout in seconds. 0 or negative values disable the timeout.

Data type: | integer
Default value: | 2
Access: | Readable / Writeable
Applies to: | SKIN-CLIENT


CLIENT-LOGGING attribute

Tell the Skin-Client to write logging information into the console.

If the logging information are meant for the Progress Task you can instantiate a SKIN-CLIENT-RT-INFO -object.

Data type: value-set
Values:
Value | Description
NONE | Disable client logging. This value can't combined with other values.
RESPONSE-TIME | Time in milliseconds between a command and Skin-Client's answer.
EXECUTION-TIME | Time in milliseconds a command takes.
COMMANDS | Command processed by the Skin-Client.
MESSAGES | Message transmitted to the server.
NUM-OF-WAITING-CMDS | Number of commands that are received but not processed (command queue length).
NUM-OF-WAITING-EVENTS | Number of not transmitted events (event queue lenght).
NUM-OF-OBJS | Number of objects that were created but are not disposed yet.
ALL | Enable all message types. This value can't combined with other values.

Note: The value may be combined of multiple values. The values are separated by plus (+).
Default value: NONE
Access: Readable / Writeable
Applies to: SKIN-CLIENT


BGCOLOR attribute

The background color of the widget.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | SKIN-CLIENT


AVAILABLE-LAFS attribute

Names of all available look and feels as comma separeted list.

Data type: | string
Access: | Readable
Applies to: | SKIN-CLIENT


AVAILABLE-FONTS attribute

Names of all available fonts as comma separeted list.

Data type: | string
Access: | Readable
Applies to: | SKIN-CLIENT


SHOW-SAVE-DIALOG method

Brings up a dialog where user can select a path to save a file. The method returns the full pathname of the given file if user approves the dialog otherwise unknown value (\?).

If user has approved and binary object is specified the content will be stored in the choosen file.

Return type: string
Applies to: SKIN-CLIENT
Syntax:
_ret = oClass:SHOW-SAVE-DIALOG(
      TITLE, DIRECTORY, FILTERS, FILTER-NAMES, OBJECT).

Param | Data type | Description
TITLE | string | dialog title
DIRECTORY | string | init directory
FILTERS | string | comma separeted file filters
FILTER-NAMES | string | name of the file filters
OBJECT | J-BINARY | Binary object to save or unknown value (\?).


SHOW-MESSAGE-DIALOG method

Brings up a dialog displaying a message.

Return type: value-set
Value | Description
OK |
Applies to: SKIN-CLIENT
Syntax:
_ret = oClass:SHOW-MESSAGE-DIALOG(
      MESSAGE-TEXT, MESSAGE-TITLE, MESSAGE-TYPE).
Param | Data type | Description
MESSAGE-TEXT | string | message text
MESSAGE-TITLE | string | dialog title
MESSAGE-TYPE value-set message type

Values:

Value | Description
PLAIN | Don't display a icon.
ERROR | Error message icon.
INFO | Information icon.
WARNING | Warning icon.
QUESTION | Question icon.


SHOW-LOAD-DIALOG method

Brings up a dialog where user can select a file to open. The method returns the full pathname of the selected file if user approves the dialog otherwise unknown value (\?).

If user has approved and binary object is specified the file will be loaded to fill the binary object.

Return type: string
Applies to: SKIN-CLIENT
Syntax:
_ret = oClass:SHOW-LOAD-DIALOG(
      TITLE, DIRECTORY, FILTERS, FILTER-NAMES, OBJECT).

Param | Data type | Description
TITLE | string | dialog title
DIRECTORY | string | init directory
FILTERS | string | comma separeted file filters
FILTER-NAMES | string | name of the file filters
OBJECT | J-BINARY | Binary object to load or unknown value (\?).


SHOW-DOCUMENT method

Uses web-browser to show a document of given URL.

If Skin-Client is started as application:
  • Under Windows, this will bring up the default browser.
  • Under Unix, the system browser is hard-coded to be 'netscape'.

Applies to: SKIN-CLIENT
Syntax:
oClass:SHOW-DOCUMENT(
      URL, FRAME).

Param | Data type | Description
URL | string | document URL (e.g.: file://server.name/dir/document.pdf or http://www.tools4progress.com/skinclient.html)
FRAME | string | HTML frame name. If empty the document is shown in a new window. This parameter is only used if Skin-Client is started as applet.


SHOW-DIR-DIALOG method

Brings up a dialog where user can select a directory. The method returns the full pathname of the selected file if user approves the dialog otherwise unknown value (\?).

Return type: string
Applies to: SKIN-CLIENT
Syntax:
_ret = oClass:SHOW-DIR-DIALOG(
      TITLE, DIRECTORY, FILTER-NAMES, TEXT).

Param | Data type | Description
TITLE | string | dialog title
DIRECTORY | string | init directory
FILTER-NAMES | string | name of the file filter
TEXT | string | button text


SHOW-CUSTOM-DIALOG method

Brings up a dialog displaying a message and providing given buttons.

The method returns the key of the choosen button or the constant CLOSED if the dialog has been closed without choosing a button.

Return type: string
Applies to: SKIN-CLIENT
Syntax:
_ret = oClass:SHOW-CUSTOM-DIALOG(
      MESSAGE-TEXT, MESSAGE-TITLE, MESSAGE-TYPE, DELIMITER, LIST).
Param | Data type | Description
MESSAGE-TEXT | string | message text
MESSAGE-TITLE | string | dialog title
MESSAGE-TYPE value-set message type

Values:

Value | Description
PLAIN | Don't display a icon.
ERROR | Error message icon.
INFO | Information icon.
WARNING | Warning icon.
QUESTION | Question icon.
DELIMITER | string | delimiter for button labels and keys
LIST | string | list of button labels and keys separated by delimiter parameter. Comparable to LIST-ITEM-PAIRS of P-COMBO-BOX


SHOW-CONFIRM-DIALOG method

Brings up a dialog where options available are determined by the option type parameter.

Return type: value-set
Value | Description
YES-OK | User has selected yes/or option.
NO | User has selected no option.
CANCEL | User has selected cancel option.
CLOSED | User has closed the dialog.
Applies to: SKIN-CLIENT
Syntax:
_ret = oClass:SHOW-CONFIRM-DIALOG(
      MESSAGE-TEXT, MESSAGE-TITLE, OPTION-TYPE, MESSAGE-TYPE).
Param | Data type | Description
MESSAGE-TEXT | string | message
MESSAGE-TITLE | string | dialog title
OPTION-TYPE value-set option type

Values:

Value | Description
YES-NO |
OK-CANCEL |
YES-NO-CANCEL |
MESSAGE-TYPE value-set message type

Values:

Value | Description
PLAIN | Don't display a icon.
ERROR | Error message icon.
INFO | Information icon.
WARNING | Warning icon.
QUESTION | Question icon.


SHOW-COLOR-CHOOSER-DIALOG method

Brings up a dialog where user can choose a color.

Return type: J-COLOR
Applies to: SKIN-CLIENT
Syntax:
oReturn = oClass:SHOW-COLOR-CHOOSER-DIALOG(
      COLOR, MESSAGE-TITLE).

Param | Data type | Description
COLOR | J-COLOR | initial color
MESSAGE-TITLE | string | dialog title


SET-WAIT-FRAME-PARAMS method

Set the frame shown if a request takes a long time and some parameter.

Applies to: SKIN-CLIENT
Syntax:
oClass:SET-WAIT-FRAME-PARAMS(
      FRAME, TIMEOUT, ENABLED).

Param | Data type | Description
FRAME | P-FRAME | The Frame to be shown. ? (unknown value) means "no change"
TIMEOUT | integer | Delay before the wait-frame is shown, in milliseconds. ? (unknown value) means "no change"
ENABLED | boolean | Sets whether the wait-frame should be displayed. ? (unknown value) means "no change"


SET-DEFAULT-FONT method

Write a font to the table of defaults for Java (Swing) widgets for currently active Look'n'Feel.

Applies to: SKIN-CLIENT
Syntax:
oClass:SET-DEFAULT-FONT(
      COMPONENT, FONT).
Param Data type Description
COMPONENT value-set

Values:

Value | Description
P-BUTTON | Default button font.
P-TOGGLE-BOX | Default toggle-box font.
P-COMBO-BOX | Default combo-box font.
P-FILL-IN | Default fill-in font.
P-EDITOR | Default editor font.
P-TEXT | Default text font.
P-SELECTION-LIST | Default selection-list font.
P-PROGRESS-BAR | Default progress-bar font.
P-RADIO-SET | Default radio-button font.
P-BROWSE | Default browse font.
P-TREE | Default tree font.
P-TABBED-PANE | Default font for tabs.
P-MENU-ITEM | Default menu item font.
P-TOGGLE-BOX-MENU-ITEM | Default toggle-box menu item font.
P-MENU | Default menu bar font.
FONT J-FONT


SET-DEFAULT-COLOR method

Write a color to the table of defaults for Java (Swing) widgets for currently active Look'n'Feel.

Applies to: SKIN-CLIENT
Syntax:
oClass:SET-DEFAULT-COLOR(
      COMPONENT, COLOR).
Param Data type Description
COMPONENT value-set

Values:

Value | Description
P-FRAME.FG |
P-FRAME.BG |
P-BUTTON.FG |
P-BUTTON.BG |
P-BROWSE.FG |
P-COMBO-BOX.FG |
P-COMBO-BOX.BG |
P-EDITOR.BG |
P-EDITOR.FG |
P-EDITOR.CARET |
P-FILL-IN.BG |
P-FILL-IN.CARET |
P-FILL-IN.FG |
P-PROGRESS-BAR.BG |
P-PROGRESS-BAR.FG |
P-SELECTION-LIST.BG |
P-SELECTION-LIST.FG |
P-SPLIT-PANE.BG |
P-TABBED-PANE.BG |
P-TABBED-PANE.FG |
P-TEXT.BG |
P-TEXT.FG |
P-TOGGLE-BOX.BG |
P-TOGGLE-BOX.FG |
P-TREE.BG |
P-TREE.FG |
COLOR J-COLOR


SET-DATE-ORDER method

Overrides client computer's default date order. The date order determines the order of day, month, year of an input value displayed by the P-DATE-PICKER widget.

Applies to: SKIN-CLIENT
Syntax:
oClass:SET-DATE-ORDER(
      ORDER).

Param | Data type | Description
ORDER | string | Examples: MDY, DMY, YMD


SAVE-WIDGET-IMAGE method

Takes a picture of a given skin-client widget and saves the image to a file

Return type: boolean
Applies to: SKIN-CLIENT
Syntax:
_ret = oClass:SAVE-WIDGET-IMAGE(
      WIDGET, TARGET, FORMAT).

Param | Data type | Description
WIDGET | AP-WIDGET | widget
TARGET | string | target image filename
FORMAT | string | image format (depends on client java runtime, but should support at least PNG, JPG and BMP)


REPAINT method

Repaints this component (application-trigged painting).

There are two kinds of painting operations: system-triggered painting, and application-triggered painting.

In a system-triggered painting operation, the system requests a component to render its contents, usually for one of the following reasons:
  • The component is first made visible on the screen.
  • The component is resized.
  • The component has damage that needs to be repaired. (For example, something that previously obscured the component has moved, and a previously obscured portion of the component has become exposed).

In an application-triggered painting operation, the application decides it needs to update a component because its internal state has changed. (For example, the application detects that a mouse button has been pressed and determines that it needs to paint a 'depressed' button visual).

Applies to: SKIN-CLIENT
Syntax:
oClass:REPAINT(
      ).


PRINT-WIDGET-IMAGE method

Takes a picture of a given skin-client widget and prints it using the systems default printer or shows a native print dialog.

Return type: boolean
Applies to: SKIN-CLIENT
Syntax:
_ret = oClass:PRINT-WIDGET-IMAGE(
      WIDGET, ORIENTATION, CHOOSE-PRINTER).
Param | Data type | Description
WIDGET AP-WIDGET
widget
ORIENTATION value-set page orientation

Values:

Value | Description
PORTRAIT |
LANDSCAPE |
CHOOSE-PRINTER | boolean | if true, a native dialog is shown to be able to choose the printer and to adjust printer settings


OPEN-BINARY method

Tries to open a document represented by the given binary

Applies to: SKIN-CLIENT
Syntax:
oClass:OPEN-BINARY(
      BINARY, DOCUMENT-TYPE, FRAME).

Param | Data type | Description
BINARY | J-BINARY | Binary object containing the content of the document to open
DOCUMENT-TYPE | string | The document-type (file-extention)
FRAME | string | HTML frame name. If empty the document is shown in a new window. This parameter is only used if Skin-Client is started as applet.


GET-STRING-WIDTH method

This method returns the width (in pixels) needed to render the given string using the given font.

Return type: integer
Applies to: SKIN-CLIENT
Syntax:
_ret = oClass:GET-STRING-WIDTH(
      STRING, FONT).

Param | Data type | Description
STRING | string | The string to use for width calculation
FONT | J-FONT | The font to use for width calculation


GET-DEFAULT-FONT method

Read a font from the table of defaults for Java (Swing) widgets for currently active Look'n'Feel.

Return type: J-FONT
Applies to: SKIN-CLIENT
Syntax:
oReturn = oClass:GET-DEFAULT-FONT(
      COMPONENT).
Param Data type Description
COMPONENT value-set

Values:

Value | Description
P-BUTTON | Default button font.
P-TOGGLE-BOX | Default toggle-box font.
P-COMBO-BOX | Default combo-box font.
P-FILL-IN | Default fill-in font.
P-EDITOR | Default editor font.
P-TEXT | Default text font.
P-SELECTION-LIST | Default selection-list font.
P-PROGRESS-BAR | Default progress-bar font.
P-RADIO-SET | Default radio-button font.
P-BROWSE | Default browse font.
P-TREE | Default tree font.
P-TABBED-PANE | Default font for tabs.
P-MENU-ITEM | Default menu item font.
P-TOGGLE-BOX-MENU-ITEM | Default toggle-box menu item font.
P-MENU | Default menu bar font.


GET-DEFAULT-COLOR method

Read a color from the table of defaults for Java (Swing) widgets for currenttly active Look'n'Feel.

Return type: J-COLOR
Applies to: SKIN-CLIENT
Syntax:
oReturn = oClass:GET-DEFAULT-COLOR(
      COMPONENT).
Param Data type Description
COMPONENT value-set

Values:

Value | Description
P-FRAME.FG |
P-FRAME.BG |
P-BUTTON.FG |
P-BUTTON.BG |
P-BROWSE.FG |
P-COMBO-BOX.FG |
P-COMBO-BOX.BG |
P-EDITOR.BG |
P-EDITOR.FG |
P-EDITOR.CARET |
P-FILL-IN.BG |
P-FILL-IN.CARET |
P-FILL-IN.FG |
P-PROGRESS-BAR.BG |
P-PROGRESS-BAR.FG |
P-SELECTION-LIST.BG |
P-SELECTION-LIST.FG |
P-SPLIT-PANE.BG |
P-TABBED-PANE.BG |
P-TABBED-PANE.FG |
P-TEXT.BG |
P-TEXT.FG |
P-TOGGLE-BOX.BG |
P-TOGGLE-BOX.FG |
P-TREE.BG |
P-TREE.FG |


FOCUS method

The widget that has current input focus.

Return type: AJ-COMPONENT
Applies to: SKIN-CLIENT
Syntax:
oReturn = oClass:FOCUS(
      ).


CREATE-CUSTOM-OBJECT method

Return type: JS-CUSTOM
Applies to: SKIN-CLIENT
Syntax:
oReturn = oClass:CREATE-CUSTOM-OBJECT(
      TYPE).

Param | Data type | Description
TYPE | string |


CONVERT-LOCATION method

This method returns the location of a given widget converted to the coordinate system of a given container. The result is returned as comma-separated list of X- and Y-value, e.g.: '100,50'

Return type: string
Applies to: SKIN-CLIENT
Syntax:
_ret = oClass:CONVERT-LOCATION(
      SOURCE-WIDGET, TARGET-CONTAINER).

Param | Data type | Description
SOURCE-WIDGET | AJ-COMPONENT | The widget to get the location for
TARGET-CONTAINER | AJ-COMPONENT | The container defining the coordinate system


CONVERT-INTO-GRAY-SCALE method

Convert image in to gray scale.

Return type: J-IMAGE-ICON
Applies to: SKIN-CLIENT
Syntax:
oReturn = oClass:CONVERT-INTO-GRAY-SCALE(
      SOURCE).

Param | Data type | Description
SOURCE | J-IMAGE-ICON | Source image


BELL method

Make a beep sound on the client.

Applies to: SKIN-CLIENT
Syntax:
oClass:BELL(
      ).


ACTIVE-WINDOW method

The currently active P-WINDOW, P-DIALOG or the SKIN-CLIENT if the client runs as an applet.

Return type: AJ-COMPONENT
Applies to: SKIN-CLIENT
Syntax:
oReturn = oClass:ACTIVE-WINDOW(
      ).


ACTIVATE-SYNCHRONIZED-MODE method

Activates the 'Synchronized-Mode':

Whenever a registered event occurs the UI and all upcoming events get blocked until all sc-commands received from the server are executed.
Note: This method should be invoked as early as possible (before the first UI-event occurs)

Applies to: SKIN-CLIENT
Syntax:
oClass:ACTIVATE-SYNCHRONIZED-MODE(
      ).


SC-OBJECT abstract class

Subclasses

J-BINARY | J-COLOR
J-COOKIE | J-CURSOR
J-FILE | J-FONT
JS-OBJECT | J-TIMER
P-BAND | P-BAND-GROUP
P-BAND-ITEM | P-BAND-TAB
P-BROWSE-COLUMN | P-DOCKFRAME
P-DOCKGROUP | P-MENU
P-MENU-ITEM | P-SEPARATOR
P-TOOL-BAR | P-TREE-NODE
SKIN-CLIENT | SKIN-CLIENT-RT-INFO
P-LINK-BUTTON
P-SCHEDULER-TASK P-TASKPANEGROUP
P-DIALOG | P-FRAME
P-MDI-CONTAINER | P-WEB-BROWSER
P-WINDOW |
P-BROWSE | P-BUTTON
P-COMBO-BOX | P-CUSTOM-BROWSE
P-DATE-PICKER | P-DOCKMAN
P-EDITOR | P-FILE-UPLOADER
P-FILL-IN | P-FLEX-TEXT
P-GRID | P-IMAGE
P-OUTLOOKBAR | P-PROGRESS-BAR
P-RADIO-SET | P-RECTANGLE
P-RTF-EDITOR | P-SCHEDULER
P-SELECTION-LIST | P-SHORTCUT-BAR
P-SPLIT-PANE | P-TABBED-PANE
P-TASKPANE | P-TEXT
P-TOGGLE-BOX | P-TREE
J-CANVAS | J-COLOR-ICON
J-IMAGE-ICON |

Attributes

MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

Events


PRIVATE-DATA attribute

An arbitrary string associated with an object.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP P-SCHEDULER-TASK P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER P-LINK-BUTTON J-IMAGE-ICON J-COLOR-ICON J-CANVAS SKIN-CLIENT SKIN-CLIENT-RT-INFO J-FILE J-BINARY J-COLOR J-FONT J-TIMER J-CURSOR JS-CUSTOM JS-OBJECT J-COOKIE P-SEPARATOR P-TOGGLE-BOX-MENU-ITEM P-MENU-ITEM P-MENU P-BROWSE-COLUMN P-TREE-NODE P-TOOL-BAR P-DOCKGROUP P-DOCKFRAME P-BAND P-BAND-TAB P-BAND-GROUP P-BAND-ITEM-POPUP P-BAND-ITEM-FLIPFLOP P-BAND-ITEM


PARENT attribute

The parent of the widget.

Data type: | SC-OBJECT
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP P-SCHEDULER-TASK P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER P-LINK-BUTTON J-IMAGE-ICON J-COLOR-ICON J-CANVAS SKIN-CLIENT SKIN-CLIENT-RT-INFO J-FILE J-BINARY J-COLOR J-FONT J-TIMER J-CURSOR JS-CUSTOM JS-OBJECT J-COOKIE P-SEPARATOR P-TOGGLE-BOX-MENU-ITEM P-MENU-ITEM P-MENU P-BROWSE-COLUMN P-TREE-NODE P-TOOL-BAR P-DOCKGROUP P-DOCKFRAME P-BAND P-BAND-TAB P-BAND-GROUP P-BAND-ITEM-POPUP P-BAND-ITEM-FLIPFLOP P-BAND-ITEM


NAME attribute

The name with which this widget could be found using sc_GetObj Progress API function.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP P-SCHEDULER-TASK P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER P-LINK-BUTTON J-IMAGE-ICON J-COLOR-ICON J-CANVAS SKIN-CLIENT SKIN-CLIENT-RT-INFO J-FILE J-BINARY J-COLOR J-FONT J-TIMER J-CURSOR JS-CUSTOM JS-OBJECT J-COOKIE P-SEPARATOR P-TOGGLE-BOX-MENU-ITEM P-MENU-ITEM P-MENU P-BROWSE-COLUMN P-TREE-NODE P-TOOL-BAR P-DOCKGROUP P-DOCKFRAME P-BAND P-BAND-TAB P-BAND-GROUP P-BAND-ITEM-POPUP P-BAND-ITEM-FLIPFLOP P-BAND-ITEM


MODIFIED attribute

Indicates whether the value for the widget has changed.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP P-SCHEDULER-TASK P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER P-LINK-BUTTON J-IMAGE-ICON J-COLOR-ICON J-CANVAS SKIN-CLIENT SKIN-CLIENT-RT-INFO J-FILE J-BINARY J-COLOR J-FONT J-TIMER J-CURSOR JS-CUSTOM JS-OBJECT J-COOKIE P-SEPARATOR P-TOGGLE-BOX-MENU-ITEM P-MENU-ITEM P-MENU P-BROWSE-COLUMN P-TREE-NODE P-TOOL-BAR P-DOCKGROUP P-DOCKFRAME P-BAND P-BAND-TAB P-BAND-GROUP P-BAND-ITEM-POPUP P-BAND-ITEM-FLIPFLOP P-BAND-ITEM


P-WINDOW class

P-WINDOW
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

A window is a rectangular area on the screen that can contain frame and field level widgets. Normally a window has a border and a title bar with small icon, title, minimize-, maximize- and close-buttons.

The attributes WIDTH-PIXELS and HEIGHT-PIXELS indicates the size of the window's content area. By specifying a virtual size (attributes VIRTUAL-WIDTH-PIXELS and VIRTAL-HEIGHT-PIXELS) greater than normal size you can make the content area scrollable.

Attributes

ALWAYS-ON-TOP | BGCOLOR
BGIMAGE | DEFAULT-BUTTON
EMBEDDED | ICON
MDI-PARENT | RESIZABLE
SCROLLABLE | STATE
STATUS-BAR-TEXT | STATUS-BAR-VISIBLE
TITLE | UNDECORATED
UPDATE-LOCKED | VIRTUAL-HEIGHT-PIXELS
VIRTUAL-WIDTH-PIXELS | VISIBLE
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

CENTER-ON-CURRENT-WINDOW | CENTER-ON-SCREEN
TO-TOP |
inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

ENTRY | LEAVE
RESIZED | WINDOW-CLOSE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY

Example:

/**
 *  The example create a window with pixels size 800x600 and make it visible.
 *  If user press the close button in the title bar the window will disposed.
 */

DEFINE VARIABLE oWindow AS P-WINDOW    NO-UNDO.

oWindow = NEW P-WINDOW(THIS-PROCEDURE).
oWindow:NAME = "Window".
oWindow:TITLE = "A Skin-Client Window...".
oWindow:WIDTH-PIXELS = 800.
oWindow:HEIGHT-PIXELS = 600.
oWindow:VISIBLE = YES.
oWindow:PARENT = SKIN-CLIENT:oINSTANCE.
oWindow:WINDOW-CLOSE = "WindowClose".


VISIBLE attribute

Indicates whether a widget is currently visible on the display.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-WINDOW


VIRTUAL-WIDTH-PIXELS attribute

The maximum height of window's content area, in pixels.

For a SCROLLABLE window, VIRTUAL-HEIGHT-PIXELS specifies the height of the entire content area while HEIGHT-PIXELS specifies the height of the visible portion of the content area.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-WINDOW


VIRTUAL-HEIGHT-PIXELS attribute

The maximum width of window's content area, in pixels.

For a SCROLLABLE window, VIRTUAL-WIDTH-PIXELS specifies the width of the entire content area while WIDTH-PIXELS specifies the width of the visible portion of the content area.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-WINDOW


UPDATE-LOCKED attribute

If the UPDATE-LOCKED attribute is TRUE, the window will ignore any paint requests (triggered by user OR application) until the attribute is reset to FALSE.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-WINDOW


UNDECORATED attribute

Indicates whether this window is undecorated. By default, all windows are initially decorated.

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-WINDOW


TITLE attribute

The title string a window displays.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-WINDOW


STATUS-BAR-VISIBLE attribute

Indicates whether a status-bar is visible.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-WINDOW


STATUS-BAR-TEXT attribute

The text shown in the window status bar.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-WINDOW


STATE attribute

The state of this window.

Data type: value-set
Values:
Value | Description
NORMAL | Window is neither ICONIFIED nor MAXIMIZED.
ICONIFIED | Window is iconified.
MAXIMIZED | Window is maximized.
Access: Readable / Writeable
Applies to: P-WINDOW


SCROLLABLE attribute

If the SCROLLABLE attribute is TRUE, window's content area can be bigger than the display space allotted to it (that is, it is scrollable). If SCROLLABLE is FALSE, the content area must fit within the allotted display space; it cannot be made to scroll.

The VIRTUAL-HEIGHT-PIXELS and VIRTUAL-WIDTH-PIXELS attributes control the virtual or maximum size of window's content area.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-WINDOW


RESIZABLE attribute

Indicates whether the user can resize a widget at run time.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-WINDOW


MDI-PARENT attribute

The MDI-Container used when the window gets embedded by setting the attribute EMBEDDED to TRUE

Data type: | P-MDI-CONTAINER
Access: | Readable / Writeable
Applies to: | P-WINDOW


ICON attribute

The icon of the window, loaded with sc_loadFile Progress API function.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-WINDOW


EMBEDDED attribute

Indicates if the window is embedded.

Note: embedding only works if MDI-PARENT is set to a valid container.

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-WINDOW


DEFAULT-BUTTON attribute

The default button of the window.

Data type: | P-BUTTON
Access: | Readable / Writeable
Applies to: | P-WINDOW


BGIMAGE attribute

The background image of the widget.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-WINDOW


BGCOLOR attribute

The background color of the window.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-WINDOW


ALWAYS-ON-TOP attribute

An always-on-top window is a window that stays above all other windows except maybe other always-on-top windows. If there are several always-on-top windows the order in which they stay relative to each other is not specified and is platform dependent.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-WINDOW


TO-TOP method

Move window to top.

Applies to: P-WINDOW
Syntax:
oClass:TO-TOP(
      ).


CENTER-ON-SCREEN method

Center window on the screen.

Applies to: P-WINDOW
Syntax:
oClass:CENTER-ON-SCREEN(
      ).


CENTER-ON-CURRENT-WINDOW method

Center window relative to the currently focused window

Applies to: P-WINDOW
Syntax:
oClass:CENTER-ON-CURRENT-WINDOW(
      ).


P-WEB-BROWSER class

P-WEB-BROWSER
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

Attributes

ANCHORS URL
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

CALL-JS-FUNCTION GET-JS-OBJECT
inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

JS-MESSAGE URL-LOADED
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY


URL attribute

The URL to load

Data type: | string
Access: | Readable / Writeable
Applies to: | P-WEB-BROWSER


ANCHORS attribute

Anchors are used to define automatic client-side resizing and/or repositioning of widgets.

This attribute indicates which anchors to respect if the parent container resizes.

Data type: value-set
Values:
Value | Description
NONE | No anchor
LEFT | Anchor to the left border of the parent container
TOP | Anchor to the top border of the parent container
RIGHT | Anchor to the right border of the parent container
BOTTOM | Anchor to the bottom border of the parent container
FILLED | Completly fills the parent container

Note: The value may be combined of multiple values. The values are separated by plus (+).
Default value: LEFT+TOP
Access: Readable / Writeable
Applies to: P-WEB-BROWSER


GET-JS-OBJECT method

Gets the javascript object with the given name

Return type: JS-OBJECT
Applies to: P-WEB-BROWSER
Syntax:
oReturn = oClass:GET-JS-OBJECT(
      OBJECT).

Param | Data type | Description
OBJECT | string | Name of the javascript object


CALL-JS-FUNCTION method

calls a javascript function

Return type: string
Applies to: P-WEB-BROWSER
Syntax:
_ret = oClass:CALL-JS-FUNCTION(
      FUNCTION, PARAMETER-LIST).

Param | Data type | Description
FUNCTION | string | Name of the function
PARAMETER-LIST | string | List of parameters that are passed to the function, delimited by DELIMITER


P-TREE-NODE class

P-TREE-NODE
extended by SC-OBJECT

Stores information about a tree node that can be used for a P-TREE widget.

Attributes

CLOSE-ICON | EDIT-ICON
EXPANDED | INPUT-VALUE
LEAF | LEAF-ICON
OPEN-ICON | READ-ONLY
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

SET-CLOSE-POPUP-MENU | SET-LEAF-POPUP-MENU
SET-OPEN-POPUP-MENU |

Events

TREE-COLLAPSE TREE-EXPAND

Example:

/**
 *  The example create a tree widget and a root node.
 */

DEFINE VARIABLE oTree AS P-TREE      NO-UNDO.
DEFINE VARIABLE oRoot AS P-TREE-NODE NO-UNDO.

oTree = NEW P-TREE(THIS-PROCEDURE).
oTree:NAME          = "Tree".
oTree:X             = 1.
oTree:Y             = 1.
oTree:HEIGHT-PIXELS = 350.
oTree:WIDTH-PIXELS  = 200.
oTree:PARENT        = oFrame.

oRoot = NEW P-TREE-NODE(THIS-PROCEDURE).
oRoot:NAME        = "Root-Node".
oRoot:INPUT-VALUE = "root node".
oRoot:PARENT      = oTree.
oRoot:LEAF-ICON   = J-IMAGE-ICON:LOAD-IMAGE("icons/Tree-Node-Icon.png").
oRoot:LEAF        = NO.


READ-ONLY attribute

Indicates whether INPUT-VALUE of a tree node is write-protected.
Note: The INPUT-VALUE of a P-TREE-NODE is not write-protected (modifiable by user) if and only if READ-ONLY attribute of P-TREE and READ-ONLY attribute of P-TREE-NODE are FALSE.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-TREE-NODE


OPEN-ICON attribute

The open icon of the widget.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-TREE-NODE


LEAF-ICON attribute

The leaf icon of the widget.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-TREE-NODE


LEAF attribute

Indicates whether the leaf is enable.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-TREE-NODE


INPUT-VALUE attribute

The input-value of this tree node.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-TREE-NODE


EXPANDED attribute

Indicates wether the node is expanded.

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-TREE-NODE


EDIT-ICON attribute

The edit icon of the widget.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-TREE-NODE


CLOSE-ICON attribute

The close icon of the widget.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-TREE-NODE


SET-OPEN-POPUP-MENU method

Applies to: P-TREE-NODE
Syntax:
oClass:SET-OPEN-POPUP-MENU(
      POPUP-MENU).

Param | Data type | Description
POPUP-MENU | P-MENU | Set a menu that can popup if this tree node open.


SET-LEAF-POPUP-MENU method

Applies to: P-TREE-NODE
Syntax:
oClass:SET-LEAF-POPUP-MENU(
      POPUP-MENU).

Param | Data type | Description
POPUP-MENU | P-MENU | Set a menu that can popup if this a leaf tree node.


SET-CLOSE-POPUP-MENU method

Applies to: P-TREE-NODE
Syntax:
oClass:SET-CLOSE-POPUP-MENU(
      POPUP-MENU).

Param | Data type | Description
POPUP-MENU | P-MENU | Set a menu that can popup if this tree node closed.


P-TREE class

P-TREE
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

With the P-TREE widget, you can display hierarchical data. Here's a picture of a tree:

As the preceding figure shows, P-TREE displays its data vertically. Each row displayed by the tree contains exactly one item of data, which is called a node. Every tree has a root node from which all nodes descend. By default, the tree displays the root node, but you can decree otherwise. A node can either have children or not. We refer to nodes that can have children - whether or not they currently have children - as branch nodes. Nodes that can't have children are leaf nodes.

Branch nodes can have any number of children. Typically, the user can expand and collapse branch nodes - making their children visible or invisible - by clicking them. By default, all branch nodes except the root node start out collapsed.

Attributes

CLOSE-ICON | EDIT-ICON
LEAF-ICON | NODE-HANDLES-VISIBLE
OPEN-ICON | READ-ONLY
ROOT-HANDLES-VISIBLE | ROW-HEIGHT-PIXELS
SELECTED |
inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

ADD-TO-WHITELIST | CLEAR-WHITELIST
EXPAND-ROW | GET-NODE-AT
REMOVE-FROM-WHITELIST | SELECT-ROW
SET-CLOSE-POPUP-MENU | SET-LEAF-POPUP-MENU
SET-OPEN-POPUP-MENU |
inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

DRAG-OVER | TREE-COLLAPSE
TREE-EXPAND | VALUE-CHANGED
inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY

Example:

/**
 *  The example create a tree widget and a root node.
 */

DEFINE VARIABLE oTree AS P-TREE      NO-UNDO.
DEFINE VARIABLE oRoot AS P-TREE-NODE NO-UNDO.

oTree = NEW P-TREE(THIS-PROCEDURE).
oTree:NAME          = "Tree".
oTree:X             = 1.
oTree:Y             = 1.
oTree:HEIGHT-PIXELS = 350.
oTree:WIDTH-PIXELS  = 200.
oTree:PARENT        = oFrame.

oRoot = NEW P-TREE-NODE(THIS-PROCEDURE).
oRoot:NAME        = "Root-Node".
oRoot:INPUT-VALUE = "root node".
oRoot:PARENT      = oTree.
oRoot:LEAF-ICON   = J-IMAGE-ICON:LOAD-IMAGE("icons/Tree-Node-Icon.png").
oRoot:LEAF        = NO.


SELECTED attribute

The selected tree node.

Data type: | P-TREE-NODE
Access: | Readable / Writeable
Applies to: | P-TREE


ROW-HEIGHT-PIXELS attribute

The row height, in pixels.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-TREE


ROOT-HANDLES-VISIBLE attribute

Indicates whether the handles are displayed at the topmost level of the tree.

A handle is a small icon that displays adjacent to the node which allows the user to click once to expand or collapse the node. A common interface shows a plus sign (+) for a node which can be expanded and a minus sign (-) for a node which can be collapsed. Handles are always shown for nodes below the topmost level.

If the root node is not displayed, then all of its children are at the topmost level of the tree.

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-TREE


READ-ONLY attribute

Indicates whether tree's INPUT-VALUEs are write-protected.
Note: The INPUT-VALUE of a P-TREE-NODE is not write-protected (modifiable by user) if and only if READ-ONLY attribute of P-TREE and READ-ONLY attribute of P-TREE-NODE are FALSE.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-TREE


OPEN-ICON attribute

The default icon of open tree nodes.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-TREE


NODE-HANDLES-VISIBLE attribute

Indicates whether the handles are displayed for any nodes of the tree.

A handle is a small icon that displays adjacent to the node which allows the user to click once to expand or collapse the node. A common interface shows a plus sign (+) for a node which can be expanded and a minus sign (-) for a node which can be collapsed. Handles are always shown for nodes below the topmost level.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-TREE


LEAF-ICON attribute

The default icon of leaf tree nodes.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-TREE


EDIT-ICON attribute

The default icon of an editing tree node.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-TREE


CLOSE-ICON attribute

The default icon of closed tree nodes.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-TREE


SET-OPEN-POPUP-MENU method

Applies to: P-TREE
Syntax:
oClass:SET-OPEN-POPUP-MENU(
      POPUP-MENU).

Param | Data type | Description
POPUP-MENU | P-MENU | Default popup menu for an open tree node.


SET-LEAF-POPUP-MENU method

Applies to: P-TREE
Syntax:
oClass:SET-LEAF-POPUP-MENU(
      POPUP-MENU).

Param | Data type | Description
POPUP-MENU | P-MENU | Default popup menu for a leaf tree node.


SET-CLOSE-POPUP-MENU method

Applies to: P-TREE
Syntax:
oClass:SET-CLOSE-POPUP-MENU(
      POPUP-MENU).

Param | Data type | Description
POPUP-MENU | P-MENU | Default popup menu for a closed tree node.


SELECT-ROW method

Selects the node at the specified row in the display.

Applies to: P-TREE
Syntax:
oClass:SELECT-ROW(
      ROW).

Param | Data type | Description
ROW | integer | The row to select, where 0 is the first row in the display.


REMOVE-FROM-WHITELIST method

Applies to: P-TREE
Syntax:
oClass:REMOVE-FROM-WHITELIST(
      TREENODE).

Param | Data type | Description
TREENODE | P-TREE-NODE | a treenode


GET-NODE-AT method

Return type: P-TREE-NODE
Applies to: P-TREE
Syntax:
oReturn = oClass:GET-NODE-AT(
      X-POSITION, Y-POSITION).

Param | Data type | Description
X-POSITION | integer | x position
Y-POSITION | integer | y position


EXPAND-ROW method

Ensures that the node in the specified row is expanded and viewable.

Applies to: P-TREE
Syntax:
oClass:EXPAND-ROW(
      DISPLAY-ROW).

Param | Data type | Description
DISPLAY-ROW | integer | An integer specifying a display row, where 0 is the first row in the display.


CLEAR-WHITELIST method

Applies to: P-TREE
Syntax:
oClass:CLEAR-WHITELIST(
      ).


ADD-TO-WHITELIST method

Applies to: P-TREE
Syntax:
oClass:ADD-TO-WHITELIST(
      TREENODE).

Param | Data type | Description
TREENODE | P-TREE-NODE | a treenode


P-TOOL-BAR class

P-TOOL-BAR
extended by SC-OBJECT

A tool bar is a container that groups several widgets - usually buttons with icons - into a row or column. Often, tool bars provide easy access to functionality that is also in menus.

There is no need to initialize children widgets' attributes X, Y, WIDTH-PIXELS and HEIGHT-PIXELS. The tool bar will manage the location and size of its widgets.

Attributes

BORDER-PAINTED | HEIGHT-PIXELS
OPAQUE | ORIENTATION
ROLLOVER | TITLE
VISIBLE | WIDTH-PIXELS
X | Y
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

ADD-SEPARATOR

Events

Example:

/**
 *  The example creates a button bar with new button and save button.
 */

DEFINE VARIABLE oToolbar AS P-TOOL-BAR    NO-UNDO.
DEFINE VARIABLE oBtnNew  AS P-Button      NO-UNDO.
DEFINE VARIABLE oBtnSave AS P-Button      NO-UNDO.

oToolbar = NEW P-TOOL-BAR(THIS-PROCEDURE).
oToolbar:Name        = "Tool-Bar".
oToolbar:TITLE       = "Tool-Bar".
oToolbar:ROLLOVER    = YES.
oToolbar:ORIENTATION = "HORIZONTAL".
oToolbar:PARENT      = oWindow.

oBtnNew = NEW P-Button(THIS-PROCEDURE).
oBtnNew:NAME          = "btnew".
oBtnNew:ICON          = J-IMAGE-ICON:LOAD-IMAGE("sc/icons/filenew-small.png").
oBtnNew:TOOLTIP       = "new file".
oBtnNew:PARENT        = oToolbar.
oBtnNew:FLAT-BUTTON   = YES.

oBtnSave = NEW P-Button(THIS-PROCEDURE).
oBtnSave:NAME          = "btsave".
oBtnSave:ICON          = J-IMAGE-ICON:LOAD-IMAGE("sc/icons/filesave-small.png",?).
oBtnSave:TOOLTIP       = "save file".
oBtnSave:PARENT        = oToolbar.
oBtnSave:FLAT-BUTTON   = YES.


Y attribute

The relative y position in pixels of the top widget border.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-TOOL-BAR


X attribute

The relative x position in pixels of the left widget border.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-TOOL-BAR


WIDTH-PIXELS attribute

The width of the widget, in pixels.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-TOOL-BAR


VISIBLE attribute

Indicates whether the widget is currently visible on the display. But a field-level-widget must have a parent to be visible.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-TOOL-BAR


TITLE attribute

The title of the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-TOOL-BAR


ROLLOVER attribute

If the rollover state is true then the border of the toolbar buttons will be drawn only when the mouse pointer hovers over them.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-TOOL-BAR


ORIENTATION attribute

The orientation of the widget.

Data type: value-set
Values:
Value | Description
HORIZONTAL |
VERTICAL |
Access: Readable / Writeable
Applies to: P-TOOL-BAR


OPAQUE attribute

If true the widget paints every pixel within its bounds. Otherwise, the widget may not paint some or all of its pixels, allowing the underlying pixels to show through.

Data type: | boolean
Default value: | \?
Access: | Readable / Writeable
Applies to: | P-TOOL-BAR


HEIGHT-PIXELS attribute

The height of the widget, in pixels.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-TOOL-BAR


BORDER-PAINTED attribute

Indicates whether the border should be painted.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-TOOL-BAR


ADD-SEPARATOR method

Appends a separator of a specified size to the end of the tool bar.

Applies to: P-TOOL-BAR
Syntax:
oClass:ADD-SEPARATOR(
      WIDTH-PIXELS, HEIGHt-PIXELS).

Param | Data type | Description
WIDTH-PIXELS | integer | Separator width, in pixels.
HEIGHt-PIXELS | integer | Separator height, in pixels.


P-TOGGLE-BOX-MENU-ITEM class

P-TOGGLE-BOX-MENU-ITEM
extended by P-MENU-ITEM
extended by SC-OBJECT

Attributes

CHECKED
inherited from P-MENU-ITEM:
DISABLED-ICON | DISABLED-SELECTED-ICON
FONT | ICON
LABEL | PRESSED-ICON
ROLLOVER-ICON | ROLLOVER-SELECTED-ICON
SELECTED-ICON | SENSITIVE
VISIBLE |
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

inherited from P-MENU-ITEM:
SET-ACCELERATOR

Events

CHOOSE
inherited from P-MENU-ITEM:
ANY-KEY | ANY-KEY
CHOOSE |


CHECKED attribute

Indicates whether a widget selected.

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-TOGGLE-BOX-MENU-ITEM


P-TOGGLE-BOX class

P-TOGGLE-BOX
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

A check box is a widget that can be in either an 'on' (true) or 'off' (false) state. Clicking on a check box changes its state from 'on' to 'off', or from 'off' to 'on'.

Attributes

FLIP-FLOP * | INPUT-VALUE
LABEL | OPAQUE
* mandatory (must be set to realise object)
inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

VALUE-CHANGED
inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY

Example:

/**
 *  The example creates a toggle box that is initially checked.
 */

DEFINE VARIABLE oToggleBox AS P-TOGGLE-BOX    NO-UNDO.

oToggleBox = NEW P-TOGGLE-BOX(THIS-PROCEDURE).
oToggleBox:NAME          = "Toggle-Box".
oToggleBox:LABEL         = "Label:".
oToggleBox:HEIGHT-PIXELS = 20.
oToggleBox:WIDTH-PIXELS  = 200.
oToggleBox:Y             = 10.
oToggleBox:X             = 50.
oToggleBox:PARENT        = oFrame.
oToggleBox:INPUT-VALUE   = YES.


OPAQUE attribute

If true the widget paints every pixel within its bounds. Otherwise, the widget may not paint some or all of its pixels, allowing the underlying pixels to show through.

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-TOGGLE-BOX


LABEL attribute

The label of the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-TOGGLE-BOX


INPUT-VALUE attribute

is TRUE if the toggle box is checked else FALSE.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-TOGGLE-BOX


FLIP-FLOP attribute

Displays the toggle-box as a flip-flop button.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-TOGGLE-BOX


P-TEXT class

P-TEXT
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

A display area for a short text string or an image, or both. P-TEXT does not react to input events. As a result, it cannot get the keyboard focus.

Attributes

DATA-TYPE | FORMAT
HORIZONTAL-ALIGNMENT | HORIZONTAL-TEXT-POSITION
ICON | ICON-TEXT-GAP
INPUT-VALUE | MOUSE-OVER-FGCOLOR
OPAQUE | VERTICAL-ALIGNMENT
VERTICAL-TEXT-POSITION |
inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY

Example:

/**
 *  A display area showing "Your Text" in the frame.
 */

DEFINE VARIABLE oText AS P-TEXT    NO-UNDO.

oText = NEW P-TEXT(THIS-PROCEDURE).
oText:NAME            = "Text".
oText:FONT            = oFont.
oText:INPUT-VALUE     = "Your Text".
oText:HEIGHT-PIXELS   = 20.
oText:WIDTH-PIXELS    = 100.
oText:Y               = 10.
oText:X               = 10.
oText:PARENT          = oFrame.


VERTICAL-TEXT-POSITION attribute

The vertical position of the text relative to its icon.

Data type: value-set
Values:
Value | Description
TOP |
CENTER |
BOTTOM |
Access: Readable / Writeable
Applies to: P-TEXT


VERTICAL-ALIGNMENT attribute

The vertical alignment of displayed value and the icon.

Data type: value-set
Values:
Value | Description
TOP |
CENTER |
BOTTOM |
Access: Readable / Writeable
Applies to: P-TEXT


OPAQUE attribute

If true the widget paints every pixel within its bounds. Otherwise, the widget may not paint some or all of its pixels, allowing the underlying pixels to show through.

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-TEXT


MOUSE-OVER-FGCOLOR attribute

The foreground color of displayed value on mouse over.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-TEXT


INPUT-VALUE attribute

The input-value of the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-TEXT


ICON-TEXT-GAP attribute

Gap between icon and displayed value, in pixels

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-TEXT


ICON attribute

The icon of the widget.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-TEXT


HORIZONTAL-TEXT-POSITION attribute

The horizontal position of the text relative to its icon.

Data type: value-set
Values:
Value | Description
RIGHT | Right position in an area.
LEFT | Left position in an area.
CENTER | The central position in an area.
LEADING | Identifies the leading edge of text for use with left-to-right and right-to-left languages.
TRAILING | Identifies the trailing edge of text for use with left-to-right and right-to-left languages.
Access: Readable / Writeable
Applies to: P-TEXT


HORIZONTAL-ALIGNMENT attribute

The horizontal alignment of displayed value and the icon.

Data type: value-set
Values:
Value | Description
RIGHT | Right position in an area.
LEFT | Left position in an area.
CENTER | The central position in an area.
LEADING | Identifies the leading edge of text for use with left-to-right and right-to-left languages.
TRAILING | Identifies the trailing edge of text for use with left-to-right and right-to-left languages.
Access: Readable / Writeable
Applies to: P-TEXT


FORMAT attribute

The FORMAT value is used to format the INPUT-VALUE to the value that will be displayed.

Allowed format depends on the value of attribute DATA-TYPE .

CHARACTER Format

Special Character | Description
~ | Used to quote special characters.
X | Represents any character.
N | Represents a digit or a letter. A space is not allowed.
A | Represents a letter. A space is not allowed.
! | Represents a letter that is converted to uppercase during input. A space is not allowed.
9 | Represents a digit. A space is not allowed.
(n ) | Number indicating how many times to repeat the previous format character. For example, !(5) is the same as !!!!! and represents 5 characters that are to be converted to uppercase when entered.
fillchar | Represents any character or characters you want to fill a display. For example, if you display the value abc with a format of x(3)***, the displayed value is abc***.

NUMERIC Format (also allowed names DECIMAL and INTEGER)

Special Character | Description
~ | Used to quote special characters.
> | Blank shows as absent.
< | Digit, zero shows as absent.
. | Decimal separator.
, | Thousands Separator.

DATE Format

You can specify the following in the format string:
  • The separator character.
  • Whether the year is two-digit or four-digit.
Example | Separator | Year
99-99-99 | - | two-digit
99/99/9999 | / | four-digit

Please note:

  • The order of Year, Month and Day depents on the setting of the client system.

LOGICAL Format

Syntax:
true-string/false-string

One of the two string may be empty.

Please note:

  • For INPUT-VALUE true you can also use the synonyms yes, on and 1.
  • For INPUT-VALUE false you can also use the synonyms no, off and 0.
  • Skin Client always send true, false or /? (unknown value).

Data type: | string
Default value: |
Access: | Readable / Writeable
Applies to: | P-TEXT


DATA-TYPE attribute

Please see the description at FORMAT attribute.

Data type: value-set
Values:
Value | Description
LOGICAL | Allows tree values: TRUE (alias YES), FALSE (alias NO) and unknown value (\?).
CHARACTER | Any string.
NUMERIC | Alias for DECIMAL.
INTEGER | Integer numbers.
DECIMAL | Decimal numbers.
DATE | Year, month and day.
DATETIME | Year, month, day, hours, minutes, esconds and milliseconds.
BLOB | Binary data
Default value: CHARACTER
Access: Readable / Writeable
Applies to: P-TEXT


P-TASKPANEGROUP class

P-TASKPANEGROUP
extended by AJ-CONTAINER
extended by AJ-COMPONENT
extended by SC-OBJECT

Attributes

BODY-BGCOLOR | CHEVRON-BGCOLOR
CHEVRON-BGCOLOR-HOVER | CHEVRON-BORDERCOLOR
CHEVRON-BORDERCOLOR-HOVER | CHEVRON-FGCOLOR
CHEVRON-FGCOLOR-HOVER | EXPANDED
HEADER-BGCOLOR | HEADER-FGCOLOR
HEADER-FGCOLOR-HOVER | ICON
SECOND-HEADER-BGCOLOR | SPECIAL
TITLE |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY


TITLE attribute

Data type: | string
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP


SPECIAL attribute

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP


SECOND-HEADER-BGCOLOR attribute

Second background color of the group-header (if not special).

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP


ICON attribute

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP


HEADER-FGCOLOR-HOVER attribute

Foreground color of the group-header on mouse over.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP


HEADER-FGCOLOR attribute

Foreground color of the group-header.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP


HEADER-BGCOLOR attribute

Background color of the group-header.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP


EXPANDED attribute

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP


CHEVRON-FGCOLOR-HOVER attribute

Foreground color of the chevron in group-header on mouse over.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP


CHEVRON-FGCOLOR attribute

Foreground color of the chevron in group-header.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP


CHEVRON-BORDERCOLOR-HOVER attribute

Border color of the chevron in group-header on mouse over.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP


CHEVRON-BORDERCOLOR attribute

Border color of the chevron in group-header.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP


CHEVRON-BGCOLOR-HOVER attribute

Background color of the chevron in group-header on mouse over.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP


CHEVRON-BGCOLOR attribute

Background color of the chevron in group-header.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP


BODY-BGCOLOR attribute

Background color of the group-body.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP


P-TASKPANE class

P-TASKPANE
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

Attributes

inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY


P-TAB-FRAME class

P-TAB-FRAME
extended by P-FRAME
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

A P-TAB-FRAME is a tab page within a P-TABBED-PANE .

Attributes

CLOSABLE | TAB-ICON
TAB-INDEX | TAB-TITLE
TAB-TOOLTIP |
inherited from P-FRAME:
ANCHORS | BGCOLOR2
BGIMAGE | BORDER-COLOR
BOX | EDGE-PIXELS
H-BLOCK-INC | H-UNIT-INC
RADIUS-PIXELS | SCROLLABLE
TITLE | TITLE-BGCOLOR
TITLE-FGCOLOR | TITLE-FONT
UPDATE-LOCKED | V-BLOCK-INC
VERTICAL-GRADIENT | VIRTUAL-HEIGHT-PIXELS
VIRTUAL-WIDTH-PIXELS | V-UNIT-INC
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

inherited from P-FRAME:
REMOVE-GRADIENT-PAINT | SCROLL-TO-COORDINATES
SCROLL-TO-LEFT-UPPER-CORNER | SCROLL-TO-VISIBLE
SET-GRADIENT-PAINT | SET-PREFERRED-SIZE
inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

inherited from P-FRAME:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY

Example:

DEFINE VARIABLE oTabFrame AS P-TAB-FRAME    NO-UNDO.

oTabFrame = NEW P-TAB-FRAME(THIS-PROCEDURE).
oTabFrame:NAME      = "Tab-Frame".
oTabFrame:TAB-TITLE = "Tab Title".
oTabFrame:PARENT    = oTabbedPane.


TAB-TOOLTIP attribute

The tooltip of the tab.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-TAB-FRAME


TAB-TITLE attribute

The title of the tab.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-TAB-FRAME


TAB-INDEX attribute

The index within the P-TABBED-PANE .

Data type: | integer
Default value: | 0
Access: | Readable
Applies to: | P-TAB-FRAME


TAB-ICON attribute

The icon of the tab.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-TAB-FRAME


CLOSABLE attribute

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-TAB-FRAME


P-TABBED-PANE class

P-TABBED-PANE
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

With the tabbed pane class, you can have several P-TAB-FRAMEs share the same space. The user chooses which tab to view by simply selecting the desired tab.

Attributes

INNER-HEIGHT | LABELS
LAYOUT | SELECTED
SELECTED-INDEX | TAB-NUM
TAB-PLACEMENT | TABS-CLOSABLE
inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

SET-CLOSABLE-AT | SET-ICON-AT
SET-TITLE-AT | SET-TOOLTIP-AT
inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

CHOOSE | INNER-HEIGHT-CHANGED
LEFT-MOUSE-DBLCLICK | TAB-CLOSE
TAB-NUM-CHANGED |
inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY

Example:

/**
 *  The example create a tabbed pane.
 */

DEFINE VARIABLE oTabbedPane AS P-TABBED-PANE    NO-UNDO.

oTabbedPane = NEW P-TABBED-PANE(THIS-PROCEDURE).
oTabbedPane:NAME          = "Tabbed-Pane".
oTabbedPane:PARENT        = oFrame.
oTabbedPane:X             = 5.
oTabbedPane:Y             = 5.
oTabbedPane:WIDTH-PIXELS  = 500.
oTabbedPane:HEIGHT-PIXELS = 300.


TABS-CLOSABLE attribute

indicates if tabs may contain a close-button

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-TABBED-PANE


TAB-PLACEMENT attribute

The placement of the tabs.

Data type: value-set
Values:
Value | Description
TOP | Tabs are shown on widget's top.
BOTTOM | Tabs are shown on widget's bottom.
LEFT | Tabs are shown on widget's left.
RIGHT | Tabs are shown on widget's right.
Access: Readable / Writeable
Applies to: P-TABBED-PANE


TAB-NUM attribute

Number of the tabs.

Data type: | integer
Default value: | 0
Access: | Readable
Applies to: | P-TABBED-PANE


SELECTED-INDEX attribute

Index number from the selected tab. First tab has index 1.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-TABBED-PANE


SELECTED attribute

The selected P-TAB-FRAME

Data type: | AJ-COMPONENT
Access: | Readable / Writeable
Applies to: | P-TABBED-PANE


LAYOUT attribute

Sets the policy which the tabbedpane will use in laying out the tabs when all the tabs will not fit within a single run.

Data type: value-set
Values:
Value | Description
WRAP-TAB-LAYOUT | Tabs are divided in multible runs.
SCROLL-TAB-LAYOUT | All tabs will be in a single run (scrollable).
Default value: WRAP-TAB-LAYOUT
Access: Readable / Writeable
Applies to: P-TABBED-PANE


LABELS attribute

List of tab labels. The DELIMITER is used to separated the list items.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-TABBED-PANE


INNER-HEIGHT attribute

The height of the area available to components on a tabbed pane.

This value is only valid, if at least on tab has been added to the tabbed pane.

Data type: | integer
Default value: | 0
Access: | Readable
Applies to: | P-TABBED-PANE


SET-TOOLTIP-AT method

Set the tooltip of the tab specified by tab index.

See also attribute TAB-TOOLTIP of P-TAB-FRAME.

Applies to: P-TABBED-PANE
Syntax:
oClass:SET-TOOLTIP-AT(
      TAB-INDEX, TOOLTIP).

Param | Data type | Description
TAB-INDEX | integer | tab index
TOOLTIP | string | tooltip


SET-TITLE-AT method

Set the title of the tab specified by tab index.

See also attribute TAB-TITLE of P-TAB-FRAME.

Applies to: P-TABBED-PANE
Syntax:
oClass:SET-TITLE-AT(
      TAB-INDEX, TITLE).

Param | Data type | Description
TAB-INDEX | integer | tab index
TITLE | string | title


SET-ICON-AT method

Set the icon of the tab specified by tab index.

See also attribute TAB-ICON of P-TAB-FRAME.

Applies to: P-TABBED-PANE
Syntax:
oClass:SET-ICON-AT(
      TAB-INDEX, ICON).

Param | Data type | Description
TAB-INDEX | integer | tab index
ICON | A-ICON | icon


SET-CLOSABLE-AT method

Applies to: P-TABBED-PANE
Syntax:
oClass:SET-CLOSABLE-AT(
      TAB-INDEX, CLOSABLE).

Param | Data type | Description
TAB-INDEX | integer | tab index
CLOSABLE | boolean | closable


P-SPLIT-PANE class

P-SPLIT-PANE
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

A split pane displays two widgets (usually frames), either side by side or one on top of the other. By dragging the divider that appears between the widgets, the user can specify how much of the split pane's total area goes to each widget. You can divide screen space among three or more widgets by putting split panes inside of split panes.

Please note that the size of the both widgets (defined via FIRST and SECOND) is controlled by the split pane. The attributes WIDTH-PIXELS and HEIGHT-PIXELS of the both widgets will be ignored.

Attributes

COLLAPSED-INDEX | DIVIDER-POS
DIVIDER-SENSITIVE | DIVIDER-SIZE
FIRST | MIN-SIZE-FIRST
MIN-SIZE-SECOND | ORIENTATION
RESIZE-WEIGHT | SECOND
inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

VALUE-CHANGED
inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY

Example:

/**
 *  The example create a split pane. The first frame will be on the left
 *  the second frame on the right side. Because that is the default orientation.
 */

DEFINE VARIABLE oSplitPane AS P-SPLIT-PANE    NO-UNDO.

oSplitPane = NEW P-SPLIT-PANE(THIS-PROCEDURE).
oSplitPane:NAME          = "Split-Pane".
oSplitPane:HEIGHT-PIXELS   = 180.
oSplitPane:WIDTH-PIXELS    = 640.
oSplitPane:Y               = 5.
oSplitPane:X               = 5.
oSplitPane:PARENT          = oFrame.
oSplitPane:FIRST           = oFrameFirst.
oSplitPane:SECOND          = oFrameSecond.
oSplitPane:DIVIDER-POS     = 320.


SECOND attribute

Widget on the right/bottom.

Data type: | AJ-COMPONENT
Access: | Readable / Writeable
Applies to: | P-SPLIT-PANE


RESIZE-WEIGHT attribute

This attribute is used to define, what happens when the P-SPLIT-PANE gets resized, what to do with the resulting difference.

The value indicates how much of the difference (in percent) is used to resize the FIRST component

Examples:

0 - The FIRST component keeps its size while the SECOND gets resized

100 - The SECOND component keeps its size while the FIRST gets resized

50 - The FIRST and SECOND component get resized equally

30 - The FIRST gets resized by 30% of the difference while the SECOND gets resized by 70%

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-SPLIT-PANE


ORIENTATION attribute

Orientation of the two widgets FIRST and SECOND .

Data type: value-set
Values:
Value | Description
VERTICAL | FIRST widget is above and SECOND widget is below.
HORIZONTAL | FIRST widget is left and SECOND widget is right.
Default value: HORIZONTAL
Access: Readable / Writeable
Applies to: P-SPLIT-PANE


MIN-SIZE-SECOND attribute

The minimum width / height of the right- / bottom-component

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-SPLIT-PANE


MIN-SIZE-FIRST attribute

The minimum width / height of the left- / top-component

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-SPLIT-PANE


FIRST attribute

Widget on the left/top.

Data type: | AJ-COMPONENT
Access: | Readable / Writeable
Applies to: | P-SPLIT-PANE


DIVIDER-SIZE attribute

The size of the divider, in pixels.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-SPLIT-PANE


DIVIDER-SENSITIVE attribute

Indicates if the divider can be moved

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-SPLIT-PANE


DIVIDER-POS attribute

The position of the divider, in pixels.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-SPLIT-PANE


COLLAPSED-INDEX attribute

Indicates which child-widget should be collapsed.
Possible values:
0: No widget is collapsed and the divider can be used to partition the available space
1: The FIRST widget gets hidden and the SECOND widget uses all the available space
2: The SECOND widget gets hidden and the FIRST widget uses all the available space

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-SPLIT-PANE


P-SHORTCUT-BAR class

P-SHORTCUT-BAR
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

Attributes

SELECTED-INDEX
inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

SET-BUTTON-COLORS | SET-BUTTON-FONT
SET-HEADER-COLORS | SET-HEADER-FONT
SET-ICON-AT | SET-MOUSE-OVER-COLOR
SET-SELECTION-COLOR | SET-TITLE-AT
SET-TOOLTIP-AT | SET-VISIBLE-COUNT
inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

CHOOSE
inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY


SELECTED-INDEX attribute

Index of selected tab

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-SHORTCUT-BAR


SET-VISIBLE-COUNT method

Sets number of visible tab-buttons to display

Applies to: P-SHORTCUT-BAR
Syntax:
oClass:SET-VISIBLE-COUNT(
      TAB-COUNT).

Param | Data type | Description
TAB-COUNT | integer | tab count


SET-TOOLTIP-AT method

Set the tooltip of the tab specified by tab index.

See also attribute TAB-TOOLTIP of P-TAB-FRAME.

Applies to: P-SHORTCUT-BAR
Syntax:
oClass:SET-TOOLTIP-AT(
      TAB-INDEX, TOOLTIP).

Param | Data type | Description
TAB-INDEX | integer | tab index
TOOLTIP | string | tooltip


SET-TITLE-AT method

Set the title of the tab specified by tab index.

See also attribute TAB-TITLE of P-TAB-FRAME.

Applies to: P-SHORTCUT-BAR
Syntax:
oClass:SET-TITLE-AT(
      TAB-INDEX, TITLE).

Param | Data type | Description
TAB-INDEX | integer | tab index
TITLE | string | title


SET-SELECTION-COLOR method

sets the color used to indicate tab-selection

Applies to: P-SHORTCUT-BAR
Syntax:
oClass:SET-SELECTION-COLOR(
      COLOR, ALPHA-VALUE).

Param | Data type | Description
COLOR | J-COLOR | color
ALPHA-VALUE | integer | alpha-value (0 to 255)


SET-MOUSE-OVER-COLOR method

sets the color used for mouse-over efects

Applies to: P-SHORTCUT-BAR
Syntax:
oClass:SET-MOUSE-OVER-COLOR(
      COLOR, ALPHA-VALUE).

Param | Data type | Description
COLOR | J-COLOR | color
ALPHA-VALUE | integer | alpha-value (0 to 255)


SET-ICON-AT method

Set the icon of the tab specified by tab index.

See also attribute TAB-ICON of P-TAB-FRAME.

Applies to: P-SHORTCUT-BAR
Syntax:
oClass:SET-ICON-AT(
      TAB-INDEX, ICON).

Param | Data type | Description
TAB-INDEX | integer | tab index
ICON | A-ICON | icon


SET-HEADER-FONT method

sets the font used for tab-headers

Applies to: P-SHORTCUT-BAR
Syntax:
oClass:SET-HEADER-FONT(
      FONT).

Param | Data type | Description
FONT | J-FONT | font


SET-HEADER-COLORS method

sets the colors used for tab-headers

Applies to: P-SHORTCUT-BAR
Syntax:
oClass:SET-HEADER-COLORS(
      BG-COLOR1, BG-COLOR2, BG-COLOR3).

Param | Data type | Description
BG-COLOR1 | J-COLOR | background-color 1
BG-COLOR2 | J-COLOR | background-color 2
BG-COLOR3 | J-COLOR | foreground color


SET-BUTTON-FONT method

sets the font used for tab-buttons

Applies to: P-SHORTCUT-BAR
Syntax:
oClass:SET-BUTTON-FONT(
      FONT).

Param | Data type | Description
FONT | J-FONT | font


SET-BUTTON-COLORS method

sets the colors used for tab-buttons

Applies to: P-SHORTCUT-BAR
Syntax:
oClass:SET-BUTTON-COLORS(
      BG-COLOR1, BG-COLOR2, BG-COLOR3).

Param | Data type | Description
BG-COLOR1 | J-COLOR | background-color 1
BG-COLOR2 | J-COLOR | background-color 2
BG-COLOR3 | J-COLOR | foreground color


P-SEPARATOR class

P-SEPARATOR
extended by SC-OBJECT

Attributes

VISIBLE
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

Events


VISIBLE attribute

Indicates whether the separator is visible.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-SEPARATOR


P-SELECTION-LIST class

P-SELECTION-LIST
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

A widget that allows the user to select one or more items from a list.

Attributes

INPUT-VALUE | LABEL
LABEL-BGCOLOR | LABEL-FGCOLOR
LABEL-FONT | LAYOUT-ORIENTATION
LIST-ITEM-PAIRS | LIST-ITEMS
MULTIPLE | VISIBLE-ROW-COUNT
inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

SET-ICON
inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

VALUE-CHANGED
inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY

Example:

/**
 *  The example create a selection list with three items.
 */

DEFINE VARIABLE oSelectionList AS P-SELECTION-LIST    NO-UNDO.

oSelectionList = NEW P-SELECTION-LIST(THIS-PROCEDURE).
oSelectionList:NAME            = "Selection-List".
oSelectionList:HEIGHT-PIXELS   = 130.
oSelectionList:WIDTH-PIXELS    = 150.
oSelectionList:Y               = 5.
oSelectionList:X               = 5.
oSelectionList:PARENT          = oFrame.
oSelectionList:LIST-ITEM-PAIRS = "Item1,I1,Item2,I2,Item3,I3".


VISIBLE-ROW-COUNT attribute

Data type: | integer
Default value: | 8
Access: | Readable / Writeable
Applies to: | P-SELECTION-LIST


MULTIPLE attribute

The MULTIPLE attribute specifies whether the user can select multiple items from the widget, or only a single item.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-SELECTION-LIST


LIST-ITEMS attribute

A list of the items associated with a selection list. The list is delimiter-separated.

Note: The LIST-ITEMS attribute applies only to selection lists whose entries consist of single items. For selection lists whose entries consist of label-value pairs, use the LIST-ITEM-PAIRS attribute.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-SELECTION-LIST


LIST-ITEM-PAIRS attribute

A list of the label-value pairs associated with a selection list. The list is delimiter-separated.

Note: The LIST-ITEM-PAIRS attribute applies only to selection lists whose entries consist of label-value pairs. For selection lists whose entries consist of single items, use the LIST-ITEMS attribute.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-SELECTION-LIST


LAYOUT-ORIENTATION attribute

Data type: value-set
Values:
Value | Description
VERTICAL |
VERTICAL-WRAP |
HORIZONTAL-WRAP |
Access: Readable / Writeable
Applies to: P-SELECTION-LIST


LABEL-FONT attribute

The font of widget's label.

Data type: | J-FONT
Access: | Readable / Writeable
Applies to: | P-SELECTION-LIST


LABEL-FGCOLOR attribute

The color of widget's label.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-SELECTION-LIST


LABEL-BGCOLOR attribute

The background color of widget's label.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-SELECTION-LIST


LABEL attribute

The label of the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-SELECTION-LIST


INPUT-VALUE attribute

The input-value of the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-SELECTION-LIST


SET-ICON method

Assign a icon that should be display with the specified input value. To remove a icon assign a unknown value (\?).

Applies to: P-SELECTION-LIST
Syntax:
oClass:SET-ICON(
      INPUT-VALUE, ICON).

Param | Data type | Description
INPUT-VALUE | string | Input value.
ICON | A-ICON | Icon to be displayed, if specified input value is shown.


P-SCHEDULER-TASK class

P-SCHEDULER-TASK
extended by AJ-CONTAINER
extended by AJ-COMPONENT
extended by SC-OBJECT

Attributes

BGCOLOR | BGCOLOR2
COL | HEIGHT
MOVE-PERMISSION | RESIZE-PERMISSION
ROW | SELECTED
TOOLTIP | WIDTH
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

SET-LOCATION SET-SIZE
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

END-MOVE | END-RESIZE
MOVED | RESIZED
VALUE-CHANGED |
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY


WIDTH attribute

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-SCHEDULER-TASK


TOOLTIP attribute

Data type: | string
Access: | Readable / Writeable
Applies to: | P-SCHEDULER-TASK


SELECTED attribute

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-SCHEDULER-TASK


ROW attribute

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-SCHEDULER-TASK


RESIZE-PERMISSION attribute

Data type: value-set
Values:
Value | Description
WIDTH-ONLY |
HEIGHT-ONLY |
BOTH |
NONE |
Default value: BOTH
Access: Readable / Writeable
Applies to: P-SCHEDULER-TASK


MOVE-PERMISSION attribute

Data type: value-set
Values:
Value | Description
COL-ONLY |
ROW-ONLY |
BOTH |
NONE |
Default value: BOTH
Access: Readable / Writeable
Applies to: P-SCHEDULER-TASK


HEIGHT attribute

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-SCHEDULER-TASK


COL attribute

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-SCHEDULER-TASK


BGCOLOR2 attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-SCHEDULER-TASK


BGCOLOR attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-SCHEDULER-TASK


SET-SIZE method

Applies to: P-SCHEDULER-TASK
Syntax:
oClass:SET-SIZE(
      WIDTH-PIXELS, HEIGHT-PIXELS).

Param | Data type | Description
WIDTH-PIXELS | integer |
HEIGHT-PIXELS | integer |


SET-LOCATION method

Applies to: P-SCHEDULER-TASK
Syntax:
oClass:SET-LOCATION(
      X-POSITION, Y-POSITION).

Param | Data type | Description
X-POSITION | integer |
Y-POSITION | integer |


P-SCHEDULER class

P-SCHEDULER
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

Attributes

CELL-SELECTION | COL-LABEL-ALIGNMENT
COL-LABEL-BGCOLOR | COL-LABEL-FGCOLOR
COL-LABEL-HEIGHT | COL-LABELS
COL-RESIZE-MODE | COL-WIDTH
GRID-BGCOLOR | H-SEPARATOR-COLOR
H-SEPARATORS | NUM-COLS
NUM-ROWS | NUM-VISIBLE-COLS
NUM-VISIBLE-ROWS | ROW-HEIGHT
ROW-LABEL-ALIGNMENT | ROW-LABEL-BGCOLOR
ROW-LABEL-FGCOLOR | ROW-LABELS
ROW-LABEL-WIDTH | ROW-RESIZE-MODE
SELECTED-TASK | SELECTION-COLOR
SHADOW-COLOR | SHADOW-SIZE
V-SEPARATOR-COLOR | V-SEPARATORS
inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

GET-COL-LABEL-AT | GET-ROW-LABEL-AT
SCROLL-TO | SET-COL-LABEL-AT
SET-COL-LABEL-BGCOLOR-AT | SET-COL-LABEL-FGCOLOR-AT
SET-ROW-LABEL-AT | SET-ROW-LABEL-BGCOLOR-AT
SET-ROW-LABEL-FGCOLOR-AT |
inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

CELL-CLICK | CELL-DBLCLICK
COL-LABEL-CLICK | COL-LABEL-DBLCLICK
ROW-LABEL-CLICK | ROW-LABEL-DBLCLICK
VALUE-CHANGED |
inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY


V-SEPARATORS attribute

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-SCHEDULER


V-SEPARATOR-COLOR attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-SCHEDULER


SHADOW-SIZE attribute

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-SCHEDULER


SHADOW-COLOR attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-SCHEDULER


SELECTION-COLOR attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-SCHEDULER


SELECTED-TASK attribute

Data type: | P-SCHEDULER-TASK
Access: | Readable / Writeable
Applies to: | P-SCHEDULER


ROW-RESIZE-MODE attribute

Data type: value-set
Values:
Value | Description
FIXED-ROW-HEIGHT |
FIXED-VISIBLE-ROW-COUNT |
Default value: FIXED-ROW-HEIGHT
Access: Readable / Writeable
Applies to: P-SCHEDULER


ROW-LABEL-WIDTH attribute

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-SCHEDULER


ROW-LABELS attribute

Data type: | string
Access: | Readable / Writeable
Applies to: | P-SCHEDULER


ROW-LABEL-FGCOLOR attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-SCHEDULER


ROW-LABEL-BGCOLOR attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-SCHEDULER


ROW-LABEL-ALIGNMENT attribute

Data type: value-set
Values:
Value | Description
RIGHT | Right position in an area.
LEFT | Left position in an area.
CENTER | The central position in an area.
LEADING | Identifies the leading edge of text for use with left-to-right and right-to-left languages.
TRAILING | Identifies the trailing edge of text for use with left-to-right and right-to-left languages.
Access: Readable / Writeable
Applies to: P-SCHEDULER


ROW-HEIGHT attribute

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-SCHEDULER


NUM-VISIBLE-ROWS attribute

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-SCHEDULER


NUM-VISIBLE-COLS attribute

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-SCHEDULER


NUM-ROWS attribute

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-SCHEDULER


NUM-COLS attribute

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-SCHEDULER


H-SEPARATORS attribute

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-SCHEDULER


H-SEPARATOR-COLOR attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-SCHEDULER


GRID-BGCOLOR attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-SCHEDULER


COL-WIDTH attribute

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-SCHEDULER


COL-RESIZE-MODE attribute

Data type: value-set
Values:
Value | Description
FIXED-COL-WIDTH |
FIXED-VISIBLE-COL-COUNT |
Default value: FIXED-VISIBLE-COL-COUNT
Access: Readable / Writeable
Applies to: P-SCHEDULER


COL-LABELS attribute

Data type: | string
Access: | Readable / Writeable
Applies to: | P-SCHEDULER


COL-LABEL-HEIGHT attribute

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-SCHEDULER


COL-LABEL-FGCOLOR attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-SCHEDULER


COL-LABEL-BGCOLOR attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-SCHEDULER


COL-LABEL-ALIGNMENT attribute

Data type: value-set
Values:
Value | Description
RIGHT | Right position in an area.
LEFT | Left position in an area.
CENTER | The central position in an area.
LEADING | Identifies the leading edge of text for use with left-to-right and right-to-left languages.
TRAILING | Identifies the trailing edge of text for use with left-to-right and right-to-left languages.
Access: Readable / Writeable
Applies to: P-SCHEDULER


CELL-SELECTION attribute

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-SCHEDULER


SET-ROW-LABEL-FGCOLOR-AT method

Applies to: P-SCHEDULER
Syntax:
oClass:SET-ROW-LABEL-FGCOLOR-AT(
      ROW, FG-COLOR).

Param | Data type | Description
ROW | integer |
FG-COLOR | J-COLOR |


SET-ROW-LABEL-BGCOLOR-AT method

Applies to: P-SCHEDULER
Syntax:
oClass:SET-ROW-LABEL-BGCOLOR-AT(
      ROW, BG-COLOR).

Param | Data type | Description
ROW | integer |
BG-COLOR | J-COLOR |


SET-ROW-LABEL-AT method

Applies to: P-SCHEDULER
Syntax:
oClass:SET-ROW-LABEL-AT(
      ROW, LABEL).

Param | Data type | Description
ROW | integer |
LABEL | string |


SET-COL-LABEL-FGCOLOR-AT method

Applies to: P-SCHEDULER
Syntax:
oClass:SET-COL-LABEL-FGCOLOR-AT(
      COLUMN, FG-COLOR).

Param | Data type | Description
COLUMN | integer |
FG-COLOR | J-COLOR |


SET-COL-LABEL-BGCOLOR-AT method

Applies to: P-SCHEDULER
Syntax:
oClass:SET-COL-LABEL-BGCOLOR-AT(
      COLUMN, BG-COLOR).

Param | Data type | Description
COLUMN | integer |
BG-COLOR | J-COLOR |


SET-COL-LABEL-AT method

Applies to: P-SCHEDULER
Syntax:
oClass:SET-COL-LABEL-AT(
      COLUMN, LABEL).

Param | Data type | Description
COLUMN | integer |
LABEL | string |


SCROLL-TO method

Applies to: P-SCHEDULER
Syntax:
oClass:SCROLL-TO(
      COLUMN, ROW).

Param | Data type | Description
COLUMN | integer | column
ROW | integer | row


GET-ROW-LABEL-AT method

Return type: string
Applies to: P-SCHEDULER
Syntax:
_ret = oClass:GET-ROW-LABEL-AT(
      ROW).

Param | Data type | Description
ROW | integer |


GET-COL-LABEL-AT method

Return type: string
Applies to: P-SCHEDULER
Syntax:
_ret = oClass:GET-COL-LABEL-AT(
      COLUMN).

Param | Data type | Description
COLUMN | integer |


P-RTF-EDITOR class

P-RTF-EDITOR
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

Editor widget used to display and edit text in Rich-Text

Attributes

BGCOLOR | CONTENT-TYPE *
READ-ONLY | TOOLBAR-BGCOLOR
TOOL-BAR-VISIBLE |
* mandatory (must be set to realise object)
inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

CLEAR-TEXT | LOAD-FROM-BINARY
LOAD-FROM-FILE | LOAD-FROM-STRING
SAVE-TO-BINARY | SAVE-TO-FILE
SAVE-TO-STRING | SET-CURRENT-ALIGNMENT
SET-CURRENT-FONT |
inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY


TOOL-BAR-VISIBLE attribute

Indicates if the editors toolbar is visible

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-RTF-EDITOR


TOOLBAR-BGCOLOR attribute

Specifies the background-color of the toolbar

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-RTF-EDITOR


READ-ONLY attribute

Indicates if the editor is read-only

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-RTF-EDITOR


CONTENT-TYPE attribute

Indicates the content type of the editor.

Data type: value-set
Values:
Value | Description
HTML | Enables HTML 3.2 support.
RTF | Enables limited support of the Rich Text Format.
Access: Readable / Writeable
Applies to: P-RTF-EDITOR


BGCOLOR attribute

Specifies the background-color of the text

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-RTF-EDITOR


SET-CURRENT-FONT method

Sets the font used for current selection / location

Applies to: P-RTF-EDITOR
Syntax:
oClass:SET-CURRENT-FONT(
      FONT).

Param | Data type | Description
FONT | J-FONT | font to set


SET-CURRENT-ALIGNMENT method

Sets the alignment used for the current paragraph

Applies to: P-RTF-EDITOR
Syntax:
oClass:SET-CURRENT-ALIGNMENT(
      ALIGN).
Param Data type Description
ALIGN value-set child component

Values:

Value | Description
LEFT |
CENTER |
RIGHT |


SAVE-TO-STRING method

Saves text of the given content type and returns it as a string

Return type: string
Applies to: P-RTF-EDITOR
Syntax:
_ret = oClass:SAVE-TO-STRING(
      ).


SAVE-TO-FILE method

Saves text of the given content type to the given local file.
Returns TRUE on success, FALSE otherwise

Return type: boolean
Applies to: P-RTF-EDITOR
Syntax:
_ret = oClass:SAVE-TO-FILE(
      FILE).

Param | Data type | Description
FILE | J-FILE |


SAVE-TO-BINARY method

Saves text of the given content type to the given binary object
Returns TRUE on success, FALSE otherwise

Return type: boolean
Applies to: P-RTF-EDITOR
Syntax:
_ret = oClass:SAVE-TO-BINARY(
      BINARY).

Param | Data type | Description
BINARY | J-BINARY |


LOAD-FROM-STRING method

Loads text of the given content type using the given string
Returns TRUE on success, FALSE otherwise

Return type: boolean
Applies to: P-RTF-EDITOR
Syntax:
_ret = oClass:LOAD-FROM-STRING(
      STRING).

Param | Data type | Description
STRING | string |


LOAD-FROM-FILE method

Loads text of the given content type from the given local file
Returns TRUE on success, FALSE otherwise

Return type: boolean
Applies to: P-RTF-EDITOR
Syntax:
_ret = oClass:LOAD-FROM-FILE(
      FILE).

Param | Data type | Description
FILE | J-FILE |


LOAD-FROM-BINARY method

Loads text of the given content type using the given binary object
Returns TRUE on success, FALSE otherwise

Return type: boolean
Applies to: P-RTF-EDITOR
Syntax:
_ret = oClass:LOAD-FROM-BINARY(
      BINARY).

Param | Data type | Description
BINARY | J-BINARY |


CLEAR-TEXT method

Removes all text

Applies to: P-RTF-EDITOR
Syntax:
oClass:CLEAR-TEXT(
      ).


P-RECTANGLE class

P-RECTANGLE
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

With a rectangle you may adorn an area of a frame:

Attributes

BGCOLOR2 | EDGE-PIXELS
LABEL | LABEL-BGCOLOR
LABEL-FGCOLOR | LABEL-FONT
LABEL-ON-TOP | RADIUS-PIXELS
ROUNDED | VERTICAL-GRADIENT
inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY

Example:

/**
 *  The example creates a new rectangle.
 */

DEFINE VARIABLE oRectangle AS P-RECTANGLE    NO-UNDO.

oRectangle = NEW P-RECTANGLE(THIS-PROCEDURE).
oRectangle:NAME          = "Rectangle".
oRectangle:HEIGHT-PIXELS   = 90.
oRectangle:WIDTH-PIXELS    = 100.
oRectangle:Y               = 5.
oRectangle:X               = 5.
oRectangle:PARENT          = oFrame.


VERTICAL-GRADIENT attribute

Indicates whether the gradient of the background is vertical (true) or horizontal (false)

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-RECTANGLE


ROUNDED attribute

DEPRECATED! Use RADIUS-PIXELS

Indicates whether rectangle has rounded corners.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-RECTANGLE


RADIUS-PIXELS attribute

The radius in pixels of the rectangle corners. (0 for angular corners)

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-RECTANGLE


LABEL-ON-TOP attribute

Indicates whether the label should get painted on top of the border

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-RECTANGLE


LABEL-FONT attribute

The font of rectangle's label.

Data type: | J-FONT
Access: | Readable / Writeable
Applies to: | P-RECTANGLE


LABEL-FGCOLOR attribute

The color of rectangle's label.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-RECTANGLE


LABEL-BGCOLOR attribute

The background color of rectangle's label.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-RECTANGLE


LABEL attribute

The label of the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-RECTANGLE


EDGE-PIXELS attribute

The border-width in pixels

Data type: | integer
Default value: | 1
Access: | Readable / Writeable
Applies to: | P-RECTANGLE


BGCOLOR2 attribute

The second color of the rectangle used together with BGCOLOR to fill the background with a gradient

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-RECTANGLE


P-RADIO-SET class

P-RADIO-SET
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

A radio set is a group of values of which only one can be set at any time.

Attributes

HORIZONTAL | INPUT-VALUE
LABEL | LABEL-BGCOLOR
LABEL-FGCOLOR | LABEL-FONT
RADIO-BUTTONS |
inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

ENABLE-BUTTON
inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

VALUE-CHANGED
inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY

Example:

DEFINE VARIABLE oRadioSet AS P-RADIO-SET    NO-UNDO.

oRadioSet = NEW P-RADIO-SET(THIS-PROCEDURE).
oRadioSet:NAME          = "Rectangle".
oRadioSet:X             = 5.
oRadioSet:Y             = 5.
oRadioSet:HEIGHT-PIXELS = 90.
oRadioSet:WIDTH-PIXELS  = 100.
oRadioSet:LABEL         = "Label:".
oRadioSet:RADIO-BUTTONS = "Red,1,Green,2,Blue,3".
oRadioSet:PARENT        = oFrame.
oRadioSet:HORIZONTAL    = NO.


RADIO-BUTTONS attribute

List: button-1-label, button-1-value, button-2-label, button-2-value, ... etc.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-RADIO-SET


LABEL-FONT attribute

The font of widget's label.

Data type: | J-FONT
Access: | Readable / Writeable
Applies to: | P-RADIO-SET


LABEL-FGCOLOR attribute

The color of widget's label.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-RADIO-SET


LABEL-BGCOLOR attribute

The background color of widget's label.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-RADIO-SET


LABEL attribute

The label of the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-RADIO-SET


INPUT-VALUE attribute

The input-value of the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-RADIO-SET


HORIZONTAL attribute

The orientation of radio buttons.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-RADIO-SET


ENABLE-BUTTON method

Enables / Disables a single button referenced by its label

Applies to: P-RADIO-SET
Syntax:
oClass:ENABLE-BUTTON(
      BUTTON-LABEL, ENABLED).

Param | Data type | Description
BUTTON-LABEL | string | Button label
ENABLED | boolean | indicates if this button should be enabled


P-PROGRESS-BAR class

P-PROGRESS-BAR
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

A widget that, by default, displays an integer value within a bounded interval. A progress bar typically communicates the progress of some work by displaying its percentage of completion and possibly a textual display of this percentage.

Attributes

INPUT-VALUE | MAX
MIN | ORIENTATION
TEXT-VISIBLE |
inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY

Example:

/**
 *  The example create a progess bar to displays an integer value within 0 and 100.
 */

DEFINE VARIABLE oProgressBar AS P-PROGRESS-BAR      NO-UNDO.

oProgressBar = NEW P-PROGRESS-BAR(THIS-PROCEDURE).
oProgressBar:NAME          = "Progress-Bar".
oProgressBar:HEIGHT-PIXELS = 20.
oProgressBar:WIDTH-PIXELS  = 300.
oProgressBar:Y             = 10.
oProgressBar:X             = 10.
oProgressBar:ORIENTATION   = "HORIZONTAL".
oProgressBar:MIN           = 0.
oProgressBar:MAX           = 100.
oProgressBar:PARENT        = oFrame.


TEXT-VISIBLE attribute

Indicates whether the text is visible.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-PROGRESS-BAR


ORIENTATION attribute

The orientation of the widget.

Data type: value-set
Values:
Value | Description
HORIZONTAL |
VERTICAL |
Access: Readable / Writeable
Applies to: P-PROGRESS-BAR


MIN attribute

The minimum value of the widget.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-PROGRESS-BAR


MAX attribute

The maximum value of the widget.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-PROGRESS-BAR


INPUT-VALUE attribute

The input-value of the widget.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-PROGRESS-BAR


P-OUTLOOKBAR class

P-OUTLOOKBAR
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

Attributes

inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

SET-ICON-AT | SET-TITLE-AT
SET-TOOLTIP-AT |
inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY


SET-TOOLTIP-AT method

Set the tooltip of the tab specified by tab index.

See also attribute TAB-TOOLTIP of P-TAB-FRAME.

Applies to: P-OUTLOOKBAR
Syntax:
oClass:SET-TOOLTIP-AT(
      TAB-INDEX, TOOLTIP).

Param | Data type | Description
TAB-INDEX | integer | tab index
TOOLTIP | string | tooltip


SET-TITLE-AT method

Set the title of the tab specified by tab index.

See also attribute TAB-TITLE of P-TAB-FRAME.

Applies to: P-OUTLOOKBAR
Syntax:
oClass:SET-TITLE-AT(
      TAB-INDEX, TITLE).

Param | Data type | Description
TAB-INDEX | integer | tab index
TITLE | string | title


SET-ICON-AT method

Set the icon of the tab specified by tab index.

See also attribute TAB-ICON of P-TAB-FRAME.

Applies to: P-OUTLOOKBAR
Syntax:
oClass:SET-ICON-AT(
      TAB-INDEX, ICON).

Param | Data type | Description
TAB-INDEX | integer | tab index
ICON | A-ICON | icon


P-MENU-ITEM class

P-MENU-ITEM
extended by SC-OBJECT

A menu item is an item within a menu or submenu.

Attributes

DISABLED-ICON | DISABLED-SELECTED-ICON
FONT | ICON
LABEL | PRESSED-ICON
ROLLOVER-ICON | ROLLOVER-SELECTED-ICON
SELECTED-ICON | SENSITIVE
VISIBLE |
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

SET-ACCELERATOR

Events

ANY-KEY | ANY-KEY
CHOOSE |

Example:

/**
 *  The example create a menu item in a file menu.
 *  On choose a program window shall be closed.
 */

DEFINE VARIABLE oMenuItem AS P-MENU-ITEM    NO-UNDO.

oMenuItem = NEW P-MENU-ITEM(THIS-PROCEDURE).
oMenuItem:NAME   = "Menu-Item1".
oMenuItem:LABEL  = "Quit".
oMenuItem:PARENT = oFileMenu
oMenuItem:CHOOSE = "E_Menu-Item1_CHOOSE"


VISIBLE attribute

Indicates whether a widget is currently visible on the display.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-TOGGLE-BOX-MENU-ITEM P-MENU-ITEM


SENSITIVE attribute

Indicates whether a widget is sensitive and can receive events.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-TOGGLE-BOX-MENU-ITEM P-MENU-ITEM


SELECTED-ICON attribute

The selected icon of this element.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-TOGGLE-BOX-MENU-ITEM P-MENU-ITEM


ROLLOVER-SELECTED-ICON attribute

The rollover selected icon of this element.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-TOGGLE-BOX-MENU-ITEM P-MENU-ITEM


ROLLOVER-ICON attribute

The rollover icon of this element.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-TOGGLE-BOX-MENU-ITEM P-MENU-ITEM


PRESSED-ICON attribute

The pressed icon of this element.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-TOGGLE-BOX-MENU-ITEM P-MENU-ITEM


LABEL attribute

The LABEL attribute specifies the label for the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-TOGGLE-BOX-MENU-ITEM P-MENU-ITEM


ICON attribute

The default icon of this element.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-TOGGLE-BOX-MENU-ITEM P-MENU-ITEM


FONT attribute

The LABEL will be shown in this font.

Data type: | J-FONT
Access: | Readable / Writeable
Applies to: | P-TOGGLE-BOX-MENU-ITEM P-MENU-ITEM


DISABLED-SELECTED-ICON attribute

The disabled selected icon of this element.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-TOGGLE-BOX-MENU-ITEM P-MENU-ITEM


DISABLED-ICON attribute

The disabled icon of this element.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-TOGGLE-BOX-MENU-ITEM P-MENU-ITEM


SET-ACCELERATOR method

Sets the key combination which fires CHOOSE event without navigating the menu hierarchy. Note that when the keyboard accelerator is typed, it will work whether or not the menu is currently displayed.

Applies to: P-TOGGLE-BOX-MENU-ITEM
P-MENU-ITEM
Syntax:
oClass:SET-ACCELERATOR(
      KEY-CODE, MODIFIERS, ON-KEY-RELEASE).
Param | Data type | Description
KEY-CODE value-set key code

Values:

Value | Description
UNDEFINED | No accelerator key defined.
A |
B |
C |
D |
E |
F |
G |
H |
I |
J |
K |
L |
M |
N |
O |
P |
Q |
R |
S |
T |
U |
V |
W |
X |
Y |
Z |
0 |
1 |
2 |
3 |
4 |
5 |
6 |
7 |
8 |
9 |
ENTER |
ESC |
CTRL |
ALT |
ALT-GR |
TAB |
SPACE |
DEL |
F1 |
F2 |
F3 |
F4 |
F5 |
F6 |
F7 |
F8 |
F9 |
F10 |
F11 |
F12 |
LEFT |
RIGHT |
END |
UP |
DOWN |
PAGE-DOWN |
PAGE-UP |
PAUSE |
PASTE |

Note: The value may be combined of multiple values. The values are separated by plus (+).
MODIFIERS value-set modifiers

Values:

Value | Description
UNDEFINED | No modifier key defined.
SHIFT | Shift key
CTRL | Ctrl key
ALT | Alt key
ALT-GRAPH | Alt key
META | Meta key
LEFT-MOUSE | Left mouse button
MIDDLE-MOUSE | Middle mouse button
RIGHT-MOUSE | Right mouse button

Note: The value may be combined of multiple values. The values are separated by plus (+).
ON-KEY-RELEASE | boolean | on key release - true if the KeyStroke should represent a key release; false otherwise


P-MENU class

P-MENU
extended by SC-OBJECT

A menu can be a menu bar, a sub menu or a pop-up menu. Menu bars and pop-up menus contain sub-menus and menu items.

Attributes

DISABLED-ICON | DISABLED-SELECTED-ICON
FONT | HEIGHT-PIXELS
ICON | LABEL
LIGHT-WEIGHT-ENABLED | MENU-TYPE
MNEMONIC | PRESSED-ICON
ROLLOVER-ICON | ROLLOVER-SELECTED-ICON
SELECTED-ICON | SENSITIVE
VISIBLE |
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

ADD-SEPARATOR SHOW-POPUP

Events

ANY-KEY | ANY-KEY
CHOOSE |

Example:

/**
 *  The example creates a file menu.
 *  Parent object is the window menu bar.
 */

DEFINE VARIABLE oMenu AS P-MENU    NO-UNDO.

oMenu = NEW P-MENU(THIS-PROCEDURE).
oMenu:NAME   = "Menu".
oMenu:LABEL  = "File".
oMenu:PARENT = oMenuBar.


VISIBLE attribute

Indicates whether a widget is currently visible on the display.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-MENU


SENSITIVE attribute

Indicates whether a widget is sensitive and can receive events.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-MENU


SELECTED-ICON attribute

The selected icon of this element.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-MENU


ROLLOVER-SELECTED-ICON attribute

The rollover selected icon of this element.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-MENU


ROLLOVER-ICON attribute

The rollover icon of this element.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-MENU


PRESSED-ICON attribute

The pressed icon of this element.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-MENU


MNEMONIC attribute

Indicates the keyboard mnemonic on this menu item. The mnemonic is the key which when combined with the look and feel's mouseless modifier (usually Alt) will activate this menu item if focus is contained somewhere within this button's ancestor window.

A mnemonic must correspond to a single key on the keyboard. Mnemonics are case-insensitive, therefore a key event with the corresponding keycode would cause the button to be activated whether or not the Shift modifier was pressed.

If the character defined by the mnemonic is found within the item's label string, the first occurrence of it will be underlined to indicate the mnemonic to the user.

Data type: value-set
Values:
Value | Description
UNDEFINED | No mnemonic key defined.
A | A key
B | B key
C | C key
D | D key
E | E key
F | F key
G | G key
H | H key
I | I key
J | J key
K | K key
L | L key
M | M key
N | N key
O | O key
P | P key
Q | Q key
R | R key
S | S key
T | T key
U | U key
V | V key
W | W key
X | X key
Y | Y key
Z | Z key
0 | 0 key
1 | 1 key
2 | 2 key
3 | 3 key
4 | 4 key
5 | 5 key
6 | 6 key
7 | 7 key
8 | 8 key
9 | 9 key
Default value: UNDEFINED
Access: Readable / Writeable
Applies to: P-MENU


MENU-TYPE attribute

Data type: value-set
Values:
Value | Description
SUB-MENU |
POPUP-MENU |
MENU-BAR |
Default value: SUB-MENU
Access: Readable / Writeable
Applies to: P-MENU


LIGHT-WEIGHT-ENABLED attribute

Indicates whether a menu may use light-weight components for performance reasons. This feature may cause glitches if the UI mixes up light-weight and heavy-weight components.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-MENU


LABEL attribute

The LABEL attribute specifies the label for the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-MENU


ICON attribute

The default icon of this element.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-MENU


HEIGHT-PIXELS attribute

The height in pixels of the menubar. For other menus this attribute always returns -1

Data type: | integer
Default value: | 0
Access: | Readable
Applies to: | P-MENU


FONT attribute

The LABEL will be shown in this font.

Data type: | J-FONT
Access: | Readable / Writeable
Applies to: | P-MENU


DISABLED-SELECTED-ICON attribute

The disabled selected icon of this element.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-MENU


DISABLED-ICON attribute

The disabled icon of this element.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-MENU


SHOW-POPUP method

Applies to: P-MENU
Syntax:
oClass:SHOW-POPUP(
      PARENT, X-COORDINATE, Y-COORDINATE).

Param | Data type | Description
PARENT | SC-OBJECT | The menus parent
X-COORDINATE | integer | x-coordinate of the popup relative to its parent
Y-COORDINATE | integer | y-coordinate of the popup relative to its parent


ADD-SEPARATOR method

Applies to: P-MENU
Syntax:
oClass:ADD-SEPARATOR(
      ).


P-MDI-CONTAINER class

P-MDI-CONTAINER
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

Attributes

ANCHORS
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY


ANCHORS attribute

Anchors are used to define automatic client-side resizing and/or repositioning of widgets.

This attribute indicates which anchors to respect if the parent container resizes.

Data type: value-set
Values:
Value | Description
NONE | No anchor
LEFT | Anchor to the left border of the parent container
TOP | Anchor to the top border of the parent container
RIGHT | Anchor to the right border of the parent container
BOTTOM | Anchor to the bottom border of the parent container
FILLED | Completly fills the parent container

Note: The value may be combined of multiple values. The values are separated by plus (+).
Default value: LEFT+TOP
Access: Readable / Writeable
Applies to: P-MDI-CONTAINER


P-LINK-BUTTON class

P-LINK-BUTTON
extended by AJ-COMPONENT
extended by SC-OBJECT

Attributes

DISABLED-ICON | DISABLED-SELECTED-ICON
ICON | MNEMONIC
PRESSED-ICON | ROLLOVER-ICON
ROLLOVER-SELECTED-ICON | SELECTED-ICON
TEXT |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY


TEXT attribute

The text of the button.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-LINK-BUTTON


SELECTED-ICON attribute

The selected icon of the widget.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-LINK-BUTTON


ROLLOVER-SELECTED-ICON attribute

The rollover selected icon of the widget.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-LINK-BUTTON


ROLLOVER-ICON attribute

The rollover icon of the widget.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-LINK-BUTTON


PRESSED-ICON attribute

The pressed icon of the widget.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-LINK-BUTTON


MNEMONIC attribute

Sets the keyboard mnemonic on this button. The mnemonic is the key which when combined with the look and feel's mouseless modifier (usually Alt) will activate this button if focus is contained somewhere within this button's ancestor window.

A mnemonic must correspond to a single key on the keyboard. Mnemonics are case-insensitive, therefore a key event with the corresponding keycode would cause the button to be activated whether or not the Shift modifier was pressed.

If the character defined by the mnemonic is found within the button's label string, the first occurrence of it will be underlined to indicate the mnemonic to the user.

Data type: value-set
Values:
Value | Description
UNDEFINED | No mnemonic key defined.
A | A key
B | B key
C | C key
D | D key
E | E key
F | F key
G | G key
H | H key
I | I key
J | J key
K | K key
L | L key
M | M key
N | N key
O | O key
P | P key
Q | Q key
R | R key
S | S key
T | T key
U | U key
V | V key
W | W key
X | X key
Y | Y key
Z | Z key
0 | 0 key
1 | 1 key
2 | 2 key
3 | 3 key
4 | 4 key
5 | 5 key
6 | 6 key
7 | 7 key
8 | 8 key
9 | 9 key
Default value: UNDEFINED
Access: Readable / Writeable
Applies to: P-LINK-BUTTON


ICON attribute

The icon of the widget.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-LINK-BUTTON


DISABLED-SELECTED-ICON attribute

The disabled selected icon of the widget.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-LINK-BUTTON


DISABLED-ICON attribute

The disabled icon of the widget.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-LINK-BUTTON


P-IMAGE class

P-IMAGE
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

A display area for an image. P-IMAGE does not react to input events. As a result, it cannot get the keyboard focus.

Attributes

HORIZONTAL-ALIGNMENT | ICON
SCALE | VERTICAL-ALIGNMENT
inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY

Example:

/**
 *  The example create a display area for an image in the frame.
 */

DEFINE VARIABLE oImage AS P-IMAGE    NO-UNDO.

oImage = NEW P-IMAGE(THIS-PROCEDURE).
oImage:NAME                 = "Image".
oImage:ICON                 = J-IMAGE-ICON:LOAD-IMAGE("Icons/Image.png").
oImage:HEIGHT-PIXELS        = 100.
oImage:WIDTH-PIXELS         = 100.
oImage:X                    = 1.
oImage:Y                    = 1.
oImage:HORIZONTAL-ALIGNMENT = "LEFT".
oImage:VERTICAL-ALIGNMENT   = "TOP".
oImage:PARENT               = oFrame.


VERTICAL-ALIGNMENT attribute

The vertical alignment of the image.

Data type: value-set
Values:
Value | Description
TOP |
CENTER |
BOTTOM |
Access: Readable / Writeable
Applies to: P-IMAGE


SCALE attribute

Should the image expand or contract to fit within the widget's boundaries?

Data type: value-set
Values:
Value | Description
STRETCH-TO-FIT | Forces the image to expand or contract to fit within the image widget's boundaries.
RETAIN-SHAPE | Indicates that the image should retain its aspect ratio (expand or contract equally in both dimensions).
NO-SCALE | Indicates that the image should retain its size.
Access: Readable / Writeable
Applies to: P-IMAGE


ICON attribute

The icon of the widget.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-IMAGE


HORIZONTAL-ALIGNMENT attribute

The horizontal alignment of the image.

Data type: value-set
Values:
Value | Description
RIGHT | Right position in an area.
LEFT | Left position in an area.
CENTER | The central position in an area.
LEADING | Identifies the leading edge of text for use with left-to-right and right-to-left languages.
TRAILING | Identifies the trailing edge of text for use with left-to-right and right-to-left languages.
Access: Readable / Writeable
Applies to: P-IMAGE


P-GRID class

P-GRID
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

A grid widget can be used as a replacement for a P-BROWSE.

The cell values are not directly associated to a query. Every cell can be directly addressed.

Attributes

COLUMN-HEADERS-VISIBLE | GRID-COLOR
H-SEPARATORS | READ-ONLY
ROW-HEIGHT-PIXELS | SELECTED-COL
SELECTED-ROW | SELECTED-VALUE
V-SEPARATORS |
inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

CLEAR-SETTINGS | CLEAR-VALUES
GET-VALUE-AT | REQUEST-FOCUS-AT
SET-ALIGNMENT-AT | SET-BGCOLOR-AT
SET-COLUMN-LABEL-AT | SET-COLUMN-WIDTH-AT
SET-FGCOLOR-AT | SET-FONT-AT
SET-GRID-SIZE | SET-READ-ONLY-AT
SET-ROW-HEIGHT-AT | SET-VALUE-AT
inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

CHOOSE VALUE-CHANGED
inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY


V-SEPARATORS attribute

If attribute is TRUE vertical lines was be shown.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-GRID


SELECTED-VALUE attribute

value of selected cell

Data type: | string
Access: | Readable
Applies to: | P-GRID


SELECTED-ROW attribute

row-index of selected cell

Data type: | integer
Default value: | 0
Access: | Readable
Applies to: | P-GRID


SELECTED-COL attribute

column-index of selected cell

Data type: | integer
Default value: | 0
Access: | Readable
Applies to: | P-GRID


ROW-HEIGHT-PIXELS attribute

The row height, in pixels.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-GRID


READ-ONLY attribute

Indicates whether the user can edit the cells.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-GRID


H-SEPARATORS attribute

If attribute is TRUE horizontal lines will be shown.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-GRID


GRID-COLOR attribute

The color used to paint the grid (horizontal and vertical separators)

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-GRID


COLUMN-HEADERS-VISIBLE attribute

Indicates whether the Browse should show column headers

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-GRID


SET-VALUE-AT method

Sets the value for a given cell

Applies to: P-GRID
Syntax:
oClass:SET-VALUE-AT(
      COLUMN, ROW, VALUE).

Param | Data type | Description
COLUMN | integer | column-index
ROW | integer | row-index
VALUE | string | value


SET-ROW-HEIGHT-AT method

Sets the row-height for a specific row

Applies to: P-GRID
Syntax:
oClass:SET-ROW-HEIGHT-AT(
      ROW, ROW-HEIGHT).

Param | Data type | Description
ROW | integer | row-index
ROW-HEIGHT | integer | row-height in pixels


SET-READ-ONLY-AT method

Defines if a given cell can be edited by the user. This setting has no effect if the grid is READ-ONLY.

Applies to: P-GRID
Syntax:
oClass:SET-READ-ONLY-AT(
      COLUMN, ROW, READ-ONLY).

Param | Data type | Description
COLUMN | integer | column-index
ROW | integer | row-index
READ-ONLY | boolean | indicates if the user may edit the cell


SET-GRID-SIZE method

Sets the number of columns and rows.

Applies to: P-GRID
Syntax:
oClass:SET-GRID-SIZE(
      NUM-COLS, NUM-ROWS).

Param | Data type | Description
NUM-COLS | integer | number of columns
NUM-ROWS | integer | number of rows


SET-FONT-AT method

Sets the font color for a given cell

Applies to: P-GRID
Syntax:
oClass:SET-FONT-AT(
      COLUMN, ROW, FONT).

Param | Data type | Description
COLUMN | integer | column-index
ROW | integer | row-index
FONT | J-FONT | font


SET-FGCOLOR-AT method

Sets the foreground color for a given cell

Applies to: P-GRID
Syntax:
oClass:SET-FGCOLOR-AT(
      COLUMN, ROW, FGCOLOR).

Param | Data type | Description
COLUMN | integer | column-index
ROW | integer | row-index
FGCOLOR | J-COLOR | foreground color


SET-COLUMN-WIDTH-AT method

Sets the width for a given column

Applies to: P-GRID
Syntax:
oClass:SET-COLUMN-WIDTH-AT(
      COLUMN, WIDTH).

Param | Data type | Description
COLUMN | integer | column-index
WIDTH | integer | label


SET-COLUMN-LABEL-AT method

Sets the label for a given column

Applies to: P-GRID
Syntax:
oClass:SET-COLUMN-LABEL-AT(
      COLUMN, LABEL).

Param | Data type | Description
COLUMN | integer | column-index
LABEL | string | label


SET-BGCOLOR-AT method

Sets the background color for a given cell

Applies to: P-GRID
Syntax:
oClass:SET-BGCOLOR-AT(
      COLUMN, ROW, BGCOLOR).

Param | Data type | Description
COLUMN | integer | column-index
ROW | integer | row-index
BGCOLOR | J-COLOR | background color


SET-ALIGNMENT-AT method

Sets the horizontal alignment for a given cell

Applies to: P-GRID
Syntax:
oClass:SET-ALIGNMENT-AT(
      COLUMN, ROW, ALIGNMENT).
Param | Data type | Description
COLUMN | integer | column-index
ROW | integer | row-index
ALIGNMENT value-set alignment

Values:

Value | Description
RIGHT | Right position in an area.
LEFT | Left position in an area.
CENTER | The central position in an area.
LEADING | Identifies the leading edge of text for use with left-to-right and right-to-left languages.
TRAILING | Identifies the trailing edge of text for use with left-to-right and right-to-left languages.


REQUEST-FOCUS-AT method

Requests focus for a given cell

Applies to: P-GRID
Syntax:
oClass:REQUEST-FOCUS-AT(
      COLUMN, ROW).

Param | Data type | Description
COLUMN | integer | column-index
ROW | integer | row-index


GET-VALUE-AT method

Returns the value of a given cell

Return type: string
Applies to: P-GRID
Syntax:
_ret = oClass:GET-VALUE-AT(
      COLUMN, ROW).

Param | Data type | Description
COLUMN | integer | column-index
ROW | integer | row-index


CLEAR-VALUES method

Sets all cell values to blank

Applies to: P-GRID
Syntax:
oClass:CLEAR-VALUES(
      ).


CLEAR-SETTINGS method

Removes all cell-, column- and row-settings (colors, fonts, sizes ...)

Applies to: P-GRID
Syntax:
oClass:CLEAR-SETTINGS(
      ).


P-FRAME class

P-FRAME
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

A frame is a display area within a window that can group together (contain) a set of field-level widgets and child frames.

Attributes

ANCHORS | BGCOLOR2
BGIMAGE | BORDER-COLOR
BOX | EDGE-PIXELS
H-BLOCK-INC | H-UNIT-INC
RADIUS-PIXELS | SCROLLABLE
TITLE | TITLE-BGCOLOR
TITLE-FGCOLOR | TITLE-FONT
UPDATE-LOCKED | V-BLOCK-INC
VERTICAL-GRADIENT | VIRTUAL-HEIGHT-PIXELS
VIRTUAL-WIDTH-PIXELS | V-UNIT-INC
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

REMOVE-GRADIENT-PAINT | SCROLL-TO-COORDINATES
SCROLL-TO-LEFT-UPPER-CORNER | SCROLL-TO-VISIBLE
SET-GRADIENT-PAINT | SET-PREFERRED-SIZE
inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY

Example:

/**
 *  The example create a new frame with a window.
 */

DEFINE VARIABLE oFrame AS P-FRAME    NO-UNDO.

oFrame = NEW P-FRAME(THIS-PROCEDURE).
oFrame:NAME          = "Frame".
oFrame:WIDTH-PIXELS  = 800.
oFrame:HEIGHT-PIXELS = 600.
oFrame:Y             = 0.
oFrame:X             = 0.
oFrame:PARENT        = oWindow.


V-UNIT-INC attribute

The number of pixels to scroll if the user clicks one of the buttons on the vertical scroll bar. The amount that the mouse wheel scrolls is platform dependent. For example, by default on Windows XP, the mouse wheel scrolls three unit increments.

See also: V-BLOCK-INC , H-UNIT-INC , H-BLOCK-INC

Data type: | integer
Default value: | 12
Access: | Readable / Writeable
Applies to: | P-TAB-FRAME P-FRAME


VIRTUAL-WIDTH-PIXELS attribute

The maximum width of the widget, in pixels.

For a SCROLLABLE frame, VIRTUAL-WIDTH-PIXELS specifies the width of the entire frame while WIDTH-PIXELS specifies the width of the visible portion of the frame.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-TAB-FRAME P-FRAME


VIRTUAL-HEIGHT-PIXELS attribute

The maximum height of the widget, in pixels.

For a SCROLLABLE frame, VIRTUAL-HEIGHT-PIXELS specifies the height of the entire frame while HEIGHT-PIXELS specifies the height of the visible portion of the frame.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-TAB-FRAME P-FRAME


VERTICAL-GRADIENT attribute

Indicates whether the gradient of the background is vertical (true) or horizontal (false)

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-TAB-FRAME P-FRAME


V-BLOCK-INC attribute

The number of pixels to scroll if the user clicks on the track of the vertical scroll bar.

See also: V-UNIT-INC , H-UNIT-INC , H-BLOCK-INC

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-TAB-FRAME P-FRAME


UPDATE-LOCKED attribute

If the UPDATE-LOCKED attribute is TRUE, the frame will ignore any paint requests (triggered by user OR application) until the attribute is reset to FALSE.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-TAB-FRAME P-FRAME


TITLE-FONT attribute

The font of frame's title.

Data type: | J-FONT
Access: | Readable / Writeable
Applies to: | P-TAB-FRAME P-FRAME


TITLE-FGCOLOR attribute

The color of frame's title.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-TAB-FRAME P-FRAME


TITLE-BGCOLOR attribute

The background color of frame's title.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-TAB-FRAME P-FRAME


TITLE attribute

The title of the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-TAB-FRAME P-FRAME


SCROLLABLE attribute

If the SCROLLABLE attribute is TRUE, the frame can be bigger than the display space allotted to it (that is, it is scrollable). If SCROLLABLE is FALSE, the frame must fit within the allotted display space; it cannot be made to scroll.

The VIRTUAL-HEIGHT-PIXELS and VIRTUAL-WIDTH-PIXELS attributes control the virtual or maximum size of a frame.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-TAB-FRAME P-FRAME


RADIUS-PIXELS attribute

The radius in pixels of the rectangle corners. (0 for angular corners)

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-TAB-FRAME P-FRAME


H-UNIT-INC attribute

The number of pixels to scroll if the user clicks one of the buttons on the horizontal scroll bar.

See also: V-UNIT-INC , V-BLOCK-INC , H-BLOCK-INC

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-TAB-FRAME P-FRAME


H-BLOCK-INC attribute

The number of pixels to scroll if the user clicks on the track of the horizontal scroll bar.

See also: V-UNIT-INC , V-BLOCK-INC , H-UNIT-INC

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-TAB-FRAME P-FRAME


EDGE-PIXELS attribute

The border-width in pixels

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-TAB-FRAME P-FRAME


BOX attribute

Indicates whether the widget has a graphical border around it.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-TAB-FRAME P-FRAME


BORDER-COLOR attribute

The color used to paint the border around the frame. If this attribute is not set (or set to unknown) then no rectangle is painted.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-TAB-FRAME P-FRAME


BGIMAGE attribute

The background image of the widget.
Note: Setting a background image using this attribute overrides all other settings regarding background and border!

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-TAB-FRAME P-FRAME


BGCOLOR2 attribute

The second background color used together with BGCOLOR to fill the background with a gradient

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-TAB-FRAME P-FRAME


ANCHORS attribute

Anchors are used to define automatic client-side resizing and/or repositioning of widgets.

This attribute indicates which anchors to respect if the parent container resizes.

Data type: value-set
Values:
Value | Description
NONE | No anchor
LEFT | Anchor to the left border of the parent container
TOP | Anchor to the top border of the parent container
RIGHT | Anchor to the right border of the parent container
BOTTOM | Anchor to the bottom border of the parent container
FILLED | Completly fills the parent container

Note: The value may be combined of multiple values. The values are separated by plus (+).
Default value: LEFT+TOP
Access: Readable / Writeable
Applies to: P-TAB-FRAME
P-FRAME


SET-PREFERRED-SIZE method

Set preferred size. This information may be used by layout manager.

Applies to: P-TAB-FRAME
P-FRAME
Syntax:
oClass:SET-PREFERRED-SIZE(
      WIDTH-PIXELS, HEIGHT-PIXELS).

Param | Data type | Description
WIDTH-PIXELS | integer | preferred width pixels
HEIGHT-PIXELS | integer | preferred height pixels


SET-GRADIENT-PAINT method

Fills background with a color gradient.
Note: Setting a gradient using this method overrides all other settings regarding background and border!

Applies to: P-TAB-FRAME
P-FRAME
Syntax:
oClass:SET-GRADIENT-PAINT(
      X1, Y1, COLOR1, X2, Y2, COLOR2, CYCLIC).

Param | Data type | Description
X1 | integer | x1
Y1 | integer | y1
COLOR1 | J-COLOR | color1
X2 | integer | x2
Y2 | integer | y2
COLOR2 | J-COLOR | color2
CYCLIC | boolean | cyclic


SCROLL-TO-VISIBLE method

Scroll the viewport to assure that the given component is fully visible (if possible).

Applies to: P-TAB-FRAME
P-FRAME
Syntax:
oClass:SCROLL-TO-VISIBLE(
      COMPONENT).

Param | Data type | Description
COMPONENT | AP-FIELD-LEVEL-WIDGET |


SCROLL-TO-LEFT-UPPER-CORNER method

Scroll the viewport in a way that the given component is in the upper left corner (if possible).

Applies to: P-TAB-FRAME
P-FRAME
Syntax:
oClass:SCROLL-TO-LEFT-UPPER-CORNER(
      COMPONENT).

Param | Data type | Description
COMPONENT | AP-FIELD-LEVEL-WIDGET |


SCROLL-TO-COORDINATES method

Scroll the viewport to assure that the rectangle build using the given coordinates is fully visible (if possible).

Applies to: P-TAB-FRAME
P-FRAME
Syntax:
oClass:SCROLL-TO-COORDINATES(
      X, Y, WIDTH, HEIGHT).

Param | Data type | Description
X | integer |
Y | integer |
WIDTH | integer |
HEIGHT | integer |


REMOVE-GRADIENT-PAINT method

Remove color gradient from background.

Applies to: P-TAB-FRAME
P-FRAME
Syntax:
oClass:REMOVE-GRADIENT-PAINT(
      ).


P-FLEX-TEXT class

P-FLEX-TEXT
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

A display area for a longer text string. P-TEXT does not react to input events. As a result, it cannot get the keyboard focus.

Attributes

HORIZONTAL-ALIGNMENT | INPUT-VALUE
MIN-HEIGHT-PIXELS | MOUSE-OVER-FGCOLOR
OPAQUE |
inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY

Example:

/**
 *  A display area showing "Your Text" in the frame.
 */

DEFINE VARIABLE oText AS P-TEXT    NO-UNDO.

oText = NEW P-FLEX-TEXT(THIS-PROCEDURE).
oText:NAME            = "Text".
oText:FONT            = oFont.
oText:INPUT-VALUE     = "Your Text".
oText:MIN-HEIGHT-PIXELS = 20.
oText:WIDTH-PIXELS    = 100.
oText:Y               = 10.
oText:X               = 10.
oText:PARENT          = oFrame.


OPAQUE attribute

If true the widget paints every pixel within its bounds. Otherwise, the widget may not paint some or all of its pixels, allowing the underlying pixels to show through.

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-FLEX-TEXT


MOUSE-OVER-FGCOLOR attribute

The foreground color of displayed value on mouse over.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-FLEX-TEXT


MIN-HEIGHT-PIXELS attribute

The minimal height of the widget.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-FLEX-TEXT


INPUT-VALUE attribute

The input-value of the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-FLEX-TEXT


HORIZONTAL-ALIGNMENT attribute

The horizontal alignment of displayed value.

Data type: value-set
Values:
Value | Description
RIGHT | Right position in an area.
LEFT | Left position in an area.
CENTER | The central position in an area.
LEADING | Identifies the leading edge of text for use with left-to-right and right-to-left languages.
TRAILING | Identifies the trailing edge of text for use with left-to-right and right-to-left languages.
Access: Readable / Writeable
Applies to: P-FLEX-TEXT


P-FILL-IN class

P-FILL-IN
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

A fill-in is a basic text control that lets the user enter a small amount of text. If you need to obtain more than one line of input from the user, you should use a P-EDITOR instead.

Attributes

CARET-COLOR | DATA-TYPE
ENTER-LIKE-TAB | FORMAT
HORIZONTAL-ALIGNMENT | INPUT-VALUE
LABEL | LABEL-BGCOLOR
LABEL-FGCOLOR | LABEL-FONT
PASSWORD-FIELD * | READ-ONLY
SHOW-FORMAT-ERROR | USER-PRIORITY
* mandatory (must be set to realise object)
inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

CLEAR-SELECTION | COPY
CUT | PASTE
SELECT-ALL | SET-SHOW-DISABLED-BORDER
UNLOCK-FIELD |
inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

VALUE-CHANGED
inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY

Example:

/**
 *  The example create a fill-in that lets the user enter a string
 *  with maximum length of 40 characters.
 */

DEFINE VARIABLE oFillIn AS P-FILL-IN    NO-UNDO.

oFillIn = NEW P-FILL-IN(THIS-PROCEDURE).
oFillIn:NAME          = "Fill-In".
oFillIn:LABEL         = "Label:".
oFillIn:FORMAT        = "X(40)".
oFillIn:HEIGHT-PIXELS = 20.
oFillIn:WIDTH-PIXELS  = 150.
oFillIn:Y             = 5.
oFillIn:X             = 30.
oFillIn:PARENT        = oFrame.


USER-PRIORITY attribute

If set to TRUE the Fill-Ins INPUT-VALUE cannot be changed by application if the user has changed the input-value. The lock can only be released by calling method UNLOCK-FIELD.

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-FILL-IN


SHOW-FORMAT-ERROR attribute

Indicates whether the field is allowed to display an error message if a format error occurs.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-FILL-IN


READ-ONLY attribute

Indicates whether a widget is write-protected.

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-FILL-IN


PASSWORD-FIELD attribute

Displays password data in a field as a series of fill characters.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-FILL-IN


LABEL-FONT attribute

The font of fill-in's label.

Data type: | J-FONT
Access: | Readable / Writeable
Applies to: | P-FILL-IN


LABEL-FGCOLOR attribute

The color of fill-in's label.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-FILL-IN


LABEL-BGCOLOR attribute

The background color of fill-in's label.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-FILL-IN


LABEL attribute

The label of the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-FILL-IN


INPUT-VALUE attribute

The input-value of the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-FILL-IN


HORIZONTAL-ALIGNMENT attribute

The horizontal alignment of the text.

Data type: value-set
Values:
Value | Description
RIGHT | Right position in an area.
LEFT | Left position in an area.
CENTER | The central position in an area.
LEADING | Identifies the leading edge of text for use with left-to-right and right-to-left languages.
TRAILING | Identifies the trailing edge of text for use with left-to-right and right-to-left languages.
Access: Readable / Writeable
Applies to: P-FILL-IN


FORMAT attribute

The FORMAT value is used to format the INPUT-VALUE to the value that will be displayed.

Allowed format depends on the value of attribute DATA-TYPE .

CHARACTER Format

Special Character | Description
~ | Used to quote special characters.
X | Represents any character.
N | Represents a digit or a letter. A space is not allowed.
A | Represents a letter. A space is not allowed.
! | Represents a letter that is converted to uppercase during input. A space is not allowed.
9 | Represents a digit. A space is not allowed.
(n ) | Number indicating how many times to repeat the previous format character. For example, !(5) is the same as !!!!! and represents 5 characters that are to be converted to uppercase when entered.
fillchar | Represents any character or characters you want to fill a display. For example, if you display the value abc with a format of x(3)***, the displayed value is abc***.

NUMERIC Format (also allowed names DECIMAL and INTEGER)

Special Character | Description
~ | Used to quote special characters.
> | Blank shows as absent.
< | Digit, zero shows as absent.
. | Decimal separator.
, | Thousands Separator.

DATE Format

You can specify the following in the format string:
  • The separator character.
  • Whether the year is two-digit or four-digit.
Example | Separator | Year
99-99-99 | - | two-digit
99/99/9999 | / | four-digit

Please note:

  • The order of Year, Month and Day depents on the setting of the client system.

LOGICAL Format

Syntax:
true-string/false-string

One of the two string may be empty.

Please note:

  • The user input is NOT case sensetive.
  • For INPUT-VALUE true you can also use the synonyms yes, on and 1.
  • For INPUT-VALUE false you can also use the synonyms no, off and 0.
  • Skin Client always send true, false or /? (unknown value).

Data type: | string
Default value: |
Access: | Readable / Writeable
Applies to: | P-FILL-IN


ENTER-LIKE-TAB attribute

Indicates whether pressing RETURN transfers focus to the next widget (like pressing TAB).

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-FILL-IN


DATA-TYPE attribute

Please see the description at FORMAT attribute.

Data type: value-set
Values:
Value | Description
LOGICAL | Allows tree values: TRUE (alias YES), FALSE (alias NO) and unknown value (\?).
CHARACTER | Any string.
NUMERIC | Alias for DECIMAL.
INTEGER | Integer numbers.
DECIMAL | Decimal numbers.
DATE | Year, month and day.
DATETIME | Year, month, day, hours, minutes, esconds and milliseconds.
BLOB | Binary data
Default value: CHARACTER
Access: Readable / Writeable
Applies to: P-FILL-IN


CARET-COLOR attribute

The caret color of the widget.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-FILL-IN


UNLOCK-FIELD method

Releases the lock of the Fill-In to allow changing the INPUT-VALUE by application again. This method has no effect if attribute USER-PRIORITY is set to false

Applies to: P-FILL-IN
Syntax:
oClass:UNLOCK-FIELD(
      ).


SET-SHOW-DISABLED-BORDER method

Set the visibility of the Fill-Ins border in its disabled state

Applies to: P-FILL-IN
Syntax:
oClass:SET-SHOW-DISABLED-BORDER(
      VISIBLE).

Param | Data type | Description
VISIBLE | boolean | Indicates if the border should be visible


SELECT-ALL method

Selects the whole contents of the fill in

Applies to: P-FILL-IN
Syntax:
oClass:SELECT-ALL(
      ).


PASTE method

Transfers the contents of the system clipboard into the fill-in. If there is a selection in the fill-in, it is replaced with the contents of the clipboard. If there is no selection, the clipboard contents are inserted in front of the current insert position. If the clipboard is empty, does nothing.

Applies to: P-FILL-IN
Syntax:
oClass:PASTE(
      ).


CUT method

Transfers the currently selected text to the system clipboard, removing the text form the fill-in. The current selection is reset. Does nothing for null selections.

Applies to: P-FILL-IN
Syntax:
oClass:CUT(
      ).


COPY method

Transfers the currently selected text to the system clipboard, leaving the text in the fill-in. The current selection remains intact. Does nothing for null selections.

Applies to: P-FILL-IN
Syntax:
oClass:COPY(
      ).


CLEAR-SELECTION method

Clears current selection and moves cursor to the end of the text

Applies to: P-FILL-IN
Syntax:
oClass:CLEAR-SELECTION(
      ).


P-FILE-UPLOADER class

P-FILE-UPLOADER
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

Attributes

LABEL
inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

FILE-UPLOADED
inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY


LABEL attribute

The label of the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-FILE-UPLOADER


P-EDITOR class

P-EDITOR
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

An editor is a field-level widget that allows you to perform complex text manipulation on a character value.

Attributes

ACCEPTS-RETURN | ACCEPTS-TAB
BGCOLOR | BOX
CAN-REDO | CAN-UNDO
CARET-COLOR | CONTENT-TYPE *
INPUT-VALUE | LABEL
LABEL-BGCOLOR | LABEL-FGCOLOR
LABEL-FONT | MAX-CHARS
READ-ONLY | REDO-DESCRIPTION
UNDO-DESCRIPTION | URL
WORD-WRAP |
* mandatory (must be set to realise object)
inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

ALIGN | APPEND
COPY | CUT
FONT-COLOR | FONT-NAME
FONT-SIZE | FONT-STYLE
GET-PLAIN-TEXT | GET-STYLES
LIST-ITEM | LOAD
NEW-DOCUMENT | PASTE
REDO | SAVE
SCROLL-TO-BOTTOM | SCROLL-TO-TOP
SET-SHOW-DISABLED-BORDER | UNDO
ZOOM |
inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

CARET-MOVED | CHOOSE
VALUE-CHANGED |
inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY

Example:

/**
 *  The example creates a editor widget.
 */

DEFINE VARIABLE oEditor AS P-EDITOR    NO-UNDO.

oEditor = NEW P-EDITOR(THIS-PROCEDURE).
oEditor:NAME            = "Editor".
oEditor:HEIGHT-PIXELS   = 150.
oEditor:WIDTH-PIXELS    = 100.
oEditor:Y               = 25.
oEditor:X               = 20.
oEditor:PARENT          = oFrame.

oEditor:APPEND(hP-EDITOR).


WORD-WRAP attribute

Indicates whether the content gets wrapped automatically to not need a horizontal scrollbar Note: this attribute can only be changed for PLAIN content.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-EDITOR


URL attribute

Show HTML page (not editable).

Data type: | string
Access: | Readable / Writeable
Applies to: | P-EDITOR


UNDO-DESCRIPTION attribute

Description of the next undo operation.

Data type: | string
Access: | Readable
Applies to: | P-EDITOR


REDO-DESCRIPTION attribute

Description of the next redo operation.

Data type: | string
Access: | Readable
Applies to: | P-EDITOR


READ-ONLY attribute

Indicates whether a widget is write-protected.

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-EDITOR


MAX-CHARS attribute

The maximum number of characters the editor can hold. Note: this attribute only affects PLAIN-text editors

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-EDITOR


LABEL-FONT attribute

The font of widget's label.

Data type: | J-FONT
Access: | Readable / Writeable
Applies to: | P-EDITOR


LABEL-FGCOLOR attribute

The color of widget's label.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-EDITOR


LABEL-BGCOLOR attribute

The background color of widget's label.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-EDITOR


LABEL attribute

The label of the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-EDITOR


INPUT-VALUE attribute

The input value of the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-EDITOR


CONTENT-TYPE attribute

Indicates the content type of the editor.

Data type: value-set
Values:
Value | Description
PLAIN | Unformatted text of any length.
HTML | Enables HTML 3.2 support.
RTF | Enables limited support of the Rich Text Format.
Access: Readable / Writeable
Applies to: P-EDITOR


CARET-COLOR attribute

The caret color of the widget.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-EDITOR


CAN-UNDO attribute

Indicates whether an undo operation would be successful now.

Data type: | boolean
Default value: | FALSE
Access: | Readable
Applies to: | P-EDITOR


CAN-REDO attribute

Indicates whether an redo operation would be successful now.

Data type: | boolean
Default value: | FALSE
Access: | Readable
Applies to: | P-EDITOR


BOX attribute

Indicates whether the widget has a graphical border around it.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-EDITOR


BGCOLOR attribute

The background color of the widget.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-EDITOR


ACCEPTS-TAB attribute

Indicates whether the user may insert tabs by pressing the TAB-key.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-EDITOR


ACCEPTS-RETURN attribute

Indicates whether the user may insert line breaks by pressing the RETURN-key.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-EDITOR


ZOOM method

Applies to: P-EDITOR
Syntax:
oClass:ZOOM(
      SCALE).

Param | Data type | Description
SCALE | string | Scale factor for the RTF editor. Use value 1.0 to scale to 100%.


UNDO method

Applies to: P-EDITOR
Syntax:
oClass:UNDO(
      ).


SET-SHOW-DISABLED-BORDER method

Set the visibility of the Editors border in its disabled state

Applies to: P-EDITOR
Syntax:
oClass:SET-SHOW-DISABLED-BORDER(
      VISIBLE).

Param | Data type | Description
VISIBLE | boolean | Indicates if the border should be visible


SCROLL-TO-TOP method

Applies to: P-EDITOR
Syntax:
oClass:SCROLL-TO-TOP(
      ).


SCROLL-TO-BOTTOM method

Applies to: P-EDITOR
Syntax:
oClass:SCROLL-TO-BOTTOM(
      ).


SAVE method

Applies to: P-EDITOR
Syntax:
oClass:SAVE(
      BINARY).

Param | Data type | Description
BINARY | J-BINARY |


REDO method

Applies to: P-EDITOR
Syntax:
oClass:REDO(
      ).


PASTE method

Transfers the contents of the system clipboard into the editor. If there is a selection in the editor, it is replaced with the contents of the clipboard. If there is no selection, the clipboard contents are inserted in front of the current insert position. If the clipboard is empty, does nothing.

Applies to: P-EDITOR
Syntax:
oClass:PASTE(
      ).


NEW-DOCUMENT method

Applies to: P-EDITOR
Syntax:
oClass:NEW-DOCUMENT(
      ).


LOAD method

Applies to: P-EDITOR
Syntax:
oClass:LOAD(
      BINARY).

Param | Data type | Description
BINARY | J-BINARY |


LIST-ITEM method

Creates list item(s) at current cursor position

It depends on the selected lines count and cursor position if a new list is created and if more than one item is created

Applies to: P-EDITOR
Syntax:
oClass:LIST-ITEM(
      ).


GET-STYLES method

Return type: string
Applies to: P-EDITOR
Syntax:
_ret = oClass:GET-STYLES(
      ).


GET-PLAIN-TEXT method

Return type: string
Applies to: P-EDITOR
Syntax:
_ret = oClass:GET-PLAIN-TEXT(
      ).


FONT-STYLE method

Applies to: P-EDITOR
Syntax:
oClass:FONT-STYLE(
      STYLE).
Param Data type Description
STYLE value-set

Values:

Value | Description
BOLD |
ITALIC |
UNDERLINE |


FONT-SIZE method

Applies to: P-EDITOR
Syntax:
oClass:FONT-SIZE(
      SIZE).

Param | Data type | Description
SIZE | integer |


FONT-NAME method

Applies to: P-EDITOR
Syntax:
oClass:FONT-NAME(
      NAME).

Param | Data type | Description
NAME | string |


FONT-COLOR method

Applies to: P-EDITOR
Syntax:
oClass:FONT-COLOR(
      COLOR).

Param | Data type | Description
COLOR | J-COLOR |


CUT method

Transfers the currently selected text to the system clipboard, removing the text form the editor. The current selection is reset. Does nothing for null selections.

Applies to: P-EDITOR
Syntax:
oClass:CUT(
      ).


COPY method

Transfers the currently selected text to the system clipboard, leaving the text in the editor. The current selection remains intact. Does nothing for null selections.

Applies to: P-EDITOR
Syntax:
oClass:COPY(
      ).


APPEND method

Appends the given text to the end of the document.

Applies to: P-EDITOR
Syntax:
oClass:APPEND(
      TEXT).

Param | Data type | Description
TEXT | string | The text to append.


ALIGN method

Applies to: P-EDITOR
Syntax:
oClass:ALIGN(
      ALIGN).
Param Data type Description
ALIGN value-set

Values:

Value | Description
LEFT |
CENTER |
RIGHT |


P-DOCKMAN class

P-DOCKMAN
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

Attributes

BASE-LAYOUT | DEBUG-MODE
DROP-BUTTON-BGCOLOR | DROP-BUTTON-BGCOLOR-HL
inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

ADD-DOCKFRAME | DOCK-FRAME-AT
DOCK-FRAME-AT-BASE | LOAD-LAYOUT
REMOVE-DOCKFRAME | SAVE-LAYOUT
SET-FLOATING-WINDOWS-VISIBLE |
inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY


DROP-BUTTON-BGCOLOR-HL attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-DOCKMAN


DROP-BUTTON-BGCOLOR attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-DOCKMAN


DEBUG-MODE attribute

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-DOCKMAN


BASE-LAYOUT attribute

Data type: value-set
Values:
Value | Description
TABFOLDER | Group is represented by a tabfolder
HORIZONTAL-SPLIT | Group is represented by a horizontal splitter
VERTICAL-SPLIT | Group is represented by a vertical splitter
Access: Readable / Writeable
Applies to: P-DOCKMAN


SET-FLOATING-WINDOWS-VISIBLE method

Sets visibility of all floating windows (if any)

Applies to: P-DOCKMAN
Syntax:
oClass:SET-FLOATING-WINDOWS-VISIBLE(
      VISIBLE).

Param | Data type | Description
VISIBLE | boolean |


SAVE-LAYOUT method

Saves current docking manager layout.

Return type: boolean
Applies to: P-DOCKMAN
Syntax:
_ret = oClass:SAVE-LAYOUT(
      OBJECT).

Param | Data type | Description
OBJECT | J-BINARY | Binary object to save to.


REMOVE-DOCKFRAME method

Applies to: P-DOCKMAN
Syntax:
oClass:REMOVE-DOCKFRAME(
      DOCKFRAME).

Param | Data type | Description
DOCKFRAME | P-DOCKFRAME |


LOAD-LAYOUT method

Loads docking manager layout.

Return type: boolean
Applies to: P-DOCKMAN
Syntax:
_ret = oClass:LOAD-LAYOUT(
      OBJECT).

Param | Data type | Description
OBJECT | J-BINARY | Binary object to load from.


DOCK-FRAME-AT-BASE method

Applies to: P-DOCKMAN
Syntax:
oClass:DOCK-FRAME-AT-BASE(
      DOCKFRAME, ).
Param Data type Description
DOCKFRAME P-DOCKFRAME
value-set

Values:

Value | Description
NORTH | Frame gets docked to the north
SOUTH | Frame gets docked to the south
WEST | Frame gets docked to the west
EAST | Frame gets docked to the east
TAB | Frame gets docked as tabfolder


DOCK-FRAME-AT method

Applies to: P-DOCKMAN
Syntax:
oClass:DOCK-FRAME-AT(
      DOCKFRAME, , ).
Param Data type Description
DOCKFRAME P-DOCKFRAME
value-set

Values:

Value | Description
NORTH | Frame gets docked to the north
SOUTH | Frame gets docked to the south
WEST | Frame gets docked to the west
EAST | Frame gets docked to the east
TAB | Frame gets docked as tabfolder
P-DOCKFRAME


ADD-DOCKFRAME method

Applies to: P-DOCKMAN
Syntax:
oClass:ADD-DOCKFRAME(
      DOCKFRAME, ).

Param | Data type | Description
DOCKFRAME | P-DOCKFRAME |
 | boolean |


P-DOCKGROUP class

P-DOCKGROUP
extended by SC-OBJECT

Attributes

GROUP-TYPE
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

ADD-DOCKFRAME REMOVE-DOCKFRAME

Events


GROUP-TYPE attribute

Data type: value-set
Values:
Value | Description
TABFOLDER | Group is represented by a tabfolder
HORIZONTAL-SPLIT | Group is represented by a horizontal splitter
VERTICAL-SPLIT | Group is represented by a vertical splitter
Access: Readable / Writeable
Applies to: P-DOCKGROUP


REMOVE-DOCKFRAME method

Applies to: P-DOCKGROUP
Syntax:
oClass:REMOVE-DOCKFRAME(
      DOCKFRAME).

Param | Data type | Description
DOCKFRAME | P-DOCKFRAME |


ADD-DOCKFRAME method

Applies to: P-DOCKGROUP
Syntax:
oClass:ADD-DOCKFRAME(
      DOCKFRAME, ).

Param | Data type | Description
DOCKFRAME | P-DOCKFRAME |
 | boolean |


P-DOCKFRAME class

P-DOCKFRAME
extended by SC-OBJECT

Attributes

ACTIVE | CAPTION-ACTIVE-BGCOLOR
CAPTION-ACTIVE-BGCOLOR-HL | CAPTION-ACTIVE-FGCOLOR
CAPTION-INACTIVE-BGCOLOR | CAPTION-INACTIVE-BGCOLOR-HL
CAPTION-INACTIVE-FGCOLOR | CAPTION-VISIBLE
CLOSEABLE | CONTENT-MIN-HEIGHT
CONTENT-MIN-WIDTH | FLOATABLE
FLOATED | HIDEABLE
HIDE-POSITION | ICON
KEY * | LABEL
PINNED | SCROLLABLE
* mandatory (must be set to realise object)
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

ACTIVATE | ADD-SPECIAL-BUTTON
CLOSE | SET-CALC-SIZE

Events

DOCKFRAME-ACTIVE | DOCKFRAME-CLOSED
DOCKFRAME-CLOSING | DOCKFRAME-SPECIAL-CHOOSE


SCROLLABLE attribute

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-DOCKFRAME


PINNED attribute

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-DOCKFRAME


LABEL attribute

Data type: | string
Access: | Readable / Writeable
Applies to: | P-DOCKFRAME


KEY attribute

Data type: | string
Access: | Readable / Writeable
Applies to: | P-DOCKFRAME


ICON attribute

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-DOCKFRAME


HIDE-POSITION attribute

Data type: value-set
Values:
Value | Description
NORTH | Frame gets hidden to the north
SOUTH | Frame gets hidden to the south
WEST | Frame gets hidden to the west
EAST | Frame gets hidden to the east
Access: Readable / Writeable
Applies to: P-DOCKFRAME


HIDEABLE attribute

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-DOCKFRAME


FLOATED attribute

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-DOCKFRAME


FLOATABLE attribute

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-DOCKFRAME


CONTENT-MIN-WIDTH attribute

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-DOCKFRAME


CONTENT-MIN-HEIGHT attribute

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-DOCKFRAME


CLOSEABLE attribute

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-DOCKFRAME


CAPTION-VISIBLE attribute

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-DOCKFRAME


CAPTION-INACTIVE-FGCOLOR attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-DOCKFRAME


CAPTION-INACTIVE-BGCOLOR-HL attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-DOCKFRAME


CAPTION-INACTIVE-BGCOLOR attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-DOCKFRAME


CAPTION-ACTIVE-FGCOLOR attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-DOCKFRAME


CAPTION-ACTIVE-BGCOLOR-HL attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-DOCKFRAME


CAPTION-ACTIVE-BGCOLOR attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-DOCKFRAME


ACTIVE attribute

Data type: | boolean
Default value: | true
Access: | Readable
Applies to: | P-DOCKFRAME


SET-CALC-SIZE method

Applies to: P-DOCKFRAME
Syntax:
oClass:SET-CALC-SIZE(
      WIDTH-PIXELS, HEIGHT-PIXELS).

Param | Data type | Description
WIDTH-PIXELS | integer | width used for size-calculations
HEIGHT-PIXELS | integer | height used for size-calculations


CLOSE method

Applies to: P-DOCKFRAME
Syntax:
oClass:CLOSE(
      ).


ADD-SPECIAL-BUTTON method

Applies to: P-DOCKFRAME
Syntax:
oClass:ADD-SPECIAL-BUTTON(
      BUTTON-KEY, BUTTON-ICON, AUTOMATIC-RECOLORING).

Param | Data type | Description
BUTTON-KEY | string | button key
BUTTON-ICON | A-ICON | button icon
AUTOMATIC-RECOLORING | boolean | if set to true icon-pixels get automatically recolored from BLACK to fg-color currently used by the button


ACTIVATE method

Applies to: P-DOCKFRAME
Syntax:
oClass:ACTIVATE(
      ).


P-DIALOG class

P-DIALOG
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

The following figure shows a dialog with a default button:

A dialog is simular a P-WINDOW but differs from in three points:

  • It has a system window ventilator, but has no affordances for minimizing or maximizing.
  • While a dialog box has input focus, your application cannot perform any other processing until you complete the input or otherwise close the dialog box. That is, it is modal.
  • A dialog has a default button that is emphasised. If user pressed enter key the default button will be activated.

A dialog has no icon in the title bar if it isn't RESIZEABLE. Otherwise it obtains its icon form the last focused window.

Attributes

ALWAYS-ON-TOP | BGCOLOR
BGIMAGE | DEFAULT-BUTTON
OWNER * | RESIZABLE
SCROLLABLE | STATUS-BAR-TEXT
STATUS-BAR-VISIBLE | TITLE
UNDECORATED | UPDATE-LOCKED
VIRTUAL-HEIGHT-PIXELS | VIRTUAL-WIDTH-PIXELS
VISIBLE |
* mandatory (must be set to realise object)
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

CENTER-ON-OWNER | CENTER-ON-SCREEN
TO-TOP |
inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

ENTRY | LEAVE
RESIZED | WINDOW-CLOSE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY

Example:

/**
 *  The example create a P-DIALOG that containts a P-TEXT and a P-BUTTON.
 *  The button is set as default button.
 */

DEFINE VARIABLE oDialog AS P-DIALOG    NO-UNDO.
DEFINE VARIABLE oText   AS P-TEXT      NO-UNDO.
DEFINE VARIABLE oButton AS P-BUTTON      NO-UNDO.

oDialog = NEW P-DIALOG(THIS-PROCEDURE).
oDialog:NAME          = "About".
oDialog:TITLE         = "About...".
oDialog:WIDTH-PIXELS  = 280.
oDialog:HEIGHT-PIXELS = 80.
oDialog:Y             = 300.
oDialog:X             = 300.
oDialog:VISIBLE       = YES.
oDialog:PARENT        = SKIN-CLIENT:oINSTANCE.
oDialog:WINDOW-CLOSE  = "DialogClose".
oDialog:RESIZABLE     = NO.

oText = NEW P-TEXT(THIS-PROCEDURE).
oText:NAME                 = "version1".
oText:INPUT-VALUE          = "Skin-Client Webdemo 1.0".
oText:HEIGHT-PIXELS        = 25.
oText:WIDTH-PIXELS         = 280.
oText:Y                    = 10.
oText:X                    = 0.
oText:PARENT               = oDialog.
oText:HORIZONTAL-ALIGNMENT = "CENTER".

oButton = NEW P-BUTTON(THIS-PROCEDURE).
oButton:NAME          = "btOK".
oButton:LABEL         = "OK".
oButton:HEIGHT-PIXELS = 25.
oButton:WIDTH-PIXELS  = 80.
oButton:X             = 100.
oButton:Y             = 50.
oButton:PARENT        = oDialog.
oButton:CHOOSE        = "DialogClose".


VISIBLE attribute

Indicates whether a widget is currently visible on the display.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-DIALOG


VIRTUAL-WIDTH-PIXELS attribute

The maximum width of the dialog's content area, in pixels.

For a SCROLLABLE dialog, VIRTUAL-WIDTH-PIXELS specifies the width of the entire content area while WIDTH-PIXELS specifies the width of the visible portion of the content area.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-DIALOG


VIRTUAL-HEIGHT-PIXELS attribute

The maximum height of the dialog's content area, in pixels.

For a SCROLLABLE dialog, VIRTUAL-HEIGHT-PIXELS specifies the height of the entire content area while HEIGHT-PIXELS specifies the height of the visible portion of the content area.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-DIALOG


UPDATE-LOCKED attribute

If the UPDATE-LOCKED attribute is TRUE, the dialog will ignore any paint requests (triggered by user OR application) until the attribute is reset to FALSE.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-DIALOG


UNDECORATED attribute

Indicates whether this dialog is undecorated. By default, all dialogs are initially decorated.

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-DIALOG


TITLE attribute

The title of the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-DIALOG


STATUS-BAR-VISIBLE attribute

Indicates whether a status-bar is visible.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-DIALOG


STATUS-BAR-TEXT attribute

The status bar text of the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-DIALOG


SCROLLABLE attribute

If the SCROLLABLE attribute is TRUE, the dialog's content area can be bigger than the display space allotted to it (that is, it is scrollable). If SCROLLABLE is FALSE, the content area must fit within the allotted display space; it cannot be made to scroll.

The VIRTUAL-HEIGHT-PIXELS and VIRTUAL-WIDTH-PIXELS attributes control the virtual or maximum size of the dialog's content area.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-DIALOG


RESIZABLE attribute

Indicates whether the user can resize a widget at run time.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-DIALOG


OWNER attribute

The owner of the new dialog. If not set the owner is determined automatically

Data type: | AJ-COMPONENT
Access: | Readable / Writeable
Applies to: | P-DIALOG


DEFAULT-BUTTON attribute

The default button of the window.

Data type: | P-BUTTON
Access: | Readable / Writeable
Applies to: | P-DIALOG


BGIMAGE attribute

The background image of the widget.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-DIALOG


BGCOLOR attribute

The background color of the widget.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-DIALOG


ALWAYS-ON-TOP attribute

Since Java 1.5. Changes the always-on-top window state. An always-on-top window is a window that stays above all other windows except maybe other always-on-top windows. If there are several always-on-top windows the order in which they stay relative to each other is not specified and is platform dependent.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-DIALOG


TO-TOP method

Move window to top.

Applies to: P-DIALOG
Syntax:
oClass:TO-TOP(
      ).


CENTER-ON-SCREEN method

Center dialog on the screen.

Applies to: P-DIALOG
Syntax:
oClass:CENTER-ON-SCREEN(
      ).


CENTER-ON-OWNER method

Center dialog relative to its owner

Applies to: P-DIALOG
Syntax:
oClass:CENTER-ON-OWNER(
      ).


P-DATE-PICKER class

P-DATE-PICKER
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

A date picker is a particular fill-in for date values. The user can select a date from the drop-down month calendar, which appears at the user's request.

Attributes

FORMAT | INPUT-VALUE
LABEL | LABEL-BGCOLOR
LABEL-FGCOLOR | LABEL-FONT
READ-ONLY | SUBTYPE *
TIME-IN-MILLIS |
* mandatory (must be set to realise object)
inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

CLEAR-ALL-BACKGROUNDS | CLEAR-ALL-FOREGROUNDS
CLEAR-BACKGROUND-AT | CLEAR-FOREGROUND-AT
GET-BACKGROUND-AT | GET-FOREGROUND-AT
SET-BACKGROUND-AT | SET-FOREGROUND-AT
inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

VALUE-CHANGED
inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY

Example:

DEFINE VARIABLE oDatePicker AS P-DATE-PICKER    NO-UNDO.

oDatePicker = NEW P-DATE-PICKER(THIS-PROCEDURE).
oDatePicker:NAME            = "Date-Picker".
oDatePicker:SUBTYPE         = "DROP-DOWN".
oDatePicker:LABEL           = "Label:".
oDatePicker:HEIGHT-PIXELS   = 20.
oDatePicker:WIDTH-PIXELS    = 100.
oDatePicker:Y               = 10.
oDatePicker:X               = 30.
oDatePicker:PARENT          = oFrame.


TIME-IN-MILLIS attribute

Time in milliseconds.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-DATE-PICKER


SUBTYPE attribute

Subtype of the date-picker, either SIMPLE or DROP-DOWN.

Data type: value-set
Values:
Value | Description
SIMPLE | Simple date-picker subtype
DROP-DOWN | Drop-Down date-picker subtype
BUTTONLESS | Buttonless date-picker subtype
Access: Readable / Writeable
Applies to: P-DATE-PICKER


READ-ONLY attribute

Indicates whether a widget is write-protected.

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-DATE-PICKER


LABEL-FONT attribute

The font of widget's label.

Data type: | J-FONT
Access: | Readable / Writeable
Applies to: | P-DATE-PICKER


LABEL-FGCOLOR attribute

The color of widget's label.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-DATE-PICKER


LABEL-BGCOLOR attribute

The background color of widget's label.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-DATE-PICKER


LABEL attribute

The label of the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-DATE-PICKER


INPUT-VALUE attribute

The date of the date picker. must be in the form mmddyyyy, when set.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-DATE-PICKER


FORMAT attribute

The display/input date format.

Data type: | string
Default value: | 99/99/99
Access: | Readable / Writeable
Applies to: | P-DATE-PICKER


SET-FOREGROUND-AT method

Sets a 'special' foreground color for a specific date.

Applies to: P-DATE-PICKER
Syntax:
oClass:SET-FOREGROUND-AT(
      DATE, COLOR).

Param | Data type | Description
DATE | string | date
COLOR | J-COLOR | color


SET-BACKGROUND-AT method

Sets a 'special' background color for a specific date.

Applies to: P-DATE-PICKER
Syntax:
oClass:SET-BACKGROUND-AT(
      DATE, COLOR).

Param | Data type | Description
DATE | string | date
COLOR | J-COLOR | color


GET-FOREGROUND-AT method

Returns the foreground color for a specific date.

Return type: J-COLOR
Applies to: P-DATE-PICKER
Syntax:
oReturn = oClass:GET-FOREGROUND-AT(
      DATE).

Param | Data type | Description
DATE | string | date


GET-BACKGROUND-AT method

Returns the background color for a specific date.

Return type: J-COLOR
Applies to: P-DATE-PICKER
Syntax:
oReturn = oClass:GET-BACKGROUND-AT(
      DATE).

Param | Data type | Description
DATE | string | date


CLEAR-FOREGROUND-AT method

Resets a 'special' foreground color that has been previously set for a specific date.

Applies to: P-DATE-PICKER
Syntax:
oClass:CLEAR-FOREGROUND-AT(
      DATE).

Param | Data type | Description
DATE | string | date


CLEAR-BACKGROUND-AT method

Resets a 'special' background color that has been previously set for a specific date.

Applies to: P-DATE-PICKER
Syntax:
oClass:CLEAR-BACKGROUND-AT(
      DATE).

Param | Data type | Description
DATE | string | date


CLEAR-ALL-FOREGROUNDS method

Resets all 'special' foreground colors that have been previously set.

Applies to: P-DATE-PICKER
Syntax:
oClass:CLEAR-ALL-FOREGROUNDS(
      ).


CLEAR-ALL-BACKGROUNDS method

Resets all 'special' background colors that have been previously set.

Applies to: P-DATE-PICKER
Syntax:
oClass:CLEAR-ALL-BACKGROUNDS(
      ).


P-CUSTOM-BROWSE class

P-CUSTOM-BROWSE
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

Attributes

LABEL | LABEL-BGCOLOR
LABEL-FGCOLOR | LABEL-FONT
MULTIPLE | NUM-SELECTED-ROWS
ROW-HEIGHT-PIXELS | SELECTED
SELECTED-BGCOLOR |
inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

APPEND-ROW | CLEAR-SELECTION
EMPTY | FINISH-MULTI-ROW-APPEND
REGISTER-ICON-CHILD | REGISTER-TEXT-CHILD
SET-BGCOLOR-AT | SET-FGCOLOR-AT
SET-ICON-AT | START-MULTI-ROW-APPEND
inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

OFF-END | OFF-HOME
VALUE-CHANGED |
inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY


SELECTED-BGCOLOR attribute

The background color of selected rows.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-CUSTOM-BROWSE


SELECTED attribute

IDs of the selected rows.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-CUSTOM-BROWSE


ROW-HEIGHT-PIXELS attribute

The row height, in pixels.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-CUSTOM-BROWSE


NUM-SELECTED-ROWS attribute

The number of selected rows.

Data type: | integer
Default value: | 0
Access: | Readable
Applies to: | P-CUSTOM-BROWSE


MULTIPLE attribute

If attribute is TRUE the user is able to select multiple rows.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-CUSTOM-BROWSE


LABEL-FONT attribute

The font of widget's label.

Data type: | J-FONT
Access: | Readable / Writeable
Applies to: | P-CUSTOM-BROWSE


LABEL-FGCOLOR attribute

The color of widget's label.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-CUSTOM-BROWSE


LABEL-BGCOLOR attribute

The background color of widget's label.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-CUSTOM-BROWSE


LABEL attribute

The label of the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-CUSTOM-BROWSE


START-MULTI-ROW-APPEND method

Tells the widgets that multiple rows will be appended next. The client may use this information for optimization.

Applies to: P-CUSTOM-BROWSE
Syntax:
oClass:START-MULTI-ROW-APPEND(
      KEEP-ROWS).

Param | Data type | Description
KEEP-ROWS | boolean | Indicates if existing rows should be kept after finishing appending rows


SET-ICON-AT method

Applies to: P-CUSTOM-BROWSE
Syntax:
oClass:SET-ICON-AT(
      ROW-ID, DATA-COLUMN-INDEX, ICON).

Param | Data type | Description
ROW-ID | string | row ID
DATA-COLUMN-INDEX | integer | index of data-column
ICON | A-ICON | icon


SET-FGCOLOR-AT method

Applies to: P-CUSTOM-BROWSE
Syntax:
oClass:SET-FGCOLOR-AT(
      ROW-ID, DATA-COLUMN-INDEX, FG-COLOR).

Param | Data type | Description
ROW-ID | string | row ID
DATA-COLUMN-INDEX | integer | index of data-column
FG-COLOR | J-COLOR | foreground color


SET-BGCOLOR-AT method

Applies to: P-CUSTOM-BROWSE
Syntax:
oClass:SET-BGCOLOR-AT(
      ROW-ID, DATA-COLUMN-INDEX, BG-COLOR).

Param | Data type | Description
ROW-ID | string | row ID
DATA-COLUMN-INDEX | integer | index of data-column
BG-COLOR | J-COLOR | background color


REGISTER-TEXT-CHILD method

Applies to: P-CUSTOM-BROWSE
Syntax:
oClass:REGISTER-TEXT-CHILD(
      DATA-COLUMN-INDEX, COMPONENT).

Param | Data type | Description
DATA-COLUMN-INDEX | integer | index of data-column to use for the child
COMPONENT | AJ-COMPONENT | The child to register.


REGISTER-ICON-CHILD method

Applies to: P-CUSTOM-BROWSE
Syntax:
oClass:REGISTER-ICON-CHILD(
      DATA-COLUMN-INDEX, COMPONENT).

Param | Data type | Description
DATA-COLUMN-INDEX | integer | index of data-column to use for the child
COMPONENT | AJ-COMPONENT | The child to register.


FINISH-MULTI-ROW-APPEND method

Tells the widgets that appending multiple rows is done. The client may use this information for optimization. This method has to be called if START-MULTI-ROW-APPEND has been called previously.

Applies to: P-CUSTOM-BROWSE
Syntax:
oClass:FINISH-MULTI-ROW-APPEND(
      ROW-IDS).

Param | Data type | Description
ROW-IDS | string | IDs of the rows to select


EMPTY method

Remove all rows from browse.

Applies to: P-CUSTOM-BROWSE
Syntax:
oClass:EMPTY(
      ).


CLEAR-SELECTION method

Removes the highlight from the currently selected rows.

Applies to: P-CUSTOM-BROWSE
Syntax:
oClass:CLEAR-SELECTION(
      ).


APPEND-ROW method

Create a row and redraw browse to display the new row.

The row is specified by row ID and a list of values separated by delimiter.

Applies to: P-CUSTOM-BROWSE
Syntax:
oClass:APPEND-ROW(
      ROW-ID, ROW-DATA).

Param | Data type | Description
ROW-ID | string | row ID
ROW-DATA | string | row-data


P-COMBO-BOX class

P-COMBO-BOX
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

A component that combines a button or editable fill-in and a drop-down list. The user can select a value from the drop-down list, which appears at the user's request.

Attributes

AUTO-COMPLETION | IGNORE-INVALID-VALUE
IGNORE-PAGE-UP-DOWN | INNER-LINES
INPUT-VALUE | LABEL
LABEL-BGCOLOR | LABEL-FGCOLOR
LABEL-FONT | LIST-ITEM-PAIRS
LIST-ITEMS | LIST-WIDTH-PIXELS
SUBTYPE |
inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

SET-ICON
inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

VALUE-CHANGED
inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY

Example:

/**
 *  The example creates a combo box with three items.
 */

DEFINE VARIABLE oComboBox AS P-COMBO-BOX    NO-UNDO.

oComboBox = NEW P-COMBO-BOX(THIS-PROCEDURE).
oComboBox:NAME            = "Combo-Box".
oComboBox:LABEL           = "Label".
oComboBox:HEIGHT-PIXELS   = 20.
oComboBox:WIDTH-PIXELS    = 150.
oComboBox:Y               = 5.
oComboBox:X               = 35.
oComboBox:PARENT          = oFrame.
oComboBox:LIST-ITEM-PAIRS = "Item1,I1,Item2,I2,Item3,I3".


SUBTYPE attribute

Subtype of the combo-box, either DROP-DOWN or DROP-DOWN-LIST.

Data type: value-set
Values:
Value | Description
DROP-DOWN | Editable combo-box subtype
DROP-DOWN-LIST | Simple drop-down combo-box subtype
Access: Readable / Writeable
Applies to: P-COMBO-BOX


LIST-WIDTH-PIXELS attribute

-1 = same as width-pixels; 0 = auto-fit

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-COMBO-BOX


LIST-ITEMS attribute

A list of the items.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-COMBO-BOX


LIST-ITEM-PAIRS attribute

A list of the label-value pairs.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-COMBO-BOX


LABEL-FONT attribute

The font of widget's label.

Data type: | J-FONT
Access: | Readable / Writeable
Applies to: | P-COMBO-BOX


LABEL-FGCOLOR attribute

The color of widget's label.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-COMBO-BOX


LABEL-BGCOLOR attribute

The background color of widget's label.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-COMBO-BOX


LABEL attribute

The label of the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-COMBO-BOX


INPUT-VALUE attribute

The input-value of the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-COMBO-BOX


INNER-LINES attribute

The number of inner lines.

Data type: | integer
Default value: | 8
Access: | Readable / Writeable
Applies to: | P-COMBO-BOX


IGNORE-PAGE-UP-DOWN attribute

Sets whether this combo box should ignore key presses PAGE-UP and PAGE-DOWN

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-COMBO-BOX


IGNORE-INVALID-VALUE attribute

Sets whether this combo box should ignore INPUT-VALUEs that are not available in the list

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-COMBO-BOX


AUTO-COMPLETION attribute

Sets whether this combo box should automatically complete the values typed in to match the items in the drop down list, if possible.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-COMBO-BOX


SET-ICON method

Assign a icon that should be display with the specified input value. To remove a icon assign a unknown value (\?).

Applies to: P-COMBO-BOX
Syntax:
oClass:SET-ICON(
      INPUT-VALUE, IMAGE).

Param | Data type | Description
INPUT-VALUE | string | input value
IMAGE | A-ICON | image


P-BUTTON class

P-BUTTON
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

The widget P-BUTTON represents a push button on the screen. The button can contain a textual label or it can have images associated with its possible states:

  • normal state
  • button is pressed
  • mouse is over the button (rollover)
  • button is disabled

Attributes

AUTO-DROP-DOWN-MENU | DISABLED-ICON
DISABLED-SELECTED-ICON | DROP-DOWN-BUTTON
FLAT-BUTTON | HORIZONTAL-LABEL-POS
ICON | LABEL
MNEMONIC | PAINT-FOCUS
PRESSED-ICON | ROLLOVER-ENABLED
ROLLOVER-ICON | ROLLOVER-SELECTED-ICON
SELECTED-ICON | VERTICAL-LABEL-POS
inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

HIDE-DROP-DOWN | SET-ACCELERATOR
SET-MARGIN | SHOW-DROP-DOWN
inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

CHOOSE
inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY

Example:

/**
 *  The example creates a push-button without 3D-effect in a frame.
 *  A message box will be shown if button pressed.
 */

DEFINE VARIABLE oButton AS P-BUTTON    NO-UNDO.

oButton = NEW P-BUTTON(THIS-PROCEDURE).
oButton:NAME          = "Button".
oButton:LABEL         = "Button Label".
oButton:HEIGHT-PIXELS = 30.
oButton:WIDTH-PIXELS  = 100.
oButton:X             = 1.
oButton:Y             = 1.
oButton:PARENT        = oFrame.
oButton:FLAT-BUTTON   = YES.
oButton:PAINT-FOCUS   = NO.
oButton:CHOOSE        = "E_Button_CHOOSE".


VERTICAL-LABEL-POS attribute

Vertical position of the text relative to the icon.

Data type: value-set
Values:
Value | Description
TOP |
CENTER |
BOTTOM |
Default value: CENTER
Access: Readable / Writeable
Applies to: P-BUTTON


SELECTED-ICON attribute

The selected icon of the widget.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-BUTTON


ROLLOVER-SELECTED-ICON attribute

The rollover selected icon of the widget.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-BUTTON


ROLLOVER-ICON attribute

The rollover icon of the widget.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-BUTTON


ROLLOVER-ENABLED attribute

Indicates whether the button has a rollover efect.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-BUTTON


PRESSED-ICON attribute

The pressed icon of the widget.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-BUTTON


PAINT-FOCUS attribute

Indicates whether the button has paint focus.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-BUTTON


MNEMONIC attribute

Sets the keyboard mnemonic on this button. The mnemonic is the key which when combined with the look and feel's mouseless modifier (usually Alt) will activate this button if focus is contained somewhere within this button's ancestor window.

A mnemonic must correspond to a single key on the keyboard. Mnemonics are case-insensitive, therefore a key event with the corresponding keycode would cause the button to be activated whether or not the Shift modifier was pressed.

If the character defined by the mnemonic is found within the button's label string, the first occurrence of it will be underlined to indicate the mnemonic to the user.

Data type: value-set
Values:
Value | Description
UNDEFINED | No mnemonic key defined.
A | A key
B | B key
C | C key
D | D key
E | E key
F | F key
G | G key
H | H key
I | I key
J | J key
K | K key
L | L key
M | M key
N | N key
O | O key
P | P key
Q | Q key
R | R key
S | S key
T | T key
U | U key
V | V key
W | W key
X | X key
Y | Y key
Z | Z key
0 | 0 key
1 | 1 key
2 | 2 key
3 | 3 key
4 | 4 key
5 | 5 key
6 | 6 key
7 | 7 key
8 | 8 key
9 | 9 key
Default value: UNDEFINED
Access: Readable / Writeable
Applies to: P-BUTTON


LABEL attribute

The label of the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-BUTTON


ICON attribute

The icon of the widget.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-BUTTON


HORIZONTAL-LABEL-POS attribute

The horizontal position of the label relative to the icon.

Data type: value-set
Values:
Value | Description
RIGHT | Right position in an area.
LEFT | Left position in an area.
CENTER | The central position in an area.
LEADING | Identifies the leading edge of text for use with left-to-right and right-to-left languages.
TRAILING | Identifies the trailing edge of text for use with left-to-right and right-to-left languages.
Default value: TRAILING
Access: Readable / Writeable
Applies to: P-BUTTON


FLAT-BUTTON attribute

Paint button without 3D-effect (i.e. without border).

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-BUTTON


DROP-DOWN-BUTTON attribute

Indicates whether the button is a drop down button.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-BUTTON


DISABLED-SELECTED-ICON attribute

The disabled selected icon of the widget.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-BUTTON


DISABLED-ICON attribute

The disabled icon of the widget.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-BUTTON


AUTO-DROP-DOWN-MENU attribute

If the button has a drop-down menu this attribute indicates whether the dropdown menu should be displayed automatically (on choose).
Otherwise the developer can decide if and when to display the menu by code.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-BUTTON


SHOW-DROP-DOWN method

If the button has a drop-down menu this method can be used to display the menu by code.

Applies to: P-BUTTON
Syntax:
oClass:SHOW-DROP-DOWN(
      ).


SET-MARGIN method

Sets space for margin between the button's border and the label.

Applies to: P-BUTTON
Syntax:
oClass:SET-MARGIN(
      TOP-MARGIN-PIXELS, LEFT-MARGIN-PIXELS, BOTTOM-MARGIN-PIXELS, RIGHT-MARGIN-PIXELS).

Param | Data type | Description
TOP-MARGIN-PIXELS | integer | Top margin, in pixels.
LEFT-MARGIN-PIXELS | integer | Left margin, in pixels.
BOTTOM-MARGIN-PIXELS | integer | Bottom margin, in pixels.
RIGHT-MARGIN-PIXELS | integer | Right margin, in pixels.


SET-ACCELERATOR method

Sets the key combination which fires CHOOSE event without navigating the menu hierarchy. Note that when the keyboard accelerator is typed, it will work whether or not the menu is currently displayed.

Applies to: P-BUTTON
Syntax:
oClass:SET-ACCELERATOR(
      KEY-CODE, MODIFIERS, ON-KEY-RELEASE).
Param | Data type | Description
KEY-CODE value-set key code

Values:

Value | Description
UNDEFINED | No accelerator key defined.
A |
B |
C |
D |
E |
F |
G |
H |
I |
J |
K |
L |
M |
N |
O |
P |
Q |
R |
S |
T |
U |
V |
W |
X |
Y |
Z |
0 |
1 |
2 |
3 |
4 |
5 |
6 |
7 |
8 |
9 |
ENTER |
ESC |
CTRL |
ALT |
ALT-GR |
TAB |
SPACE |
DEL |
F1 |
F2 |
F3 |
F4 |
F5 |
F6 |
F7 |
F8 |
F9 |
F10 |
F11 |
F12 |
LEFT |
RIGHT |
END |
UP |
DOWN |
PAGE-DOWN |
PAGE-UP |
PAUSE |
PASTE |

Note: The value may be combined of multiple values. The values are separated by plus (+).
MODIFIERS value-set modifiers

Values:

Value | Description
UNDEFINED | No modifier key defined.
SHIFT | Shift key
CTRL | Ctrl key
ALT | Alt key
ALT-GRAPH | Alt key
META | Meta key
LEFT-MOUSE | Left mouse button
MIDDLE-MOUSE | Middle mouse button
RIGHT-MOUSE | Right mouse button

Note: The value may be combined of multiple values. The values are separated by plus (+).
ON-KEY-RELEASE | boolean | on key release - true if the KeyStroke should represent a key release; false otherwise


HIDE-DROP-DOWN method

If the button has a drop-down menu this method can be used to hide the menu by code.

Applies to: P-BUTTON
Syntax:
oClass:HIDE-DROP-DOWN(
      ).


P-BROWSE-COLUMN class

P-BROWSE-COLUMN
extended by SC-OBJECT

Before a P-BROWSE can show data you have to assign P-BROWSE-COLUMN children. You may also want to manipulate the visibility of the column and obtain events. By initially assigning a buffer-field (handle) the label, data-type and format attributes of the browse-column are set (overwritten) by the values of the buffer-field. (You may overwrite these attributes by setting the attribute using sc_set afterwards.) Alternativly to the browse-column set-* methods the sc_setX procedure might be used to access the cell attributes.

Attributes

BUFFER-FIELD | COLUMN-BGCOLOR
COLUMN-FGCOLOR | DATA-TYPE
DISPLAY-TYPE | FONT
FORMAT | HEADER-ALIGNMENT
HORIZONTAL-ALIGNMENT | INNER-LINES
LABEL | LABEL-BGCOLOR
LABEL-FGCOLOR | LABEL-FONT
LIST-ITEM-PAIRS | LOOKUP-ICON
MAX-WIDTH-PIXELS | MIN-WIDTH-PIXELS
NEXT-COLUMN | READ-ONLY
RESIZABLE | SELECTABLE
SORTING-ENABLE | START-SEARCH-ENABLE
VERTICAL-ALIGNMENT | VISIBLE
WIDTH-PIXELS |
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

MOVE-COLUMN | REQUEST-FOCUS
SET-BGCOLOR | SET-FGCOLOR
SET-FONT | SET-ICON
SET-ICON-CB | SET-INPUT-VALUE
SET-INPUT-VALUE-EX | SET-READ-ONLY
SET-SORT-ARROW |

Events

CELL-MOUSE-ENTERED | CELL-MOUSE-EXITED
CHOOSE | COLUMN-ENTRY
COLUMN-LEAVE | END-MOVE
END-RESIZE | END-SEARCH
NEXT-COLUMN-CHANGED | RESIZED
START-MOVE | START-SEARCH
VALUE-CHANGED |

Example:

/**
 *  The example creates a new column for a P-BROWSE widget.
 *  SORTING-ENABLE + START-SEARCH allows the user to order the rows
 *  by clicking on column header.
 */

DEFINE VARIABLE oBrowseCol AS P-BROWSE-COLUMN    NO-UNDO.

oBrowseCol = NEW P-BROWSE-COLUMN(THIS-PROCEDURE).
oBrowseCol:NAME           = "Browse-Column1".
oBrowseCol:PARENT         = oBrowse.
oBrowseCol:BUFFER-FIELD   = BUFFER Customer:BUFFER-FIELD("CustNum"):HANDLE.
oBrowseCol:START-SEARCH   = "YES".
oBrowseCol:SORTING-ENABLE = YES.


WIDTH-PIXELS attribute

The width of the widget, in pixels.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-BROWSE-COLUMN


VISIBLE attribute

Indicates whether a widget is currently visible on the display.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-BROWSE-COLUMN


VERTICAL-ALIGNMENT attribute

The vertical alignment of browse cell values.

Data type: value-set
Values:
Value | Description
TOP |
CENTER |
BOTTOM |
Access: Readable / Writeable
Applies to: P-BROWSE-COLUMN


START-SEARCH-ENABLE attribute

If attribute is TRUE and the user clicks on the column header an up pointing arrow will be shown at the first time. On the next time the arrow between up and down.

A START-SEARCH event will be fired.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-BROWSE-COLUMN


SORTING-ENABLE attribute

If attribute is TRUE and the user clicks on the column header an up pointing arrow will be shown at the first time. On the next time the arrow between up and down. If value of START-SEARCH-ENABLE attribute = FALSE then the P-BROWSE object sorts it's rows itself.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-BROWSE-COLUMN


SELECTABLE attribute

Indicates whether the column can get selected

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-BROWSE-COLUMN


RESIZABLE attribute

Indicates whether the user can resize a widget at run time.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-BROWSE-COLUMN


READ-ONLY attribute

Indicates whether INPUT-VALUEs of this column is write-protected.
Note: The INPUT-VALUEs of this column is not write-protected (modifiable by user) if and only if READ-ONLY attribute of P-BROWSE-COLUMN and READ-ONLY attribute of P-BROWSE are FALSE.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-BROWSE-COLUMN


NEXT-COLUMN attribute

Indicates the browse column visible on the right hand side or /? (unknown value) if this is the last browse column.

The NEXT-COLUMN-CHANGED event will be fired if NEXT-COLUMN has changed.

Data type: | P-BROWSE-COLUMN
Access: | Readable
Applies to: | P-BROWSE-COLUMN


MIN-WIDTH-PIXELS attribute

The minimum width of a browse-column, in pixels.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-BROWSE-COLUMN


MAX-WIDTH-PIXELS attribute

The maximum width of a browse-column, in pixels.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-BROWSE-COLUMN


LOOKUP-ICON attribute

The icon that is used for buttons of LOOKUP-columns

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-BROWSE-COLUMN


LIST-ITEM-PAIRS attribute

A list of the label-value pairs associated.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-BROWSE-COLUMN


LABEL-FONT attribute

Font of the header label.

Data type: | J-FONT
Access: | Readable / Writeable
Applies to: | P-BROWSE-COLUMN


LABEL-FGCOLOR attribute

Color of the header label.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BROWSE-COLUMN


LABEL-BGCOLOR attribute

Color of the header background.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BROWSE-COLUMN


LABEL attribute

The header label of the browse column.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-BROWSE-COLUMN


INNER-LINES attribute

The number of inner lines (COMBO-BOX-mode)

Data type: | integer
Default value: | 3
Access: | Readable / Writeable
Applies to: | P-BROWSE-COLUMN


HORIZONTAL-ALIGNMENT attribute

The horizontal alignment of browse cell values.

Data type: value-set
Values:
Value | Description
RIGHT | Right position in an area.
LEFT | Left position in an area.
CENTER | The central position in an area.
LEADING | Identifies the leading edge of text for use with left-to-right and right-to-left languages.
TRAILING | Identifies the trailing edge of text for use with left-to-right and right-to-left languages.
Access: Readable / Writeable
Applies to: P-BROWSE-COLUMN


HEADER-ALIGNMENT attribute

The alignment of the header label.

Data type: value-set
Values:
Value | Description
LEFT |
CENTER |
RIGHT |
Access: Readable / Writeable
Applies to: P-BROWSE-COLUMN


FORMAT attribute

Please see the description at FORMAT attribute of P-FILL-IN widget .

Data type: | string
Default value: |
Access: | Readable / Writeable
Applies to: | P-BROWSE-COLUMN


FONT attribute

Font of browse column cell text.

Data type: | J-FONT
Access: | Readable / Writeable
Applies to: | P-BROWSE-COLUMN


DISPLAY-TYPE attribute

The display type of this column.

Data type: value-set
Values:
Value | Description
FILL-IN |
COMBO-BOX |
TOGGLE-BOX |
IMAGE |
LOOKUP |
Default value: FILL-IN
Access: Readable / Writeable
Applies to: P-BROWSE-COLUMN


DATA-TYPE attribute

Please see the description at FORMAT attribute of P-FILL-IN widget .

Data type: value-set
Values:
Value | Description
LOGICAL | Allows tree values: TRUE (alias YES), FALSE (alias NO) and unknown value (\?).
CHARACTER | Any string.
NUMERIC | Alias for DECIMAL.
INTEGER | Integer numbers.
DECIMAL | Decimal numbers.
DATE | Year, month and day.
DATETIME | Year, month, day, hours, minutes, esconds and milliseconds.
BLOB | Binary data
Default value: CHARACTER
Access: Readable / Writeable
Applies to: P-BROWSE-COLUMN


COLUMN-FGCOLOR attribute

Column foreground color.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BROWSE-COLUMN


COLUMN-BGCOLOR attribute

Column background color.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BROWSE-COLUMN


BUFFER-FIELD attribute

The widget-handle of the browse columns buffer-field.

Data type: | Progress-handle
Access: | Readable / Writeable
Applies to: | P-BROWSE-COLUMN


SET-SORT-ARROW method

Sets the sort arrow-direction of the column, or removes the arrow by setting to NONE

Applies to: P-BROWSE-COLUMN
Syntax:
oClass:SET-SORT-ARROW(
      ARROW-DIRECTION).
Param Data type Description
ARROW-DIRECTION value-set arrow direction

Values:

Value | Description
NONE |
UP |
DOWN |


SET-READ-ONLY method

Sets the READ-ONLY attribute of a browse cell. The cell is specified by this column and the row ID.

Applies to: P-BROWSE-COLUMN
Syntax:
oClass:SET-READ-ONLY(
      ROW-ID, READONLY).

Param | Data type | Description
ROW-ID | string | row ID
READONLY | boolean | readonly


SET-INPUT-VALUE-EX method

Sets the input value of a browse cell. The cell is specified by this column and the row ID.

Applies to: P-BROWSE-COLUMN
Syntax:
oClass:SET-INPUT-VALUE-EX(
      ROW-ID, INPUT-VALUE, DATA-TYPE, FORMAT).
Param | Data type | Description
ROW-ID | string | row ID
INPUT-VALUE | string | input value
DATA-TYPE value-set data type

Values:

Value | Description
LOGICAL | Allows tree values: TRUE (alias YES), FALSE (alias NO) and unknown value (\?).
CHARACTER | Any string.
NUMERIC | Alias for DECIMAL.
INTEGER | Integer numbers.
DECIMAL | Decimal numbers.
DATE | Year, month and day.
DATETIME | Year, month, day, hours, minutes, esconds and milliseconds.
BLOB | Binary data
FORMAT | string | format


SET-INPUT-VALUE method

Sets the input value of a browse cell. The cell is specified by this column and the row ID.

Applies to: P-BROWSE-COLUMN
Syntax:
oClass:SET-INPUT-VALUE(
      ROW-ID, INPUT-VALUE).

Param | Data type | Description
ROW-ID | string | row ID
INPUT-VALUE | string | input value


SET-ICON-CB method

This method only applies to COMBO-BOX-columns!

Assign a icon that should be display with the specified input value. To remove a icon assign a unknown value (\?).

Applies to: P-BROWSE-COLUMN
Syntax:
oClass:SET-ICON-CB(
      INPUT-VALUE, IMAGE).

Param | Data type | Description
INPUT-VALUE | string | input value
IMAGE | A-ICON | image


SET-ICON method

Assigns a icon that will additionally displayed in a browse cell specified by this column and the row ID. To remove a icon assign a unknown value (\?).

Applies to: P-BROWSE-COLUMN
Syntax:
oClass:SET-ICON(
      ROW-ID, ICON).

Param | Data type | Description
ROW-ID | string | row ID
ICON | A-ICON |


SET-FONT method

Sets the font of a browse cell. The cell is specified by this column and the row ID.

Applies to: P-BROWSE-COLUMN
Syntax:
oClass:SET-FONT(
      ROW-ID, FONT).

Param | Data type | Description
ROW-ID | string | row ID
FONT | J-FONT | font


SET-FGCOLOR method

Sets the foreground color of a browse cell. The cell is specified by this column and the row ID.

Applies to: P-BROWSE-COLUMN
Syntax:
oClass:SET-FGCOLOR(
      ROW-ID, FG-COLOR).

Param | Data type | Description
ROW-ID | string | row ID
FG-COLOR | J-COLOR | foreground color


SET-BGCOLOR method

Sets the background color of a browse cell. The cell is specified by this column and the row ID.

Applies to: P-BROWSE-COLUMN
Syntax:
oClass:SET-BGCOLOR(
      ROW-ID, BG-COLOR).

Param | Data type | Description
ROW-ID | string | row ID
BG-COLOR | J-COLOR | background color


REQUEST-FOCUS method

Requests that a browse cell get the input focus, and that browse's top-level ancestor become the focused Window.

Applies to: P-BROWSE-COLUMN
Syntax:
oClass:REQUEST-FOCUS(
      ROW-ID).

Param | Data type | Description
ROW-ID | string | row ID


MOVE-COLUMN method

Repositions this column in a browse widget.

The columns of a browse are numbered left to right beginning with 1 including visible but not hidden columns.

Applies to: P-BROWSE-COLUMN
Syntax:
oClass:MOVE-COLUMN(
      NEW-POSITION).

Param | Data type | Description
NEW-POSITION | integer | new position


P-BROWSE class

P-BROWSE
extended by AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

A browse widget lets you see and optinally edit data. You can reorder and change the width of the browse-columns. You can do this through direct manipulation (by pointing, clicking, and dragging) and by the program. When you rotate the mouse wheel up and down, the browse scrolls vertically up and down.

A browse has P-BROWSE-COLUMN children.

The following figure shows a browse widget. For the first column SORTING-ENABLE and START-SEARCH-ENABLE is true and column's attribute DATA-TYPE has the value NUMERIC. That allows the user the order the rows by No. clicking on the column-header.

Attributes

AUTO-RESIZE-MODE | AUTO-ROW-HEIGHT
BGCOLOR | BGCOLOR1
BGCOLOR2 | COLUMN-HEADERS-VISIBLE
COLUMN-SELECTION-ALLOWED | DEFAULT-COLUMN-TABBING
FIRST-COLUMN | FOCUS-HIGHLIGHTING
GRID-COLOR | H-SEPARATORS
LABEL | LABEL-BGCOLOR
LABEL-FGCOLOR | LABEL-FONT
MULTIPLE | NUM-LOCKED-COLUMNS
NUM-ROWS | NUM-SELECTED-COLUMNS
NUM-SELECTED-ROWS | NUM-VISIBLE-COLUMNS
QUERY | READ-ONLY
READ-ONLY-SKIPPING | REORDERING-ALLOWED
ROW-HEIGHT-PIXELS | ROW-MARKERS-VISIBLE
SELECTED | SELECTION-HIGHLIGHTING
SUBTYPE | V-SEPARATORS
inherited from AP-FIELD-LEVEL-WIDGET:
ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

APPEND-ROW | ASNROW
ASSIGN | CLEAR-COLUMN-SELECTION
CLEAR-SELECTION | DELETE-ROW
DISPLAY | DSPROW
EMPTY | FINISH-COLUMN-MULTISELECT-CHANGE
FINISH-MULTI-ROW-APPEND | GET-COLUMN-AT
GET-ROW-AT | GET-ROW-HEIGHT-PIXELS-AT
GET-SELECTED-COLUMN-AT | INSERT-ROW
MOVE-COLUMN | NEW-ROW
SET-CELL-INSETS | SET-COLUMN-SELECTED
SET-HEADER-INSETS | START-COLUMN-MULTISELECT-CHANGE
START-MULTI-ROW-APPEND | UPDATE-ROWS
inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

COLUMN-SELECTION-CHANGED | ENTRY
FIRST-COLUMN-CHANGED | LEAVE
OFF-END | OFF-HOME
ROW-DISPLAY | ROW-ENTRY
ROW-LEAVE | VALUE-CHANGED
inherited from AP-FIELD-LEVEL-WIDGET:
ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY

Example:

/**
 *  The example creates a browse.
 */

DEFINE VARIABLE oBrowse AS P-BROWSE    NO-UNDO.
DEFINE QUERY q-Query FOR Customer SCROLLING.

oBrowse = NEW P-BROWSE(THIS-PROCEDURE).
oBrowse:NAME          = "Browse".
oBrowse:WIDTH-PIXELS  = 800.
oBrowse:HEIGHT-PIXELS = 600.
oBrowse:Y             = 45.
oBrowse:X             = 5.
oBrowse:SENSITIVE     = YES.
oBrowse:MULTIPLE      = NO.
oBrowse:READ-ONLY     = NO.
oBrowse:QUERY         = QUERY q-Query:HANDLE.
oBrowse:TOOLTIP       = "This is a ToolTip".
oBrowse:VISIBLE       = YES.
oBrowse:PARENT        = oFrame.
oBrowse:BGCOLOR1      = oBgColor.


V-SEPARATORS attribute

If attribute is TRUE vertical lines was be shown.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-BROWSE


SUBTYPE attribute

Subtype of the table, either DEFAULT or LASTCOL-AS-ROW.

Data type: value-set
Values:
Value | Description
DEFAULT | The normal COLs x ROWs grid.
LASTCOL-AS-ROW | This renders the last column of a row in line of it own, if a value is set.
Default value: DEFAULT
Access: Readable / Writeable
Applies to: P-BROWSE


SELECTION-HIGHLIGHTING attribute

Indicates whether the Browse should highlight selected rows using its default (look and feel dependent) mechanisms

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-BROWSE


SELECTED attribute

IDs of the selected rows.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-BROWSE


ROW-MARKERS-VISIBLE attribute

Indicates whether a browse uses row markers.
Note: ROW-MARKERS-VISIBLE can NOT be used in conjunction with NUM-LOCKED-COLUMNS.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-BROWSE


ROW-HEIGHT-PIXELS attribute

The row height, in pixels.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-BROWSE


REORDERING-ALLOWED attribute

Indicates whether the reordering is allowed.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-BROWSE


READ-ONLY-SKIPPING attribute

Indicates whether read-only cells are automatically skipped and the next editable cell gets selected if the user presses the TAB-key.

NOTE: This attribute only applies if READ-ONLY = FALSE

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-BROWSE


READ-ONLY attribute

Indicates whether browse's INPUT-VALUEs are write-protected.
Note: The INPUT-VALUEs of a P-BROWSE-COLUMN are not write-protected (modifiable by user) if and only if READ-ONLY attribute of P-BROWSE-COLUMN and READ-ONLY attribute of P-BROWSE are FALSE.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-BROWSE


QUERY attribute

The handle of the query.

Data type: | Progress-handle
Access: | Readable / Writeable
Applies to: | P-BROWSE


NUM-VISIBLE-COLUMNS attribute

The number of visible columns.

Data type: | integer
Default value: | 0
Access: | Readable
Applies to: | P-BROWSE


NUM-SELECTED-ROWS attribute

The number of selected rows.

Data type: | integer
Default value: | 0
Access: | Readable
Applies to: | P-BROWSE


NUM-SELECTED-COLUMNS attribute

Number of selected columns

Data type: | integer
Default value: | 0
Access: | Readable
Applies to: | P-BROWSE


NUM-ROWS attribute

The number of rows.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-BROWSE


NUM-LOCKED-COLUMNS attribute

The number of visible leading columns locked in a browse widget.
Note: NUM-LOCKED-COLUMNS can NOT be used in conjunction with ROW-MARKERS-VISIBLE.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-BROWSE


MULTIPLE attribute

If attribute is TRUE the user is able to select multiple rows.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-BROWSE


LABEL-FONT attribute

The font of widget's label.

Data type: | J-FONT
Access: | Readable / Writeable
Applies to: | P-BROWSE


LABEL-FGCOLOR attribute

The color of widget's label.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BROWSE


LABEL-BGCOLOR attribute

The background color of widget's label.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BROWSE


LABEL attribute

The label of the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-BROWSE


H-SEPARATORS attribute

If attribute is TRUE horizontal lines will be shown.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-BROWSE


GRID-COLOR attribute

The color used to paint the grid (horizontal and vertical separators)

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BROWSE


FOCUS-HIGHLIGHTING attribute

Indicates whether the Browse should highlight focused cells using its default (look and feel dependent) mechanisms

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-BROWSE


FIRST-COLUMN attribute

Data type: | P-BROWSE-COLUMN
Access: | Readable
Applies to: | P-BROWSE


DEFAULT-COLUMN-TABBING attribute

Indicates whether the Browse should select the next column on its own if the user presses the TAB-key.

NOTE: This attribute only applies if READ-ONLY = FALSE

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-BROWSE


COLUMN-SELECTION-ALLOWED attribute

Indicates whether the Browse supports selecting / deselecting columns

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-BROWSE


COLUMN-HEADERS-VISIBLE attribute

Indicates whether the Browse should show column headers

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-BROWSE


BGCOLOR2 attribute

Specifies the secund background color of the widget.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BROWSE


BGCOLOR1 attribute

Specifies the first background color of the widget.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BROWSE


BGCOLOR attribute

The background color of the widget.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BROWSE


AUTO-ROW-HEIGHT attribute

Indicates whether the Browse calculate the height for each row individually

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-BROWSE


AUTO-RESIZE-MODE attribute

Data type: value-set
Values:
Value | Description
OFF | Does not adjust column widths automatically
ALL-COLUMNS | During all resize operations, proportionately resize all columns
LAST-COLUMN | During all resize operations, apply adjustments to the last column only
NEXT-COLUMN | When a column is adjusted in the UI, adjust the next column the opposite way
Access: Readable / Writeable
Applies to: P-BROWSE


UPDATE-ROWS method

Call UPDATE-ROWS after browse is filled by NEW-ROW calls to refresh the browse widget.

Applies to: P-BROWSE
Syntax:
oClass:UPDATE-ROWS(
      ).


START-MULTI-ROW-APPEND method

Tells the widgets that multiple rows will be appended next. The client may use this information for optimization.

Applies to: P-BROWSE
Syntax:
oClass:START-MULTI-ROW-APPEND(
      KEEP-ROWS).

Param | Data type | Description
KEEP-ROWS | boolean | Indicates if existing rows should be kept after finishing appending rows


START-COLUMN-MULTISELECT-CHANGE method

Prevents COLUMN-SELECTION-CHANGED from being fired until FINISH-COLUMN-MULTISELECT-CHANGE gets invoked

Applies to: P-BROWSE
Syntax:
oClass:START-COLUMN-MULTISELECT-CHANGE(
      ).


SET-HEADER-INSETS method

Sets insets used for column-headers

Applies to: P-BROWSE
Syntax:
oClass:SET-HEADER-INSETS(
      TOP, LEFT, BOTTOM, RIGHT).

Param | Data type | Description
TOP | integer | top
LEFT | integer | left
BOTTOM | integer | bottom
RIGHT | integer | right


SET-COLUMN-SELECTED method

Selects or deselects a column

Applies to: P-BROWSE
Syntax:
oClass:SET-COLUMN-SELECTED(
      CHILD-COMPONENT, SELECTED).

Param | Data type | Description
CHILD-COMPONENT | P-BROWSE-COLUMN | child component
SELECTED | boolean | selected


SET-CELL-INSETS method

Sets insets used when displaying cell-values

Applies to: P-BROWSE
Syntax:
oClass:SET-CELL-INSETS(
      TOP, LEFT, BOTTOM, RIGHT).

Param | Data type | Description
TOP | integer | top
LEFT | integer | left
BOTTOM | integer | bottom
RIGHT | integer | right


NEW-ROW method

Create a row but don't refresh the browse. Call method UPDATE-ROWS if filling browse is finished.

The row is specified by row ID and a list of values separated by delimiter.

Applies to: P-BROWSE
Syntax:
oClass:NEW-ROW(
      ROW-ID, ROW-DATA).

Param | Data type | Description
ROW-ID | string | row ID
ROW-DATA | string | row-data


MOVE-COLUMN method

Repositions a column in a browse widget.

The columns of a browse are numbered left to right beginning with 1 including visible but not hidden columns. For example, MOVE-COLUMN(1, 3) moves the first column to the third position (the second column becomes the first column and the third column becomes the second column).

Applies to: P-BROWSE
Syntax:
oClass:MOVE-COLUMN(
      COLUMN-POSITION, NEW-COLUMN-POSITION).

Param | Data type | Description
COLUMN-POSITION | integer | The position of the column to move. Position counting starts with number 1.
NEW-COLUMN-POSITION | integer | The new column position.


INSERT-ROW method

Inserts a new row. The row to insert is specified by row ID and a list of values separated by delimiter and is inserted before the given 'before row ID'.

Applies to: P-BROWSE
Syntax:
oClass:INSERT-ROW(
      BEFORE-ROW-ID, ROW-ID, CELL-VALUES).

Param | Data type | Description
BEFORE-ROW-ID | string | before row ID
ROW-ID | string | row ID
CELL-VALUES | string | list of cell values


GET-SELECTED-COLUMN-AT method

Returns the selected column at the specified index.

Return type: P-BROWSE-COLUMN
Applies to: P-BROWSE
Syntax:
oReturn = oClass:GET-SELECTED-COLUMN-AT(
      SELECTION-INDEX).

Param | Data type | Description
SELECTION-INDEX | integer | selection index


GET-ROW-HEIGHT-PIXELS-AT method

Return type: integer
Applies to: P-BROWSE
Syntax:
_ret = oClass:GET-ROW-HEIGHT-PIXELS-AT(
      ROW-ID).

Param | Data type | Description
ROW-ID | string | row ID


GET-ROW-AT method

Return type: string
Applies to: P-BROWSE
Syntax:
_ret = oClass:GET-ROW-AT(
      X-POSITION, Y-POSITION).

Param | Data type | Description
X-POSITION | integer | x position
Y-POSITION | integer | y position


GET-COLUMN-AT method

Return type: P-BROWSE-COLUMN
Applies to: P-BROWSE
Syntax:
oReturn = oClass:GET-COLUMN-AT(
      X-POSITION, Y-POSITION).

Param | Data type | Description
X-POSITION | integer | x position
Y-POSITION | integer | y position


FINISH-MULTI-ROW-APPEND method

Tells the widgets that appending multiple rows is done. The client may use this information for optimization. This method has to be called if START-MULTI-ROW-APPEND has been called previously.

Applies to: P-BROWSE
Syntax:
oClass:FINISH-MULTI-ROW-APPEND(
      ROW-IDS).

Param | Data type | Description
ROW-IDS | string | IDs of the rows to select


FINISH-COLUMN-MULTISELECT-CHANGE method

Fires COLUMN-SELECTION-CHANGED if selection has changed since START-COLUMN-MULTISELECT-CHANGE was invoked

Applies to: P-BROWSE
Syntax:
oClass:FINISH-COLUMN-MULTISELECT-CHANGE(
      ).


EMPTY method

Remove all rows from browse.

Applies to: P-BROWSE
Syntax:
oClass:EMPTY(
      ).


DSPROW method

Updates specified row with content of current query record.

Applies to: P-BROWSE
Syntax:
oClass:DSPROW(
      ROW-ID).

Param | Data type | Description
ROW-ID | string | row ID


DISPLAY method

Fills browse with data from attached query up to max count rows.

Applies to: P-BROWSE
Syntax:
oClass:DISPLAY(
      MAX-COUNT).

Param | Data type | Description
MAX-COUNT | integer | max count


DELETE-ROW method

Delete a row from the browse specified by row ID.

Applies to: P-BROWSE
Syntax:
oClass:DELETE-ROW(
      ROW-ID).

Param | Data type | Description
ROW-ID | string | row ID


CLEAR-SELECTION method

Removes the highlight from the currently selected rows.

Applies to: P-BROWSE
Syntax:
oClass:CLEAR-SELECTION(
      ).


CLEAR-COLUMN-SELECTION method

Deselects all child components

Applies to: P-BROWSE
Syntax:
oClass:CLEAR-COLUMN-SELECTION(
      ).


ASSIGN method

Update attached query records with data from browse.

Applies to: P-BROWSE
Syntax:
oClass:ASSIGN(
      ).


ASNROW method

Updates current query record with content of specified row.

Applies to: P-BROWSE
Syntax:
oClass:ASNROW(
      ROW-ID).

Param | Data type | Description
ROW-ID | string | row ID


APPEND-ROW method

Create a row and redraw browse to display the new row.

The row is specified by row ID and a list of values separated by delimiter.

Applies to: P-BROWSE
Syntax:
oClass:APPEND-ROW(
      ROW-ID, ROW-DATA).

Param | Data type | Description
ROW-ID | string | row ID
ROW-DATA | string | row-data


P-BAND-TAB class

P-BAND-TAB
extended by SC-OBJECT

Attributes

TITLE VISIBLE
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

SELECT

Events


VISIBLE attribute

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-BAND-TAB


TITLE attribute

Data type: | string
Access: | Readable / Writeable
Applies to: | P-BAND-TAB


SELECT method

Selects this tab in the band.

Applies to: P-BAND-TAB
Syntax:
oClass:SELECT(
      ).


P-BAND-ITEM-POPUP class

P-BAND-ITEM-POPUP
extended by P-BAND-ITEM
extended by SC-OBJECT

Attributes

MENU
inherited from P-BAND-ITEM:
FIRST-IN-GROUP | ICON
LABEL | SENSITIVE
SIZE | TOOLTIP
VISIBLE |
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

Events

inherited from P-BAND-ITEM:
CHOOSE


MENU attribute

Menu used as popup-menu for this item.

Data type: | P-MENU
Access: | Readable / Writeable
Applies to: | P-BAND-ITEM-POPUP


P-BAND-ITEM-FLIPFLOP class

P-BAND-ITEM-FLIPFLOP
extended by P-BAND-ITEM
extended by SC-OBJECT

Attributes

CHECKED
inherited from P-BAND-ITEM:
FIRST-IN-GROUP | ICON
LABEL | SENSITIVE
SIZE | TOOLTIP
VISIBLE |
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

Events

VALUE-CHANGED
inherited from P-BAND-ITEM:
CHOOSE


CHECKED attribute

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-BAND-ITEM-FLIPFLOP


P-BAND-ITEM class

P-BAND-ITEM
extended by SC-OBJECT

Attributes

FIRST-IN-GROUP | ICON
LABEL | SENSITIVE
SIZE | TOOLTIP
VISIBLE |
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

Events

CHOOSE


VISIBLE attribute

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-BAND-ITEM-POPUP P-BAND-ITEM-FLIPFLOP P-BAND-ITEM


TOOLTIP attribute

Data type: | string
Access: | Readable / Writeable
Applies to: | P-BAND-ITEM-POPUP P-BAND-ITEM-FLIPFLOP P-BAND-ITEM


SIZE attribute

Data type: value-set
Values:
Value | Description
SMALL |
LARGE |
IMAGE-ONLY |
Default value: SMALL
Access: Readable / Writeable
Applies to: P-BAND-ITEM-POPUP
P-BAND-ITEM-FLIPFLOP
P-BAND-ITEM


SENSITIVE attribute

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-BAND-ITEM-POPUP P-BAND-ITEM-FLIPFLOP P-BAND-ITEM


LABEL attribute

Data type: | string
Access: | Readable / Writeable
Applies to: | P-BAND-ITEM-POPUP P-BAND-ITEM-FLIPFLOP P-BAND-ITEM


ICON attribute

Icon displayed for this item. A default icon is used if not set.

Data type: | A-ICON
Access: | Readable / Writeable
Applies to: | P-BAND-ITEM-POPUP P-BAND-ITEM-FLIPFLOP P-BAND-ITEM


FIRST-IN-GROUP attribute

Indicates if this item is the first in a group of items separated by a rule

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-BAND-ITEM-POPUP P-BAND-ITEM-FLIPFLOP P-BAND-ITEM


P-BAND-GROUP class

P-BAND-GROUP
extended by SC-OBJECT

Attributes

INSERT-INDEX | TITLE
VISIBLE |
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

Events


VISIBLE attribute

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-BAND-GROUP


TITLE attribute

Data type: | string
Access: | Readable / Writeable
Applies to: | P-BAND-GROUP


INSERT-INDEX attribute

Specifies the position of this group in the parent tab when it gets added to it.

If this attribute is set to a value <= 0 the group becomes the new last group in the tab

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-BAND-GROUP


P-BAND class

P-BAND
extended by SC-OBJECT

Attributes

APP-MENU-BGCOLOR | APP-MENU-BGCOLOR-HOVER
APP-MENU-FGCOLOR | BGCOLOR
BORDER-COLOR | BORDER-COLOR-HOVER
DELAYED-TAB-REMOVAL | GROUP-BGCOLOR1
GROUP-BGCOLOR2 | GROUP-LABEL-BGCOLOR
GROUP-LABEL-FGCOLOR | ITEM-BGCOLOR-HOVER
ITEM-BGCOLOR-PRESSED | ITEM-FGCOLOR
PAINT-GROUP-BORDER | SELECTED-TAB
TAB-BGCOLOR-SELECTED | TAB-FGCOLOR
TAB-FGCOLOR-SELECTED | TABS-AREA-BGCOLOR1
TABS-AREA-BGCOLOR2 |
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

ADD-APP-MENU-ITEM

Events

CHOOSE VALUE-CHANGED


TABS-AREA-BGCOLOR2 attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BAND


TABS-AREA-BGCOLOR1 attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BAND


TAB-FGCOLOR-SELECTED attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BAND


TAB-FGCOLOR attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BAND


TAB-BGCOLOR-SELECTED attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BAND


SELECTED-TAB attribute

Data type: | P-BAND-TAB
Access: | Readable / Writeable
Applies to: | P-BAND


PAINT-GROUP-BORDER attribute

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-BAND


ITEM-FGCOLOR attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BAND


ITEM-BGCOLOR-PRESSED attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BAND


ITEM-BGCOLOR-HOVER attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BAND


GROUP-LABEL-FGCOLOR attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BAND


GROUP-LABEL-BGCOLOR attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BAND


GROUP-BGCOLOR2 attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BAND


GROUP-BGCOLOR1 attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BAND


DELAYED-TAB-REMOVAL attribute

Data type: | boolean
Default value: | false
Access: | Readable / Writeable
Applies to: | P-BAND


BORDER-COLOR-HOVER attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BAND


BORDER-COLOR attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BAND


BGCOLOR attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BAND


APP-MENU-FGCOLOR attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BAND


APP-MENU-BGCOLOR-HOVER attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BAND


APP-MENU-BGCOLOR attribute

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-BAND


ADD-APP-MENU-ITEM method

Adds an item to the application-menu.

Applies to: P-BAND
Syntax:
oClass:ADD-APP-MENU-ITEM(
      KEY, POSITION, LABEL, ICON, TOOLTIP, DESCRIPTION).
Param | Data type | Description
KEY | string
POSITION value-set

Values:

Value | Description
LEFT |
RIGHT |
BOTTOM |
LABEL | string
ICON A-ICON
TOOLTIP | string
DESCRIPTION | string


J-TIMER class

J-TIMER
extended by SC-OBJECT

A J-TIMER object is not visible on the screen. But a running timer fires cyclical TIMER events.

Attributes

DELAY | INITIAL-DELAY
REPEATS |
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

START STOP

Events

TIMER

Example:

/**
 *  The example creates a J-TIMER and start it.
 *  The procedure will be invoked ever second.
 *  After 26 calls the timer stops.
 */

DEFINE VARIABLE ii       AS INTEGER   NO-UNDO.

DEFINE VARIABLE oTimer AS J-TIMER    NO-UNDO.

oTimer = NEW J-TIMER(THIS-PROCEDURE).
oTimer:NAME          = "Timer".
oTimer:DELAY         = 1000.
oTimer:INITIAL-DELAY = 1000
oTimer:TIMER         = "E_Timer_TIMER"

oTimer:START().


REPEATS attribute

Specify FALSE to make the timer stop after sending its first event.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | J-TIMER


INITIAL-DELAY attribute

Initial delay, in milliseconds.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | J-TIMER


DELAY attribute

Delay, in milliseconds. DELAY < 20 is not allowed.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | J-TIMER


STOP method

Stop running timer.

Applies to: J-TIMER
Syntax:
oClass:STOP(
      ).


START method

Start timer. The running timer fires cyclical TIMER events.

Applies to: J-TIMER
Syntax:
oClass:START(
      ).


JS-OBJECT class

JS-OBJECT
extended by SC-OBJECT

An object that represents a javascript object in the HTML-document where the applet is embedded.

Creating an instance of this class, always returns the javascript-window-object.

Use the method GET-CHILD to get other JS-OBJECTs.

Note: Objects of this type are only available when Skin-Client is running as applet!

Attributes

DELIMITER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

CALL GET-CHILD

Events


DELIMITER attribute

Character to delimit parameters to call functions.

Data type: | string
Default value: | ,
Access: | Readable / Writeable
Applies to: | JS-CUSTOM JS-OBJECT


GET-CHILD method

Gets a child object of this object with the given name

Return type: JS-OBJECT
Applies to: JS-CUSTOM
JS-OBJECT
Syntax:
oReturn = oClass:GET-CHILD(
      CHILD-OBJECT).

Param | Data type | Description
CHILD-OBJECT | string | Name of the child object


CALL method

calls a javascript function or method of the object

Return type: string
Applies to: JS-CUSTOM
JS-OBJECT
Syntax:
_ret = oClass:CALL(
      FUNCTION, PARAMETER-LIST).

Param | Data type | Description
FUNCTION | string | Name of the function
PARAMETER-LIST | string | List of parameters that are passed to the function, delimited by DELIMITER


JS-CUSTOM class

JS-CUSTOM
extended by JS-OBJECT
extended by SC-OBJECT

An object that represents a javascript object in the HTML-document where the applet is embedded.

Creating an instance of this class, always returns the javascript-window-object.

Use the method GET-CHILD to get other JS-OBJECTs.

Note: Objects of this type are only available when Skin-Client is running as applet!

Attributes

inherited from JS-OBJECT:
DELIMITER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

inherited from JS-OBJECT:
CALL GET-CHILD

Events

JS-MESSAGE


J-IMAGE-ICON class

J-IMAGE-ICON
extended by A-ICON
extended by SC-OBJECT

A J-IMAGE-ICON object represents a image usable for serveral widgets. The attribute BINARY has to be set to make the object available.

Use the static 'LOAD-IMAGE' utility method to create an instance by a given file name or set the BINARY attribute explicitely to an already created J-BINARY object.

Attributes

BINARY *
* mandatory (must be set to realise object)
inherited from A-ICON:
HEIGHT-PIXELS WIDTH-PIXELS
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

Events

Example:

/**
 *  The example create a J-IMAGE-ICON using a J-BINARY object
 *  that is created by Skin-CLient API function 'sc_LoadFile'.
 */
DEFINE VARIABLE oImageIcon AS J-IMAGE-ICON    NO-UNDO.
oImageIcon = J-IMAGE-ICON:LOAD-IMAGE("C:/MyPic.jpg").


BINARY attribute

J-BINARY object that contains the image data.

Data type: | J-BINARY
Access: | Readable / Writeable
Applies to: | J-IMAGE-ICON


J-FONT class

J-FONT
extended by SC-OBJECT

It's needed to initialise the attributes FONT-NAME, STYPLE and SIZE to make a font object available. A font can be used for several widgets.

You may also set a default font. That means the initially used font for a certain widget. For more information see SKIN-CLIENT's method SET-DEFAULT-FONT .

Attributes

FONT-NAME * | SIZE *
STYLE * |
* mandatory (must be set to realise object)
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

Events

Example:

/**
 *  The example create a new font object
 *  initialising mandatory attributes FONT-NAME, STYLE and SIZE.
 */

DEFINE VARIABLE oFont AS J-FONT    NO-UNDO.

oFont = NEW J-FONT(THIS-PROCEDURE).
oFont:NAME      = "Arial-12".
oFont:FONT-NAME = "Arial".
oFont:STYLE     = "PLAIN".
oFont:SIZE      = 12.


STYLE attribute

Font style.

Data type: value-set
Values:
Value | Description
PLAIN | No PLAIN and no ITALIC.
BOLD | Bold font style.
ITALIC | Italic font style.

Note: The value may be combined of multiple values. The values are separated by plus (+).
Access: Readable / Writeable
Applies to: J-FONT


SIZE attribute

Font size in points (1 point == 1/72 inches).

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | J-FONT


FONT-NAME attribute

Name of an aviable font (depends on client-PC's OS).

Java knowns the three system independent fonts:
  • SansSerif
  • Serif
  • Monospaced

Data type: | string
Access: | Readable / Writeable
Applies to: | J-FONT


J-FILE class

J-FILE
extended by SC-OBJECT

A J-FILE object represents a file or directory on the client side. The attribute PATH has to be set to make the object available.

Attributes

PATH *
* mandatory (must be set to realise object)
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

CREATE-DIRECTORIES | CREATE-ZIP
DELETE | DELETE-RECURSIVE
EDIT | EXTRACT-ZIP
GET-ABSOLUTE-PATH | GET-CRC32
GET-DIGEST | GET-EXISTS
GET-LAST-MODIFIED | GET-NAME
GET-PARENT-PATH | GET-SIZE
LIST | OPEN
PRINT | PROCESS-XSL-TRANSFORMATION
SET-READ-ONLY |

Events

Example:

/**
 *  The example create a J-FILE object
 */

DEFINE VARIABLE oFile AS J-FILE    NO-UNDO.

oFile = NEW J-FILE(THIS-PROCEDURE).
oFile:NAME = "MyFile".
oFile:PATH = "myfile.txt".


PATH attribute

The path of the file or directory.

This may be an absolute path or a path relative to CURRENT-DIRECTORY

Data type: | string
Access: | Readable / Writeable
Applies to: | J-FILE


SET-READ-ONLY method

Marks the file or directory that only read-operations are allowed

Applies to: J-FILE
Syntax:
oClass:SET-READ-ONLY(
      ).


PROCESS-XSL-TRANSFORMATION method

Transforms this (XML) file using the given XSL-file.

Applies to: J-FILE
Syntax:
oClass:PROCESS-XSL-TRANSFORMATION(
      XSL-FILE, RESULT-FILE).

Param | Data type | Description
XSL-FILE | J-FILE | The xsl-file used for the transformation
RESULT-FILE | J-FILE | The resulting file of the transformation


PRINT method

Prints the file with the native desktop printing facility, using the associated application's print command.
Note: This method only works if Skin-Client is running under Java 1.6 or higher.

Return type: boolean

True, if the method could be invoked without exceptions.

Applies to: J-FILE
Syntax:
_ret = oClass:PRINT(
      ).


OPEN method

Launches the associated application to open the file.

Return type: boolean

true, if the method could be invoked without exceptions.

Applies to: J-FILE
Syntax:
_ret = oClass:OPEN(
      ).


LIST method

Lists contents of a directory.

Each file-entry consists of eight fields (fields may be blank depending on file entry and/or given parameters):

[relative-path] [attributes] [size] [modified date] [modified time] [CRC32] [SHA-1 digest] [MD5 digest]

Applies to: J-FILE
Syntax:
oClass:LIST(
      DIRECTORIES, HIDDEN-ENTRIES, READ-ONLY-ENTRIES, SUBDRIRECTORIES, CRC32-CHECKSUM, SHA-1, MD5, FILE-FILTER, FIELD-DELIMITER, FILE-ENTRY-DELIMITER, OBJECT).

Param | Data type | Description
DIRECTORIES | boolean | include directories in list
HIDDEN-ENTRIES | boolean | include hidden entries
READ-ONLY-ENTRIES | boolean | include read-only entries
SUBDRIRECTORIES | boolean | scan also subdirectories
CRC32-CHECKSUM | boolean | calculate CRC32-checksum
SHA-1 | boolean | calculate SHA-1 digest
MD5 | boolean | calculate MD5 digest
FILE-FILTER | string | DOS-style filefilter to use (blank filter means *.*)
FIELD-DELIMITER | string | delimiter used to separate fields of a file-entry
FILE-ENTRY-DELIMITER | string | delimiter used to separate file-entries
OBJECT | J-BINARY | Binary object that gets used to return the directory-listing


GET-SIZE method

Returns the size of the file.

Return type: integer
Applies to: J-FILE
Syntax:
_ret = oClass:GET-SIZE(
      ).


GET-PARENT-PATH method

Returns the path of the parent directory.

Return type: string
Applies to: J-FILE
Syntax:
_ret = oClass:GET-PARENT-PATH(
      ).


GET-NAME method

Returns the name of the file or directory without path.

Return type: string
Applies to: J-FILE
Syntax:
_ret = oClass:GET-NAME(
      ).


GET-LAST-MODIFIED method

Returns last modification date and time in the format MMddyyyyHHmmssSSS

Return type: string
Applies to: J-FILE
Syntax:
_ret = oClass:GET-LAST-MODIFIED(
      ).


GET-EXISTS method

Returns true if the file or directory exists.

Return type: boolean
Applies to: J-FILE
Syntax:
_ret = oClass:GET-EXISTS(
      ).


GET-DIGEST method

Returns digest of the file formatted as BASE64. Returns ? for directories and not existing files.

Return type: string
Applies to: J-FILE
Syntax:
_ret = oClass:GET-DIGEST(
      ALGORITHM).

Param | Data type | Description
ALGORITHM | string | The algorithm to use. Valid algorithms are: SHA-1, SHA-256, SHA-384, SHA-512, MD2, MD5


GET-CRC32 method

Returns CRC32 checksum of the file in hex format. Returns ? for directories and not existing files

Return type: string
Applies to: J-FILE
Syntax:
_ret = oClass:GET-CRC32(
      ).


GET-ABSOLUTE-PATH method

Returns the absolute path of the file or directory.

Return type: string
Applies to: J-FILE
Syntax:
_ret = oClass:GET-ABSOLUTE-PATH(
      ).


EXTRACT-ZIP method

Extracts the ZIP-file represented by this file-object to a given directory.

Return type: boolean
Applies to: J-FILE
Syntax:
_ret = oClass:EXTRACT-ZIP(
      TARGET-DIRECTORY).

Param | Data type | Description
TARGET-DIRECTORY | string | The full path of the target directory. If the directory does not exist it will be created.


EDIT method

Launches the associated application to open the file for editing.
Note: This method only works if Skin-Client is running under Java 1.6 or higher.

Return type: boolean

true, if the method could be invoked without exceptions.

Applies to: J-FILE
Syntax:
_ret = oClass:EDIT(
      ).


DELETE-RECURSIVE method

Deletes the file or directory and (if the file represents a directory) recursively deletes all subdirectories and files

Return type: boolean

true, if the file or directory could be deleted.

Applies to: J-FILE
Syntax:
_ret = oClass:DELETE-RECURSIVE(
      ).


DELETE method

Deletes the file or directory.

Return type: boolean

true, if the file or directory could be deleted.

Applies to: J-FILE
Syntax:
_ret = oClass:DELETE(
      ).


CREATE-ZIP method

Creates a new ZIP-file. The ZIP-file will contain all files and (sub-)directories of the directory represented by this file-object. If this object is not a directory the ZIP-file will contain only the file represented by this file-object.

Return type: boolean
Applies to: J-FILE
Syntax:
_ret = oClass:CREATE-ZIP(
      TARGET-ZIP-FILE).

Param | Data type | Description
TARGET-ZIP-FILE | string | The full path of the ZIP-file to create.


CREATE-DIRECTORIES method

Creates directory structure (if necessary) to reflect the absolute path.

Applies to: J-FILE
Syntax:
oClass:CREATE-DIRECTORIES(
      ).


J-CURSOR class

J-CURSOR
extended by SC-OBJECT

A class to encapsulate the bitmap representation of the mouse cursor.

Attributes

TYPE *
* mandatory (must be set to realise object)
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

Events


TYPE attribute

The type is one of the (predefined) cursors shown below.

Data type: value-set
Values:
Value | Description
DEFAULT | Default mouse cursor.
CROSSHAIR | Crosshair mouse cursor.
TEXT | Text mouse cursor.
WAIT | Wait mouse cursor (hourglass).
SW-RESIZE | South-west window resize mouse cursor.
SE-RESIZE | South-east window resize mouse cursor.
NW-RESIZE | North-west window resize mouse cursor.
NE-RESIZE | North-east window resize mouse cursor.
N-RESIZE | North window resize mouse cursor.
S-RESIZE | South window resize mouse cursor.
W-RESIZE | West window resize mouse cursor.
E-RESIZE | East window resize mouse cursor.
HAND | Hand mouse cursor.
MOVE | Move mouse cursor.
Access: Readable / Writeable
Applies to: J-CURSOR


J-COOKIE class

J-COOKIE
extended by SC-OBJECT

An object that handles cookies in the HTML-document where the applet is embedded.

Creating an instance of this class, always returns the same object.

Note: Objects of this type are only available when Skin-Client is running as applet!

Attributes

inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

DELETE-VALUE | GET-VALUE
SET-VALUE |

Events


SET-VALUE method

Stores a cookie-value with the given name that expires after the given number of days

Applies to: J-COOKIE
Syntax:
oClass:SET-VALUE(
      VALUE-NAME, STORE-VALUE, VALIDITY).

Param | Data type | Description
VALUE-NAME | string | name for the value
STORE-VALUE | string | value to store
VALIDITY | integer | validity in days


GET-VALUE method

Gets a cookie-value with the given name

Return type: string
Applies to: J-COOKIE
Syntax:
_ret = oClass:GET-VALUE(
      DESIRED-VALUE-NAME).

Param | Data type | Description
DESIRED-VALUE-NAME | string | name of the desired value


DELETE-VALUE method

Deletes a cookie-value with the given name

Applies to: J-COOKIE
Syntax:
oClass:DELETE-VALUE(
      VALUE-NAME).

Param | Data type | Description
VALUE-NAME | string | name of the value to delete


J-COLOR-ICON class

J-COLOR-ICON
extended by A-ICON
extended by SC-OBJECT

A J-COLOR-ICON is a small (initially 20x10 pixel) square icon filled in one color. The attribute COLOR has to be initialised to make the object available.

Attributes

COLOR * | HEIGHT-PIXELS
WIDTH-PIXELS |
* mandatory (must be set to realise object)
inherited from A-ICON:
HEIGHT-PIXELS WIDTH-PIXELS
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

Events

Example:

/**
 *  The example create a J-COLOR-ICON object and
 *  place the icon in a browser cell (row-ID 1).
 */

DEFINE VARIABLE oColorIcon AS J-COLOR-ICON    NO-UNDO.

oColorIcon = NEW J-COLOR-ICON(THIS-PROCEDURE).
oColorIcon:NAME          = "Color-Icon".
oColorIcon:COLOR         = oColor.
oColorIcon:WIDTH-PIXELS  = 20.
oColorIcon:HEIGHT-PIXELS = 10.

oBrowseCol:SET-ICON("1", oColorIcon).


WIDTH-PIXELS attribute

The icon width, in pixels.

Data type: | integer
Default value: | 20
Access: | Readable / Writeable
Applies to: | J-COLOR-ICON


HEIGHT-PIXELS attribute

The icon height, in pixels.

Data type: | integer
Default value: | 10
Access: | Readable / Writeable
Applies to: | J-COLOR-ICON


COLOR attribute

The color to be displayed.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | J-COLOR-ICON


J-COLOR class

J-COLOR
extended by SC-OBJECT

A J-COLOR object represents a color consisting three 8-bit values for red, green and blue amount. All attributes (RED, GREEN and BLUE) has to be initialized to make the color object available.

Please aviod to create more none-widget-objects (like color, image, binary, font, etc.) as necessary. You may use existing color (etc.) instances whenever you needed.

You may also set a default color. That means the initially used color for a certain widget. For more information see SKIN-CLIENT's method SET-DEFAULT-COLOR .

Attributes

BLUE * | GREEN *
RED * |
* mandatory (must be set to realise object)
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

Events

Example:

/**
 * The example create a color object (100% red)
 * and set it as background color of a window.
 * (A window with object-ID 'oWindow' is required.)
 */

oWindow:BGCOLOR = J-COLOR:GET-COLOR(255,0,0).


RED attribute

Red amount, a number between 0 and 255.

Data type: | integer
Access: | Readable / Writeable
Applies to: | J-COLOR


GREEN attribute

Green amount, a number between 0 and 255.

Data type: | integer
Access: | Readable / Writeable
Applies to: | J-COLOR


BLUE attribute

Blue amount, a number between 0 and 255.

Data type: | integer
Access: | Readable / Writeable
Applies to: | J-COLOR


J-CANVAS class

J-CANVAS
extended by A-ICON
extended by SC-OBJECT

A graphic 2d area that the program can use to draw geometrical figures. J-CANVAS does not react to input events. As a result, it cannot get the keyboard focus.

Attributes

BGCOLOR | HEIGHT-PIXELS
WIDTH-PIXELS |
inherited from A-ICON:
HEIGHT-PIXELS WIDTH-PIXELS
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

CLEAN | DRAW-LINE
DRAW-OVAL | DRAW-RECT
DRAW-STRING | FILL-OVAL
FILL-RECT |

Events

Example:

/**
 *  The example create a canvas with white background
 *  and draws a black circle that fills the hole area.
 */

DEFINE VARIABLE oCanvas AS J-CANVAS    NO-UNDO.

oCanvas = NEW J-CANVAS(THIS-PROCEDURE).
oCanvas:NAME          = "Canvas".
oCanvas:BGCOLOR       = oColorWhite.

oCanvas:DRAW-OVAL(oColorBlack,0,0,99,99).


WIDTH-PIXELS attribute

The width of the widget, in pixels.

Data type: | integer
Default value: | 100
Access: | Readable / Writeable
Applies to: | J-CANVAS


HEIGHT-PIXELS attribute

The height of the widget, in pixels.

Data type: | integer
Default value: | 100
Access: | Readable / Writeable
Applies to: | J-CANVAS


BGCOLOR attribute

The background color of the widget.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | J-CANVAS


FILL-RECT method

Fills rectangle with left edge at pixel position (x, y) and specified size.

Applies to: J-CANVAS
Syntax:
oClass:FILL-RECT(
      RECTANGLE-COLOR, X, Y, WIDTH-PIXELS, HEIGHT-PIXELS).

Param | Data type | Description
RECTANGLE-COLOR | J-COLOR | rectangle color
X | integer | x
Y | integer | y
WIDTH-PIXELS | integer | width pixels
HEIGHT-PIXELS | integer | height pixels


FILL-OVAL method

Fills oval that fit closely into a box with left edge at pixel position (x, y) and specified size,

Applies to: J-CANVAS
Syntax:
oClass:FILL-OVAL(
      OVAL-COLOR, X, Y, WIDTH-PIXELS, HEIGHT-PIXELS).

Param | Data type | Description
OVAL-COLOR | J-COLOR | oval color
X | integer | x
Y | integer | y
WIDTH-PIXELS | integer | width pixels
HEIGHT-PIXELS | integer | height pixels


DRAW-STRING method

Draws a string at pixels position (x, y).

Applies to: J-CANVAS
Syntax:
oClass:DRAW-STRING(
      TEXT-COLOR, X, Y, TEXT).

Param | Data type | Description
TEXT-COLOR | J-COLOR | text color
X | integer | x
Y | integer | y
TEXT | string | text


DRAW-RECT method

Draws a rectangle with left edge at pixel position (x, y) and specified size.

Applies to: J-CANVAS
Syntax:
oClass:DRAW-RECT(
      LINE-COLOR, X, Y, WIDTH-PIXELS, HEIGHT-PIXELS).

Param | Data type | Description
LINE-COLOR | J-COLOR | line color
X | integer | x
Y | integer | y
WIDTH-PIXELS | integer | width pixels
HEIGHT-PIXELS | integer | height pixels


DRAW-OVAL method

Draws oval that fit closely into a box with left edge at pixel position (x, y) and specified size.

Applies to: J-CANVAS
Syntax:
oClass:DRAW-OVAL(
      LINE-COLOR, X, Y, WIDTH-PIXELS, HEIGHT-PIXELS).

Param | Data type | Description
LINE-COLOR | J-COLOR | line color
X | integer | x
Y | integer | y
WIDTH-PIXELS | integer | width pixels
HEIGHT-PIXELS | integer | height pixels


DRAW-LINE method

Draws line from pixel position (x1, y1) to (x2, y2).

Applies to: J-CANVAS
Syntax:
oClass:DRAW-LINE(
      LINE-COLOR, X1, Y1, X2, Y2).

Param | Data type | Description
LINE-COLOR | J-COLOR | line color
X1 | integer | x1
Y1 | integer | y1
X2 | integer | x2
Y2 | integer | y2


CLEAN method

Removed all shapes from this canvas widget.

Applies to: J-CANVAS
Syntax:
oClass:CLEAN(
      ).


J-BINARY class

J-BINARY
extended by SC-OBJECT

A J-BINARY object caches binary data (e.g. for a image). Progress programmers use typically Skin-Client API function 'sc_LoadFile' to create a J-BINARY. But it is also possible to create a empty J-BINARY and load/store data on the client computer.

Attributes

inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

LOAD-FROM-FILE SAVE-TO-FILE

Events

Example:

/**
 * The example create a J-BINARY object (variable 'id-File')
 * that is filled with the content of the file 'Files/MyFile.p'.
 * The file must exist on the server.
 */

DEFINE VARIABLE id-File AS CHARACTER NO-UNDO.

id-File = J-BINARY:LOAD-FILE("Files/MyFile.p").


SAVE-TO-FILE method

Save binary data to a file represented by a J-FILE object.

Applies to: J-BINARY
Syntax:
oClass:SAVE-TO-FILE(
      FILE).

Param | Data type | Description
FILE | J-FILE | The file to save binary contents to


LOAD-FROM-FILE method

Load a file from a file represented by a J-FILE object.

Applies to: J-BINARY
Syntax:
oClass:LOAD-FROM-FILE(
      FILE).

Param | Data type | Description
FILE | J-FILE | The file to load binary contents from.


AP-WIDGET abstract class

AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

Subclasses

P-DIALOG | P-FRAME
P-MDI-CONTAINER | P-WEB-BROWSER
P-WINDOW |
P-BROWSE | P-BUTTON
P-COMBO-BOX | P-CUSTOM-BROWSE
P-DATE-PICKER | P-DOCKMAN
P-EDITOR | P-FILE-UPLOADER
P-FILL-IN | P-FLEX-TEXT
P-GRID | P-IMAGE
P-OUTLOOKBAR | P-PROGRESS-BAR
P-RADIO-SET | P-RECTANGLE
P-RTF-EDITOR | P-SCHEDULER
P-SELECTION-LIST | P-SHORTCUT-BAR
P-SPLIT-PANE | P-TABBED-PANE
P-TASKPANE | P-TEXT
P-TOGGLE-BOX | P-TREE

Attributes

DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY


Y attribute

The relative y position in pixels of the top widget border.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER


X attribute

The relative x position in pixels of the left widget border.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER


WIDTH-PIXELS attribute

The width of the widget, in pixels.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER


VISIBLE attribute

Indicates whether a widget is currently visible on the display.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER


HEIGHT-PIXELS attribute

The height of the widget, in pixels.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER


DROP-TARGET attribute

Indicates whether a widget can accept something dropped.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER


DROP-FLAVORS attribute

Data type: value-set
Values:
Value | Description
FILES | Allow to transfer a file names via DnD
STRING | Allow to transfer a string via DnD

Note: The value may be combined of multiple values. The values are separated by plus (+).
Default value: FILES+STRING
Access: Readable / Writeable
Applies to: P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-TAB-FRAME
P-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER


DROP-ACTIONS attribute

Data type: value-set
Values:
Value | Description
COPY | A constant value representing a 'copy' action to be performed by a Drag and Drop operation.
MOVE | A constant value representing a 'move' action to be performed by a Drag and Drop operation.
LINK | A constant value representing a 'link' action to be performed by a Drag and Drop operation.

Note: The value may be combined of multiple values. The values are separated by plus (+).
Default value: COPY+MOVE
Access: Readable / Writeable
Applies to: P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-TAB-FRAME
P-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER


DRAG-SOURCE attribute

Indicates whether the user can drag something from the widget.

Data type: | boolean
Default value: | FALSE
Access: | Readable / Writeable
Applies to: | P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER


DRAG-ACTIONS attribute

Data type: value-set
Values:
Value | Description
COPY | A constant value representing a 'copy' action to be performed by a Drag and Drop operation.
MOVE | A constant value representing a 'move' action to be performed by a Drag and Drop operation.
LINK | A constant value representing a 'link' action to be performed by a Drag and Drop operation.

Note: The value may be combined of multiple values. The values are separated by plus (+).
Default value: COPY+MOVE
Access: Readable / Writeable
Applies to: P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-TAB-FRAME
P-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER


DELIMITER attribute

Character to delimit list item pairs or list items.

Data type: | string
Default value: | ,
Access: | Readable / Writeable
Applies to: | P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER


TO-TOP method

Moves the widget to the top (or front) of other widgets in the same frame, window or dialog on the display.

Applies to: P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-TAB-FRAME
P-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
Syntax:
oClass:TO-TOP(
      ).


REPAINT method

Repaints this component (application-trigged painting).

There are two kinds of painting operations: system-triggered painting, and application-triggered painting.

In a system-triggered painting operation, the system requests a component to render its contents, usually for one of the following reasons:
  • The component is first made visible on the screen.
  • The component is resized.
  • The component has damage that needs to be repaired. (For example, something that previously obscured the component has moved, and a previously obscured portion of the component has become exposed).

In an application-triggered painting operation, the application decides it needs to update a component because its internal state has changed. (For example, the application detects that a mouse button has been pressed and determines that it needs to paint a 'depressed' button visual).

Applies to: P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-TAB-FRAME
P-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
Syntax:
oClass:REPAINT(
      ).


PUT-DRAG-DATA method

Defines the data of the current drag and drop operation.

Applies to: P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-TAB-FRAME
P-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
Syntax:
oClass:PUT-DRAG-DATA(
      , ).
Param Data type Description
value-set

Values:

Value | Description
FILES | Allow to transfer a file names via DnD
STRING | Allow to transfer a string via DnD
string


AP-FIELD-LEVEL-WIDGET abstract class

AP-FIELD-LEVEL-WIDGET
extended by AP-WIDGET
extended by AJ-COMPONENT
extended by SC-OBJECT

Subclasses

P-BROWSE | P-BUTTON
P-COMBO-BOX | P-CUSTOM-BROWSE
P-DATE-PICKER | P-DOCKMAN
P-EDITOR | P-FILE-UPLOADER
P-FILL-IN | P-FLEX-TEXT
P-GRID | P-IMAGE
P-OUTLOOKBAR | P-PROGRESS-BAR
P-RADIO-SET | P-RECTANGLE
P-RTF-EDITOR | P-SCHEDULER
P-SELECTION-LIST | P-SHORTCUT-BAR
P-SPLIT-PANE | P-TABBED-PANE
P-TASKPANE | P-TEXT
P-TOGGLE-BOX | P-TREE

Attributes

ANCHORS | FOCUSABLE
TAB-POSITION | TOOLTIP
inherited from AP-WIDGET:
DELIMITER | DRAG-ACTIONS
DRAG-SOURCE | DROP-ACTIONS
DROP-FLAVORS | DROP-TARGET
HEIGHT-PIXELS | VISIBLE
WIDTH-PIXELS | X
Y |
inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

inherited from AP-WIDGET:
PUT-DRAG-DATA | REPAINT
TO-TOP |
inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

ENTRY LEAVE
inherited from AP-WIDGET:
DRAG-NOTIFY DROP-NOTIFY
inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY


TOOLTIP attribute

Text which is shown when the mousepointer is over the widget.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID


TAB-POSITION attribute

The tab order of a widget within the application

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID


FOCUSABLE attribute

Indicates whether a widget is focusable on the display.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID


ANCHORS attribute

Anchors are used to define automatic client-side resizing and/or repositioning of widgets.

This attribute indicates which anchors to respect if the parent container resizes.

Data type: value-set
Values:
Value | Description
NONE | No anchor
LEFT | Anchor to the left border of the parent container
TOP | Anchor to the top border of the parent container
RIGHT | Anchor to the right border of the parent container
BOTTOM | Anchor to the bottom border of the parent container
FILLED | Completly fills the parent container

Note: The value may be combined of multiple values. The values are separated by plus (+).
Default value: LEFT+TOP
Access: Readable / Writeable
Applies to: P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID


AJ-CONTAINER abstract class

AJ-CONTAINER
extended by AJ-COMPONENT
extended by SC-OBJECT

Subclasses

P-SCHEDULER-TASK P-TASKPANEGROUP

Attributes

inherited from AJ-COMPONENT:
BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

inherited from AJ-COMPONENT:
REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

inherited from AJ-COMPONENT:
ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY


AJ-COMPONENT abstract class

AJ-COMPONENT
extended by SC-OBJECT

Subclasses

P-LINK-BUTTON
P-SCHEDULER-TASK P-TASKPANEGROUP
P-DIALOG | P-FRAME
P-MDI-CONTAINER | P-WEB-BROWSER
P-WINDOW |
P-BROWSE | P-BUTTON
P-COMBO-BOX | P-CUSTOM-BROWSE
P-DATE-PICKER | P-DOCKMAN
P-EDITOR | P-FILE-UPLOADER
P-FILL-IN | P-FLEX-TEXT
P-GRID | P-IMAGE
P-OUTLOOKBAR | P-PROGRESS-BAR
P-RADIO-SET | P-RECTANGLE
P-RTF-EDITOR | P-SCHEDULER
P-SELECTION-LIST | P-SHORTCUT-BAR
P-SPLIT-PANE | P-TABBED-PANE
P-TASKPANE | P-TEXT
P-TOGGLE-BOX | P-TREE

Attributes

BGCOLOR | CSS-CLASSES
CURSOR | FGCOLOR
FOCUS | FONT
HEIGHT-PIXELS | OPAQUE
SENSITIVE | VISIBLE
WIDTH-PIXELS | X
Y | Z-ORDER
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

REQUEST-FOCUS | SET-LOCATION
SET-SIZE | VALIDATE

Events

ANY-KEY | ANY-KEY
BACK-TAB-KEY | DELETE-KEY
ENTER-KEY | ESCAPE-KEY
INSERT-KEY | LEFT-MOUSE-CLICK
LEFT-MOUSE-DBLCLICK | LEFT-MOUSE-DOWN
MIDDLE-MOUSE-DOWN | MOUSE-ENTERED
MOUSE-EXITED | MOVED
PAGE-DOWN-KEY | PAGE-UP-KEY
RESIZED | RIGHT-MOUSE-CLICK
RIGHT-MOUSE-DOWN | TAB-KEY


Z-ORDER attribute

HTML client only: arbitrary zOrder value that can be set by the application. When you read this value, the return value will be meaningless until you have set the value. Note: this can shake up your whole design and render your application unusable.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP P-SCHEDULER-TASK P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER P-LINK-BUTTON


Y attribute

The Y-position in pixels of the top widget border. The allegation is relative to the parent of the widget.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP P-SCHEDULER-TASK P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER P-LINK-BUTTON


X attribute

The X-position in pixels of the left widget border. The allegation is relative to the parent of the widget.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP P-SCHEDULER-TASK P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER P-LINK-BUTTON


WIDTH-PIXELS attribute

The width pixels of the widget. This is a read-only attribute. Please use the method SET-SIZE to change the widget size.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP P-SCHEDULER-TASK P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER P-LINK-BUTTON


VISIBLE attribute

Indicates whether the widget is currently visible on the display. But a field-level-widget must have a parent to be visible.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP P-SCHEDULER-TASK P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER P-LINK-BUTTON


SENSITIVE attribute

Indicates whether a widget is sensitive and can receive input focus or events.

Data type: | boolean
Default value: | true
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP P-SCHEDULER-TASK P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER P-LINK-BUTTON


OPAQUE attribute

If true the widget paints every pixel within its bounds. Otherwise, the widget may not paint some or all of its pixels, allowing the underlying pixels to show through.

Data type: | boolean
Default value: | \?
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP P-SCHEDULER-TASK P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER P-LINK-BUTTON


HEIGHT-PIXELS attribute

The height pixels of the widget. This is a read-only attribute. Please use the method SET-SIZE to change the widget size.

Data type: | integer
Default value: | 0
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP P-SCHEDULER-TASK P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER P-LINK-BUTTON


FONT attribute

The font of the widget.

Data type: | J-FONT
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP P-SCHEDULER-TASK P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER P-LINK-BUTTON


FOCUS attribute

Indicates whether the widget currently has the focus.

Data type: | boolean
Default value: | FALSE
Access: | Readable
Applies to: | P-TASKPANEGROUP P-SCHEDULER-TASK P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER P-LINK-BUTTON


FGCOLOR attribute

The foreground color of the widget.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP P-SCHEDULER-TASK P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER P-LINK-BUTTON


CURSOR attribute

A bitmap representation of the cursor shown if the mouse pointer is over this widget.

Data type: | J-CURSOR
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP P-SCHEDULER-TASK P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER P-LINK-BUTTON


CSS-CLASSES attribute

HTML client only: a list of css classes that are set for this widget. Note: this can shake up your whole design and render your application unusable.

Data type: | string
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP P-SCHEDULER-TASK P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER P-LINK-BUTTON


BGCOLOR attribute

The background color of the widget.

Data type: | J-COLOR
Access: | Readable / Writeable
Applies to: | P-TASKPANEGROUP P-SCHEDULER-TASK P-TABBED-PANE P-SPLIT-PANE P-RECTANGLE P-RADIO-SET P-BUTTON P-BROWSE P-TEXT P-FLEX-TEXT P-IMAGE P-FILL-IN P-SELECTION-LIST P-EDITOR P-COMBO-BOX P-TOGGLE-BOX P-DATE-PICKER P-TREE P-PROGRESS-BAR P-OUTLOOKBAR P-SHORTCUT-BAR P-TASKPANE P-SCHEDULER P-DOCKMAN P-CUSTOM-BROWSE P-RTF-EDITOR P-FILE-UPLOADER P-GRID P-WINDOW P-DIALOG P-TAB-FRAME P-FRAME P-WEB-BROWSER P-MDI-CONTAINER P-LINK-BUTTON


VALIDATE method

Applies to: P-TASKPANEGROUP
P-SCHEDULER-TASK
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-TAB-FRAME
P-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
P-LINK-BUTTON
Syntax:
oClass:VALIDATE(
      ).


SET-SIZE method

Resizes this component.

Applies to: P-TASKPANEGROUP
P-SCHEDULER-TASK
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-TAB-FRAME
P-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
P-LINK-BUTTON
Syntax:
oClass:SET-SIZE(
      WIDTH-PIXELS, HEIGHT-PIXELS).

Param | Data type | Description
WIDTH-PIXELS | integer | width pixels
HEIGHT-PIXELS | integer | height pixels


SET-LOCATION method

Moves this component to a new location. The top-left corner of the new location is specified by the x and y parameters in the coordinate space of this component's parent.

Applies to: P-TASKPANEGROUP
P-SCHEDULER-TASK
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-TAB-FRAME
P-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
P-LINK-BUTTON
Syntax:
oClass:SET-LOCATION(
      X-LOCATION, Y-LOCATION).

Param | Data type | Description
X-LOCATION | integer | x location
Y-LOCATION | integer | y location


REQUEST-FOCUS method

Requests that this Component get the input focus, and that this Component's top-level ancestor become the focused Window. This component must be displayable, visible, and focusable for the request to be granted. Every effort will be made to honor the request; however, in some cases it may be impossible to do so. Developers must never assume that this Component is the focus owner until this Component receives a ENTRY event.

Applies to: P-TASKPANEGROUP
P-SCHEDULER-TASK
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-TAB-FRAME
P-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
P-LINK-BUTTON
Syntax:
oClass:REQUEST-FOCUS(
      ).


A-ICON abstract class

A-ICON
extended by SC-OBJECT

Subclasses

J-CANVAS | J-COLOR-ICON
J-IMAGE-ICON |

Attributes

HEIGHT-PIXELS WIDTH-PIXELS
inherited from SC-OBJECT:
MODIFIED | NAME
PARENT | PRIVATE-DATA

Methods

Events


WIDTH-PIXELS attribute

Width pixels of the icon.

Data type: | integer
Default value: | 0
Access: | Readable
Applies to: | J-IMAGE-ICON J-COLOR-ICON J-CANVAS


HEIGHT-PIXELS attribute

Height pixels of the icon.

Data type: | integer
Default value: | 0
Access: | Readable
Applies to: | J-IMAGE-ICON J-COLOR-ICON J-CANVAS


Skin-Client Events

WINDOW-CLOSE event

Fired when user causes a keyboard or mouse action that causes the native window manager to close the affected window or dialog.

Affected Widgets: Parameters:
P-WINDOW
P-DIALOG


Skin-Client Events

VALUE-CHANGED event

Fired when user causes a keyboard or mouse action that changes a value of a widget.

Affected Widgets: Parameters:
P-DATE-PICKER
Affected Widgets: Parameters:
P-SPLIT-PANE
Affected Widgets: Parameters:
P-FILL-IN
P-EDITOR
Affected Widgets: Parameters:
P-SELECTION-LIST
P-CUSTOM-BROWSE
P-COMBO-BOX
P-BROWSE
Affected Widgets: Parameters:
P-TREE
KEY-LABEL | string | Key(s) pressed when VALUE-CHANGED occured as progress-like key-label
ORIGIN | string | The origin of the event. Possible values are: 'MOUSE', 'KEYBOARD' or blank
Affected Widgets: Parameters:
P-TOGGLE-BOX
P-RADIO-SET
Affected Widgets: Parameters:
P-BROWSE-COLUMN
ROW-ID | string
INPUT-VALUE | string
Affected Widgets: Parameters:
P-SCHEDULER-TASK
Affected Widgets: Parameters:
P-SCHEDULER
Affected Widgets: Parameters:
P-BAND
Affected Widgets: Parameters:
P-BAND-ITEM-FLIPFLOP
Affected Widgets: Parameters:
P-GRID
COLUMN | integer
ROW | integer
VALUE | string


Skin-Client Events

URL-LOADED event

This event will be fired when the content has been loaded

Affected Widgets: Parameters:
P-WEB-BROWSER


Skin-Client Events

TREE-EXPAND event

Fired whenever a node in the tree has been expanded.

Affected Widgets: Parameters:
P-TREE
NODE

Affected Widgets: Parameters:
P-TREE-NODE


Skin-Client Events

TREE-COLLAPSE event

Fired whenever a node in the tree has been expanded.

Affected Widgets: Parameters:
P-TREE
NODE

Affected Widgets: Parameters:
P-TREE-NODE


Skin-Client Events

TIMER event

Fired by a running timer after the specified time interval.

Affected Widgets: Parameters:
J-TIMER


Skin-Client Events

TAB-NUM-CHANGED event

Fired whenever the number of tabs has been changed (via methods ADD-TAB and REMOVE).

Affected Widgets: Parameters:
P-TABBED-PANE


Skin-Client Events

TAB-KEY event

Fired when a TAB key has been pressed.

Affected Widgets: Parameters:
SKIN-CLIENT
P-TASKPANEGROUP
P-SCHEDULER-TASK
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-FRAME
P-TAB-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
P-LINK-BUTTON


Skin-Client Events

TAB-CLOSE event

This event will be fired when the user clicked a cell using the left mouse-button

Affected Widgets: Parameters:
P-TABBED-PANE
TAB-FRAME |
TAB-INDEX | integer


Skin-Client Events

START-SEARCH event

Fired when left mouse button has been pressed on the label of the affected browse column. To get START-SEARCH events attribute START-SEARCH-ENABLE has to be TRUE.

Affected Widgets: Parameters:
P-BROWSE-COLUMN
STATE value-set


Skin-Client Events

START-MOVE event

Fired when left mouse button is pressed on a browse column and then dragged.

Affected Widgets: Parameters:
P-BROWSE-COLUMN


Skin-Client Events

SKIN-CLIENT-TIMEOUT event

Fired by Progress Object Controller when socket connection to the client is lost.

Affected Widgets: Parameters:
SKIN-CLIENT


Skin-Client Events

SKIN-CLIENT-RT-INFO event

This event can't be subscribed but you get sync messages if you have created the SKIN-CLIENT-RT-INFO object and one of it's attribute values has changed.

Affected Widgets: Parameters:
SKIN-CLIENT-RT-INFO


Skin-Client Events

SKIN-CLIENT-HEART-BEAT event

Fired by Progress Object Controller when the agent receives a heart-beat from the broker.

Affected Widgets: Parameters:
SKIN-CLIENT


Skin-Client Events

SKIN-CLIENT-CLOSE event

Fired by Progress Object Controller when Skin-Client is shutting down.

Affected Widgets: Parameters:
SKIN-CLIENT


Skin-Client Events

ROW-LEAVE event

Fired when user causes a keyboard or mouse action that removes selection to a row of the affected browse widget.

Affected Widgets: Parameters:
P-BROWSE
ROW-ID string


Skin-Client Events

ROW-LABEL-DBLCLICK event

This event will be fired when the user double-clicked a row label using the left mouse-button

Affected Widgets: Parameters:
P-SCHEDULER
ROW integer


Skin-Client Events

ROW-LABEL-CLICK event

This event will be fired when the user clicked a row label using the left mouse-button

Affected Widgets: Parameters:
P-SCHEDULER
ROW integer


Skin-Client Events

ROW-ENTRY event

Fired when user causes a keyboard or mouse action that sets selection to a row of the affected browse widget.

Affected Widgets: Parameters:
P-BROWSE
ROW-ID string


Skin-Client Events

ROW-DISPLAY event

Fired after the row of the affected browse widget is filled.

Affected Widgets: Parameters:
P-BROWSE
ROW-ID string

Example:

PROCEDURE ON_ROW-DISPLAY_OF_MyBrowse:
  DEFINE INPUT PARAMETER cArgs AS CHARACTER NO-UNDO.
END PROCEDURE.


Skin-Client Events

RIGHT-MOUSE-DOWN event

Fired when right mouse button has been pressed.

Affected Widgets: Parameters:
SKIN-CLIENT
X | integer | X position relative to the event source component
Y | integer | Y position relative to the event source component
ALT | boolean | indicates if ALT-key is pressed
CTRL | boolean | indicates if CTRL-key is pressed
SHIFT | boolean | indicates if SHIFT-key is pressed
P-TASKPANEGROUP
P-SCHEDULER-TASK
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-FRAME
P-TAB-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
P-LINK-BUTTON
X | integer | X position relative to the event source component
Y | integer | Y position relative to the event source component
ALT | boolean | indicates if ALT-key is pressed
CTRL | boolean | indicates if CTRL-key is pressed
SHIFT | boolean | indicates if SHIFT-key is pressed


Skin-Client Events

RIGHT-MOUSE-CLICK event

Fired when right mouse button has pressed and released.

Affected Widgets: Parameters:
SKIN-CLIENT
X | integer | X position relative to the event source component
Y | integer | Y position relative to the event source component
ALT | boolean | indicates if ALT-key is pressed
CTRL | boolean | indicates if CTRL-key is pressed
SHIFT | boolean | indicates if SHIFT-key is pressed
P-TASKPANEGROUP
P-SCHEDULER-TASK
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-FRAME
P-TAB-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
P-LINK-BUTTON
X | integer | X position relative to the event source component
Y | integer | Y position relative to the event source component
ALT | boolean | indicates if ALT-key is pressed
CTRL | boolean | indicates if CTRL-key is pressed
SHIFT | boolean | indicates if SHIFT-key is pressed


Skin-Client Events

RESIZED event

Fired when a widget has been resized.

Affected Widgets: Parameters:
P-BROWSE-COLUMN
Affected Widgets: Parameters:
P-TASKPANEGROUP
P-SCHEDULER-TASK
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-FRAME
P-TAB-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
P-LINK-BUTTON
Affected Widgets: Parameters:
P-WINDOW
P-DIALOG
Affected Widgets: Parameters:
P-SCHEDULER-TASK


Skin-Client Events

PAGE-UP-KEY event

Fired when PAGE UP key has been pressed.

Affected Widgets: Parameters:
SKIN-CLIENT
P-TASKPANEGROUP
P-SCHEDULER-TASK
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-FRAME
P-TAB-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
P-LINK-BUTTON


Skin-Client Events

PAGE-DOWN-KEY event

Fired when PAGE DOWN key has been pressed.

Affected Widgets: Parameters:
SKIN-CLIENT
P-TASKPANEGROUP
P-SCHEDULER-TASK
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-FRAME
P-TAB-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
P-LINK-BUTTON


Skin-Client Events

OFF-HOME event

Fired when user tries to move before the first row of a browse.

Affected Widgets: Parameters:
P-CUSTOM-BROWSE
SOURCE-EVENT string

P-BROWSE
SOURCE-EVENT string


Skin-Client Events

OFF-END event

Fired when user tries to move after the last row of a browse.

Affected Widgets: Parameters:
P-CUSTOM-BROWSE
SOURCE-EVENT string

P-BROWSE
SOURCE-EVENT string


Skin-Client Events

NEXT-COLUMN-CHANGED event

Fired when value of attribute NEXT-COLUMN has changed.

Affected Widgets: Parameters:
P-BROWSE-COLUMN


Skin-Client Events

MOVED event

Fired when a widget has been moved.

Affected Widgets: Parameters:
P-TASKPANEGROUP
P-SCHEDULER-TASK
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-FRAME
P-TAB-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
P-LINK-BUTTON
Affected Widgets: Parameters:
P-SCHEDULER-TASK


Skin-Client Events

MOUSE-EXITED event

Fired when the mouse cursor exits a widget.

Affected Widgets: Parameters:
SKIN-CLIENT
P-TASKPANEGROUP
P-SCHEDULER-TASK
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-FRAME
P-TAB-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
P-LINK-BUTTON


Skin-Client Events

MOUSE-ENTERED event

Fired when the mouse cursor enters a widget.

Affected Widgets: Parameters:
SKIN-CLIENT
P-TASKPANEGROUP
P-SCHEDULER-TASK
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-FRAME
P-TAB-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
P-LINK-BUTTON


Skin-Client Events

MIDDLE-MOUSE-DOWN event

Fired when middle mouse button has been pressed.

Affected Widgets: Parameters:
SKIN-CLIENT
X | integer | X position relative to the event source component
Y | integer | Y position relative to the event source component
ALT | boolean | indicates if ALT-key is pressed
CTRL | boolean | indicates if CTRL-key is pressed
SHIFT | boolean | indicates if SHIFT-key is pressed
P-TASKPANEGROUP
P-SCHEDULER-TASK
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-FRAME
P-TAB-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
P-LINK-BUTTON
X | integer | X position relative to the event source component
Y | integer | Y position relative to the event source component
ALT | boolean | indicates if ALT-key is pressed
CTRL | boolean | indicates if CTRL-key is pressed
SHIFT | boolean | indicates if SHIFT-key is pressed


Skin-Client Events

LEFT-MOUSE-DOWN event

Fired when left mouse button has been pressed.

Affected Widgets: Parameters:
SKIN-CLIENT
X | integer | X position relative to the event source component
Y | integer | Y position relative to the event source component
ALT | boolean | indicates if ALT-key is pressed
CTRL | boolean | indicates if CTRL-key is pressed
SHIFT | boolean | indicates if SHIFT-key is pressed
P-TASKPANEGROUP
P-SCHEDULER-TASK
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-FRAME
P-TAB-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
P-LINK-BUTTON
X | integer | X position relative to the event source component
Y | integer | Y position relative to the event source component
ALT | boolean | indicates if ALT-key is pressed
CTRL | boolean | indicates if CTRL-key is pressed
SHIFT | boolean | indicates if SHIFT-key is pressed


Skin-Client Events

LEFT-MOUSE-DBLCLICK event

Fired when left mouse button has pressed and released twice.

Affected Widgets: Parameters:
SKIN-CLIENT
X | integer | X position relative to the event source component
Y | integer | Y position relative to the event source component
ALT | boolean | indicates if ALT-key is pressed
CTRL | boolean | indicates if CTRL-key is pressed
SHIFT | boolean | indicates if SHIFT-key is pressed
P-TASKPANEGROUP
P-SCHEDULER-TASK
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-FRAME
P-TAB-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
P-LINK-BUTTON
X | integer | X position relative to the event source component
Y | integer | Y position relative to the event source component
ALT | boolean | indicates if ALT-key is pressed
CTRL | boolean | indicates if CTRL-key is pressed
SHIFT | boolean | indicates if SHIFT-key is pressed
Affected Widgets: Parameters:
P-TABBED-PANE
X | integer | X position relative to the event source component
Y | integer | Y position relative to the event source component
ALT | boolean | indicates if ALT-key is pressed
CTRL | boolean | indicates if CTRL-key is pressed
SHIFT | boolean | indicates if SHIFT-key is pressed


Skin-Client Events

LEFT-MOUSE-CLICK event

Fired when left mouse button has pressed and released.

Affected Widgets: Parameters:
SKIN-CLIENT
X | integer | X position relative to the event source component
Y | integer | Y position relative to the event source component
ALT | boolean | indicates if ALT-key is pressed
CTRL | boolean | indicates if CTRL-key is pressed
SHIFT | boolean | indicates if SHIFT-key is pressed
P-TASKPANEGROUP
P-SCHEDULER-TASK
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-FRAME
P-TAB-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
P-LINK-BUTTON
X | integer | X position relative to the event source component
Y | integer | Y position relative to the event source component
ALT | boolean | indicates if ALT-key is pressed
CTRL | boolean | indicates if CTRL-key is pressed
SHIFT | boolean | indicates if SHIFT-key is pressed


Skin-Client Events

LEAVE event

Fired when user causes a keyboard or mouse action that takes focus from the widget.

Affected Widgets: Parameters:
SKIN-CLIENT
P-FRAME
P-TAB-FRAME
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
Affected Widgets: Parameters:
P-WINDOW
P-DIALOG
Affected Widgets: Parameters:
P-BROWSE


Skin-Client Events

JS-MESSAGE event

This event will be fired when method postJSMessage has been invoked by javascript-code

Affected Widgets: Parameters:
SKIN-CLIENT
MESSAGE string

P-WEB-BROWSER
MESSAGE string

JS-CUSTOM
MESSAGE string


Skin-Client Events

INSERT-KEY event

Fired when INSERT key has been pressed.

Affected Widgets: Parameters:
SKIN-CLIENT
P-TASKPANEGROUP
P-SCHEDULER-TASK
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-FRAME
P-TAB-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
P-LINK-BUTTON


Skin-Client Events

INNER-HEIGHT-CHANGED event

Fired when the inner height of the tabbed pane changes, when tabs are added or removed or when the width of the tabbed-pane is changed

Affected Widgets: Parameters:
P-TABBED-PANE


Skin-Client Events

FIRST-COLUMN-CHANGED event

Fired when value of attribute FIRST-COLUMN has changed.

Affected Widgets: Parameters:
P-BROWSE


Skin-Client Events

FILE-UPLOADED event

This event is fired when the P-FILE-UPLOADER finished uploading a file

Affected Widgets: Parameters:
P-FILE-UPLOADER
FILE-NAME | string
FILE-CONTENTS | string


Skin-Client Events

ESCAPE-KEY event

Fired when ESCAPE key has been pressed.

Affected Widgets: Parameters:
SKIN-CLIENT
P-TASKPANEGROUP
P-SCHEDULER-TASK
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-FRAME
P-TAB-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
P-LINK-BUTTON


Skin-Client Events

ENTRY event

Fired when user causes a keyboard or mouse action that gives focus to the widget.

Affected Widgets: Parameters:
SKIN-CLIENT
P-FRAME
P-TAB-FRAME
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
Affected Widgets: Parameters:
P-WINDOW
P-DIALOG
Affected Widgets: Parameters:
P-BROWSE


Skin-Client Events

ENTER-KEY event

Fired when ENTER key has been pressed.

Affected Widgets: Parameters:
SKIN-CLIENT
P-TASKPANEGROUP
P-SCHEDULER-TASK
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-FRAME
P-TAB-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
P-LINK-BUTTON


Skin-Client Events

END-SEARCH event

Fired when a START-SEARCH event has been applied.

Affected Widgets: Parameters:
P-BROWSE-COLUMN


Skin-Client Events

END-RESIZE event

Fired when the pressed left mouse button release after resizing.

Affected Widgets: Parameters:
P-BROWSE-COLUMN
Affected Widgets: Parameters:
P-SCHEDULER-TASK


Skin-Client Events

END-MOVE event

Fired when the pressed left mouse button release after moving.

Affected Widgets: Parameters:
P-BROWSE-COLUMN
Affected Widgets: Parameters:
P-SCHEDULER-TASK


Skin-Client Events

DROP-NOTIFY event

A mouse action that completes a drag-and-drop operation on a widget.

Affected Widgets: Parameters:
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-FRAME
P-TAB-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
ACTION | value-set |
X | integer | X position of the mouse pointer.
Y | integer | Y position of the mouse pointer.
FLAVOR | value-set |
DATA | string | A string in the drag-and-drop operation performed on a widget.


Skin-Client Events

DRAG-OVER event

Fired whenever a drag and drop operation is in progress.

Affected Widgets: Parameters:
P-TREE
NODE


Skin-Client Events

DRAG-NOTIFY event

A mouse action that starts a drag-and-drop operation on a widget.

Affected Widgets: Parameters:
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-FRAME
P-TAB-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
ACTION | value-set |
X | integer | X position of the mouse pointer.
Y | integer | Y position of the mouse pointer.


Skin-Client Events

DOCKFRAME-SPECIAL-CHOOSE event

This event will be fired when a dock-frames special-button was choosen

Affected Widgets: Parameters:
P-DOCKFRAME
BUTTON-KEY string


Skin-Client Events

DOCKFRAME-CLOSING event

This event will be fired when the user tries to close a dock-frame

Affected Widgets: Parameters:
P-DOCKFRAME


Skin-Client Events

DOCKFRAME-CLOSED event

This event will be fired when a dock-frame was closed

Affected Widgets: Parameters:
P-DOCKFRAME


Skin-Client Events

DOCKFRAME-ACTIVE event

This event will be fired when a dock-frame was activated or deactivated

Affected Widgets: Parameters:
P-DOCKFRAME


Skin-Client Events

DELETE-KEY event

Fired when DELETE key has been pressed.

Affected Widgets: Parameters:
SKIN-CLIENT
P-TASKPANEGROUP
P-SCHEDULER-TASK
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-FRAME
P-TAB-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
P-LINK-BUTTON


Skin-Client Events

CONSOLE-OUTPUT event

When Skin-Client write to the console this event will be fired.

Affected Widgets: Parameters:
SKIN-CLIENT
LEV | value-set
MSG | string


Skin-Client Events

COLUMN-SELECTION-CHANGED event

This event will be fired when the user selects or deselect one or more column

Affected Widgets: Parameters:
P-BROWSE


Skin-Client Events

COLUMN-LEAVE event

Fired when user causes a keyboard or mouse action that removes selection to a cell of the affected column.

Affected Widgets: Parameters:
P-BROWSE-COLUMN


Skin-Client Events

COLUMN-ENTRY event

Fired when user causes a keyboard or mouse action that sets selection to a cell of the affected column.

Affected Widgets: Parameters:
P-BROWSE-COLUMN


Skin-Client Events

COL-LABEL-DBLCLICK event

This event will be fired when the user double-clicked a column label using the left mouse-button

Affected Widgets: Parameters:
P-SCHEDULER
COL integer


Skin-Client Events

COL-LABEL-CLICK event

This event will be fired when the user clicked a column label using the left mouse-button

Affected Widgets: Parameters:
P-SCHEDULER
COL integer


Skin-Client Events

CHOOSE event

Fired whenever user causes a keyboard or mouse action that chooses a widget.

Affected Widgets: Parameters:
P-MENU-ITEM
P-TOGGLE-BOX-MENU-ITEM
P-MENU
P-BUTTON
P-BROWSE-COLUMN
P-TOGGLE-BOX-MENU-ITEM
Affected Widgets: Parameters:
P-TABBED-PANE
Affected Widgets: Parameters:
P-SHORTCUT-BAR
Affected Widgets: Parameters:
P-EDITOR
LINK-URL string

Affected Widgets: Parameters:
P-BAND
ITEM-KEY string

Affected Widgets: Parameters:
P-BAND-ITEM
P-BAND-ITEM-POPUP
P-BAND-ITEM-FLIPFLOP
Affected Widgets: Parameters:
P-GRID


Skin-Client Events

CELL-MOUSE-EXITED event

Fired when the mouse cursor exits a P-Browse cell.

Affected Widgets: Parameters:
P-BROWSE-COLUMN
X | integer | mouse cursors X position relative to the event source component
Y | integer | mouse cursors Y position relative to the event source component
ALT | boolean | indicates if ALT-key is pressed
CTRL | boolean | indicates if CTRL-key is pressed
SHIFT | boolean | indicates if SHIFT-key is pressed
CELL-X | integer | cells X position relative to the event source component
CELL-Y | integer | cells Y position relative to the event source component
CELL-WIDTH | integer | cell width
CELL-HEIGHT | integer | cell height
ROW-ID | string | row id of the cell
BROWSE-COLUMN |  | The cells P-Browse-Column


Skin-Client Events

CELL-MOUSE-ENTERED event

Fired when the mouse cursor enters a P-Browse cell.

Affected Widgets: Parameters:
P-BROWSE-COLUMN
X | integer | mouse cursors X position relative to the event source component
Y | integer | mouse cursors Y position relative to the event source component
ALT | boolean | indicates if ALT-key is pressed
CTRL | boolean | indicates if CTRL-key is pressed
SHIFT | boolean | indicates if SHIFT-key is pressed
CELL-X | integer | cells X position relative to the event source component
CELL-Y | integer | cells Y position relative to the event source component
CELL-WIDTH | integer | cell width
CELL-HEIGHT | integer | cell height
ROW-ID | string | row id of the cell
BROWSE-COLUMN |  | The cells P-Browse-Column


Skin-Client Events

CELL-DBLCLICK event

This event will be fired when the user double-clicked a cell using the left mouse-button

Affected Widgets: Parameters:
P-SCHEDULER
COL | integer
ROW | integer


Skin-Client Events

CELL-CLICK event

This event will be fired when the user clicked a cell using the left mouse-button

Affected Widgets: Parameters:
P-SCHEDULER
COL | integer
ROW | integer


Skin-Client Events

CARET-MOVED event

Fired when caret in RTF editor was moved.

Affected Widgets: Parameters:
P-EDITOR
DOT | integer | Fetches the location of the caret.
MARK | integer | Fetches the location of other end of a selection.
ATTRIBUTES | string |


Skin-Client Events

BACK-TAB-KEY event

Fired when SHIFT+TAB key has been pressed.

Affected Widgets: Parameters:
SKIN-CLIENT
P-TASKPANEGROUP
P-SCHEDULER-TASK
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-FRAME
P-TAB-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
P-LINK-BUTTON


Skin-Client Events

ANY-KEY event

Fired when a key has been pressed.

Affected Widgets: Parameters:
SKIN-CLIENT
KEY | integer | The key-code of the pressed key
MODIFIERS | value-set | Returns a String describing the modifier key(s), such as 'Shift', or 'Ctrl+Shift'
KEY-LABEL | string | The progress-like key-label
P-MENU-ITEM
P-TOGGLE-BOX-MENU-ITEM
KEY | integer | The key-code of the pressed key
MODIFIERS | value-set | Returns a String describing the modifier key(s), such as 'Shift', or 'Ctrl+Shift'
KEY-LABEL | string | The progress-like key-label
P-MENU
KEY | integer | The key-code of the pressed key
MODIFIERS | value-set | Returns a String describing the modifier key(s), such as 'Shift', or 'Ctrl+Shift'
KEY-LABEL | string | The progress-like key-label
P-TASKPANEGROUP
P-SCHEDULER-TASK
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-FRAME
P-TAB-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
P-LINK-BUTTON
KEY | integer | The key-code of the pressed key
MODIFIERS | value-set | Returns a String describing the modifier key(s), such as 'Shift', or 'Ctrl+Shift'
KEY-LABEL | string | The progress-like key-label
Affected Widgets: Parameters:
SKIN-CLIENT
KEY | integer | The key-code of the pressed key
KEY-LABEL | string | The progress-like key-label
P-MENU-ITEM
P-TOGGLE-BOX-MENU-ITEM
KEY | integer | The key-code of the pressed key
KEY-LABEL | string | The progress-like key-label
P-MENU
KEY | integer | The key-code of the pressed key
KEY-LABEL | string | The progress-like key-label
P-TASKPANEGROUP
P-SCHEDULER-TASK
P-TABBED-PANE
P-SPLIT-PANE
P-RECTANGLE
P-RADIO-SET
P-BUTTON
P-BROWSE
P-TEXT
P-FLEX-TEXT
P-IMAGE
P-FILL-IN
P-SELECTION-LIST
P-EDITOR
P-COMBO-BOX
P-TOGGLE-BOX
P-DATE-PICKER
P-TREE
P-PROGRESS-BAR
P-OUTLOOKBAR
P-SHORTCUT-BAR
P-TASKPANE
P-SCHEDULER
P-DOCKMAN
P-CUSTOM-BROWSE
P-RTF-EDITOR
P-FILE-UPLOADER
P-GRID
P-WINDOW
P-DIALOG
P-FRAME
P-TAB-FRAME
P-WEB-BROWSER
P-MDI-CONTAINER
P-LINK-BUTTON
KEY | integer | The key-code of the pressed key
KEY-LABEL | string | The progress-like key-label